<?php 
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
// script : filebrowser.php
// author : odu
//-------------------------------------------------------------------------------------------------
// directorybrowser for setup
//-------------------------------------------------------------------------------------------------
// 01.12.2003 - start
// 31.12.2003 - comments (odu)
// 050307 ................. brause - get users jetzt immer in const.inc aufgerufen
// 050508 ................. brause - nur noch design.inc wird included (der rest kommt von design.inc)
// 051026 ................. brause - CHANGE: nicht Festplattenlaufwerke werden wieder erkannt
//                                          hatte ich mit v22 rausgenommen, so funktionieren auch cds wieder
//                                 - NEW: bergibt auch defaultnamen fr Bezeichnung (oxyl_file)
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
  //------> standard includes

  include_once('design.inc');

  //------> header

  gen_header_setup();
  gen_title_setup('',trans('','title_filebrowser'));

  //------> check for recommended parameters

  if (! isset($txt)) $txt=trans('','fb_pselect');
  if (! isset($field))
  {
    $txt=trans('','fb_wrongc');
    $field='';
  }
  elseif(substr($field,0,3)=='PA_')
    $field2="NA_".substr($field,3);


  if (! isset($mo)) $mo='dir';
  if (! isset($start)) $start='';

  //------> if no path is set display root or all availible drives

  $dirs = array();
  if (strlen($start)<1)
  {
    $start = $dir = '';
    if ($GLOBALS['system']=='windows')
    {
      for($i=3;$i<=26;$i++)
      {
	    if (is_dir(chr($i+64).':/')) // damit werden alle laufwerke unter windows erkannt
      	//if (is_dir(chr($i+64).':/') && @dir(chr($i+64).':/') !='') //damit werden nur fesplattenlaufwerke erkannt
      	  $dirs[]=chr($i+64).':';
      }
    }
    else
      $dirs[]='/';
  }
  else
  {
    $dirs=getdirs($start);
	$dir = basename($start);
  }

  //------> prepare table
  
  echo '<table cellspacing="10" width="100%"><tr><td>';
  echo '<b>'.trans('','attention').'</b>: '.$txt.'<br><br>';
  echo '<b>'.trans('','fb_selection').'</b>: '.$start;
  if (! isset($demo))
  {
     if (($GLOBALS['system']=='windows') && (strlen($start)==3)) $start = substr($start,0,2);
     echo '&nbsp;&nbsp;<a href="javascript:opener.document.forms[0].'.$field.'.value=\''.$start.'\';'
	                                     .(isset($field2) ? 'opener.document.forms[0].'.$field2.'.value=\''.$dir.'\';' :'')
	                                     .'window.close();">'.trans('','confirm').'</a>';
  }
  echo '</td></tr></table>';
  echo '<hr color="#000000">';
  echo '<table cellspacing="10" width="100%"><tr><td>';
  $backstart=dir_name($start);

  //------> try to compensate quote problems
  
  if (strlen($start)>0)
  {
    if (($GLOBALS['system']=='windows') && (strlen($backstart)==2)) $backstart .= '/';
    if (($GLOBALS['system']=='windows') && (strlen($start)==2)) $backstart = '';
    if (($GLOBALS['system']=='windows') && (strlen($start)==3)) $backstart = '';
    if (($backstart=='.')) $backstart = '';
    echo '<a href="filebrowser.php?start='.urlencode($backstart).'&field='.$field.'&mo='.$mo.
           '&txt='.urlencode($txt).'">... '.trans('','back').'</a><br>';
    if ( (strlen($start)>=2)) $start .= '/';
  }
  
  //------> show directories
  
  reset($dirs);
  foreach($dirs as $dir)
  {
    if (! isset($demo))
      echo '<a href="filebrowser.php?start='.urlencode($start.$dir).'&field='.
            $field.'&mo='.$mo.'&txt='.urlencode($txt).'">'.$dir.'</a><br>';
    else
      echo $dir.'<br>';
  }
  echo '</td></tr></table>';
  
  //------> pag end
  
  gen_end();
?>
