<?php
//###################################### Oxyl~Box 2.0.24 #######################################
//+-------------------------------------------------------------------------------------------
//| kernel:  ir_layout.inc
//| author : brause
//+-------------------------------------------------------------------------------------------
//| provide different Hardware ir keys and Icons
//--------------------------------------------------------------------------------------------
//| 050328 ...... Brause   - ir_layout.inc erstellt
//| 050610 ...... Brause   - NEW: codes fr Showcenter 200 hinzu
//|                        - CHANGE: codes fr Transgear
//| 050731 ...... Brause   - $GLOBALS['sys_tvid_key'] hinzu
//+-------------------------------------------------------------------------------------------

$GLOBALS['sys_tvid_key'] = array(997,998,999); // welche TV IDs fr das System reserviert sind

switch($GLOBALS['brand']){ // welche IR Tasten verwendet werden sollen
      case "PIN":  $IR_LAYOUT = 1; break; // Pinnacle Showcenter
      case "PC":   $IR_LAYOUT = 1; break; // PC
      case "LTI":  $IR_LAYOUT = 2; break; // Transgear DVX 500
      case "DLT":  $IR_LAYOUT = 2; break; // Transgear DVX 700
      case "NST":  $IR_LAYOUT = 3; break; // Neuston
      case "EGT":  $IR_LAYOUT = 3; break; // Elegato
//    case "SYB":  $IR_LAYOUT = 1; break; // Auvisio Digital Media Box
//    case "ADS":  $IR_LAYOUT = 1; break; // ADS ???
	  default:     $IR_LAYOUT = 1;        // default alle unbekannnten
}

if    ($IR_LAYOUT == 1){// Button and Icons for PIN (Showcenter), PC and default 
  if($GLOBALS['model']=='Pinnacle Showcenter 200'){
    define('IR_TVID_MUSIC',  'MUSI');
    define('IR_TVID_MOVIE',  'MOVI');
    define('IR_TVID_PHOTO',  'PHOT');
    define('IR_TVID_KEYA',   'A');
    define('IR_TVID_KEYB',   'B');
    define('IR_TVID_KEYC',   'C');
  }
  else{
    define('IR_TVID_MUSIC',  'MUSIC');
    define('IR_TVID_MOVIE',  'MOVIE');
    define('IR_TVID_PHOTO',  'PHOTO');
    define('IR_TVID_KEYA',   'KEY_A');
    define('IR_TVID_KEYB',   'KEY_B');
    define('IR_TVID_KEYC',   'KEY_C');
  }
  define('IR_TVID_HOME',     'HOME');
  define('IR_TVID_HELP',     'HELP');
  define('IR_TVID_TAB',      'TAB');
  define('IR_TVID_PGUP',     'PGUP');
  define('IR_TVID_PGDN',     'PGDN');
  define('IR_TVID_OK',       'OK');
  define('IR_TVID_BACKSPACE','BACKSPACE');
  define('IR_TVID_DEL',      'DEL');
  define('IR_TVID_VOUT',     'VOUT');

  define('IR_ICON_KEYA',     'oxyl_nav_keya.gif');
  define('IR_ICON_KEYB',     'oxyl_nav_keyb.gif');
  define('IR_ICON_KEYC',     'oxyl_nav_keyc.gif');
  define('IR_ICON_HELP',     'oxyl_nav_keyhelp.gif');
  if($GLOBALS['brand']=='PIN'){
    define('IR_ICON_VOUT',     'oxyl_nav_vout.gif');
    define('IR_ICON_TAB',      'oxyl_nav_tab.gif');
  }
  else{
    define('IR_ICON_VOUT',     'pixel.gif');
    define('IR_ICON_TAB',      'pixel.gif');
  }
}
elseif($IR_LAYOUT == 2){// Button and Icons for LTI (Transgear)
  define('IR_TVID_MUSIC',     'MUSIC');
  define('IR_TVID_MOVIE',     'MOVIE');
  define('IR_TVID_PHOTO',     'PHOTO');
  define('IR_TVID_HOME',      'HOME');

  define('IR_TVID_KEYA',     'ESC');
  define('IR_TVID_KEYB',     'PLAY');
  define('IR_TVID_KEYC',     'PLAYPAUSE'); // noch nicht belegt
  define('IR_TVID_HELP',     'SEARCH');

  define('IR_TVID_TAB',      'TAB');       // noch nicht belegt
  define('IR_TVID_PGUP',     'PGUP');
  define('IR_TVID_PGDN',     'PGDN');
  define('IR_TVID_OK',       'OK');        // noch nicht belegt
  define('IR_TVID_BACKSPACE','BACK');
  define('IR_TVID_DEL',      'DEL');       // noch nicht belegt
  define('IR_TVID_VOUT',     'VOUT');      // noch nicht belegt

  define('IR_ICON_KEYA',     'oxyl_nav_keystop.gif');
  define('IR_ICON_KEYB',     'oxyl_nav_keyplay.gif');
  define('IR_ICON_KEYC',     'pixel.gif'); //oxyl_nav_keystep.gif
  define('IR_ICON_HELP',     'oxyl_nav_keysearch.gif');
  define('IR_ICON_VOUT',     'pixel.gif');
  define('IR_ICON_TAB',      'pixel.gif');
}
elseif ($IR_LAYOUT == 3){// Button and Icons for EGT, NST
  define('IR_TVID_MUSIC',     'MUSIC');
  define('IR_TVID_MOVIE',     'MOVIE');
  define('IR_TVID_PHOTO',     'PHOTO');
  define('IR_TVID_HOME',      'HOME');

  define('IR_TVID_KEYA',     'red');
  define('IR_TVID_KEYB',     'green');
  define('IR_TVID_KEYC',     'yellow');
  define('IR_TVID_HELP',     'blue');

  define('IR_TVID_TAB',      'TAB');       // belegt ???
  define('IR_TVID_PGUP',     'PGUP');      // belegt ???
  define('IR_TVID_PGDN',     'PGDN');      // belegt ???
  define('IR_TVID_OK',       'OK');        // belegt ???
  define('IR_TVID_BACKSPACE','BACKSPACE'); // belegt ???
  define('IR_TVID_DEL',      'DEL');       // belegt ???
  define('IR_TVID_VOUT',     'VOUT');      // belegt ???

  define('IR_ICON_KEYA',     'oxyl_nav_keyred.gif');
  define('IR_ICON_KEYB',     'oxyl_nav_keygreen.gif');
  define('IR_ICON_KEYC',     'oxyl_nav_keyyellow.gif');
  define('IR_ICON_HELP',     'oxyl_nav_keyblue.gif');
  define('IR_ICON_VOUT',     'pixel.gif');
  define('IR_ICON_TAB',      'pixel.gif');
}
?>
