<?php
//###################################### Oxyl~Box 2.5.0 #####################################################
//+-------------------------------------------------------------------------------------------
//| plugin: Universal Browser
//| author : Brause
//+-------------------------------------------------------------------------------------------
//| plays supported files
//+-------------------------------------------------------------------------------------------
//| 050312 ........ Brause      - Plugin neu erstellt (erstellt aus oxyl_pic, oxyl_video und oxyl_mp3)
//|                             - Multiusersupport hinzu
//|                             - sortierung nach gre, zeit und name hinzu
//| 050829 ........ Brause      - Final Release
//| 050918 ........ Brause      - NEW: Sortierung auch bei Ordnern
//| 051016 ........ Brause      - NEW: utf8_Decodierung wenn notwendig
//|                             - NEW: ABC Navigator fr Direktzugriff per Anfangsbuchstaben
//|                             - FIX: wenn Playlist aus, strzt SC ab
//|                             - FIX: falsche Seitenzahlberechnung
//|                             - FIX: History funktionierte nicht mehr (beim zurckblttern)
//| 051028 ........ Brause      - FIX: Backbutton und Netzlaufwerkeprobs
//| 060225 ........ Brause      - NEW: filterung nach lastpos files Thx to Buda
//|                                    - Filterung ber Setup
//|                                    - umschalten zwischen 0 und 99% ber Klick auf % Zahl
//+-------------------------------------------------------------------------------------------

  include_once('../../common/design.inc');

  $pluginname   = 'oxyl_file';

//********************************************************************************************  
//* default Werte setzen
//********************************************************************************************  

  if(!isset($mode))   $mode   = 'file';
  if(!isset($mode_1)) $mode_1 = 'file';
  //vereinfachung so ist der auswertungsaufwand kleiner -> icons etc.
  if    ($mode  =="mp3")      $mode_1='mp3';
  elseif($mode  =="video")    $mode_1='video';
  elseif($mode  =="pic")      $mode_1='pic';

  if    ($mode_1=='mp3')     {$mode_2='audio'; $which = 1;}
  elseif($mode_1=='video')   {$mode_2='video'; $which = 2;}
  elseif($mode_1=='pic')     {$mode_2='image'; $which = 4;}
  else                       {$mode_2='file';  $which = 7;}

  //------ config einlesen
  if(file_exists(OXYL_CONF.'plugins_oxyl_'.$mode.'_disp.inc'))
    include_once(OXYL_CONF.'plugins_oxyl_'.$mode.'_disp.inc');


  if(!isset($dispspec))        $dispspec           =0;
  if(!isset($view_progressbar))$view_progressbar   =1;
  if(!isset($dispext))         $dispext            =0;
  if(!isset($abc_navigator))   $abc_navigator      =1;
  if(!isset($view_textfile))   $view_textfile      =1;
  if(!isset($dotr_from))       $dotr_from          =0;
  if(!isset($view_all_files))  $view_all_files     =0;
  if(!isset($play_all))        $play_all           =1;
  if(!isset($no_winampplaylist)) $no_winampplaylist  =0;
  if(!isset($OFDb))            $OFDb  =0;
  if(!isset($def_play_mod))    $def_play_mod       ='PLAY';
  if(!isset($def_view_mod))    $def_view_mod       ='LIST';
  if(!isset($def_sort_mod))    $def_sort_mod       ='NAME';
  if(!isset($dir_sort_mod))    $dir_sort_mod       =1;
  if(!isset($view_sort_add))   $view_sort_add      =0;
  if(!isset($pic_back))        $pic_back           =0;
  if(!isset($enlarge_th))      $enlarge_th         =0;
  if(!isset($disp_thumb))      $disp_thumb         =1;
  if(!isset($cover_play_mod))  $cover_play_mod     =1;
  if(!isset($enlarge_md))      $enlarge_md         =0;
  if(!isset($hiddenfiles_mod)) $hiddenfiles_mod    =0;
  if(!isset($plmod))           $plmod=$def_play_mod;
  if(!isset($view))            $view =$def_view_mod;
  if(!isset($sort))            $sort =$def_sort_mod;

  $dot_arr = array('r','m','l');
  $dot_mod = $dot_arr[$dotr_from];

  if(!isset($disp_th_w))  $disp_th_w = $GLOBALS['thumb_width'];
  if(!isset($disp_th_h))  $disp_th_h = $GLOBALS['thumb_height'];
  if(!isset($disp_md_w))  $disp_md_w = $GLOBALS['med_width'];
  if(!isset($disp_md_h))  $disp_md_h = $GLOBALS['med_height'];

  $cols  = floor( LAYOUT_TABLE_WIDTH /$disp_th_w);
  $rows  = floor((LAYOUT_BODY_HEIGHT-LAYOUT_NAVI_HEIGHT-10)/($disp_th_h+2+5+21));
  $linex = ICON_SMALL_HEIGHT > 28 ? ICON_SMALL_HEIGHT : 28;
  $line  = floor((LAYOUT_BODY_HEIGHT-LAYOUT_NAVI_HEIGHT-20)/($linex+4));

  $celle    = floor((LAYOUT_TABLE_WIDTH -$cols*($disp_th_w+1))/$cols);
  $left_td  = ceil ($celle/2);
  $right_td = floor($celle/2);

  $maxlines   = $view=='LIST' ? $line : $cols*$rows;
  $max_chars  = $view=='LIST' ? $GLOBALS["maxchars"] : floor($GLOBALS["maxchars"]/$cols);
  $max_chars_md = ceil((1-($disp_md_w+5)/LAYOUT_TABLE_WIDTH)*$GLOBALS["maxchars"]);

  if (! isset($ap))   $ap='';       //(AKTIVER PFAD)
  if (! isset($fo))   $fo=' ';
  if (! isset($count))$count=0;
  if (! isset($le))   $le='';
  if (! isset($st))   $st=0;        //(SEITE) st gibt die aktuell seite an - wird auf eine tiefere ebene gewechselt wird der wert his angehngt (mit ~ als trennzeichen)
  if (! isset($his))  $his=0;       //(HISTORY) his gibt den seitenverlauf an                         //wenn keine werte fr his & st bergeben wurden diese auf standardwerte setzen

  $pics = $pics2 = $allfiles = $dirpics = $inhalt = array();
  $temp_view = '';

  // falls Zeichenkette codiert wurde
  $ap = oxyl_decode($ap);

//********************************************************************************************  
//* Playlist fr Hintergrundmusik auslesen
//********************************************************************************************  
if($mode_1=='pic'||$mode_1=='mp3'){
  if (file_exists(OXYL_CONF.'plugins_oxyl_'.$mode_1.'_dias.cfg'))
  {
    $diaoptions    = file(OXYL_CONF.'plugins_oxyl_'.$mode_1.'_dias.cfg');
    $timer         = trim($diaoptions[0]);
    $wipe          = trim($diaoptions[1]);
    $playlist      = trim($diaoptions[2]);
    $showtit       = trim($diaoptions[3]);
    $showsetup     = trim($diaoptions[4]);
    $showsound     = trim($diaoptions[5]);
  }
  else
  {
    $var  = '3'. "\r\n";
    $var .= '0'. "\r\n";
    $var .= 'MUTE'. "\r\n";
    $var .= 'ON'. "\r\n";
    $var .= 'ON'. "\r\n";
    $var .= 'ON'. "\r\n";
    create_file(OXYL_CONF.'plugins_oxyl_'.$mode_1.'_dias.cfg',$var);
  }

// Playlist pro Ordner
//--------------------------------------------
  if (file_exists(OXYL_CONF.'plugins_oxyl_'.$mode_1.'_diasdir.cfg'))
  {
    $dirplaylists=file(OXYL_CONF.'plugins_oxyl_'.$mode_1.'_diasdir.cfg');
    if($dirplaylists[0]=='')
	  @unlink(OXYL_CONF.'plugins_oxyl_'.$mode_1.'_diasdir.cfg');
	else
	{
	  foreach ($dirplaylists as $dirplaylist)
      {
        if (substr($dirplaylist,0,strpos($dirplaylist,'|'))==$ap)
        {
       	  $optarr = array();
      	  $optarr = explode('|',$dirplaylist);
          $showtit  = trim($optarr[1]);
          $timer    = trim($optarr[2]);
          $wipe     = trim($optarr[3]);
          $playlist = trim($optarr[4]);
        }
	  }
    }
  }

//--- Wiedergabeliste fr Hintergrundmusik aus Konfigdatei auslesen
  if(strlen($playlist)<4 or $playlist=='MUTE')  //wenn noch keine definiert dann nichts abspielen
    $playlist='MUTE';
  else //ansonsten
  { // user spezifische angelegte Playlist oder Playlist aus Verzeichnis
    $playlistpath = strpos($playlist,'~_')===0 ?
	                OXYL_TEMP.'user/user_'.str_replace('_','',str_replace('_Playlist_audio.pls','',substr($playlist,1))).'/'.substr($playlist,1) :
	                get_playlistpath().'/'.$playlist;

    $playlist= strlen($playlistpath)>2 ? 
	           OXYL_WEB.'/plugins/oxyl_file/oxyl_file_play.php?t=allpl&mode='.$mode.'&mode_1='.$mode_1.'&ap='.oxyl_encode($playlistpath) . '&playlist_mod=audio&post_port='.$GLOBALS['port'].'& ' : 'MUTE';
  }
}
//********************************************************************************************  
//* handle standardplaylist
//********************************************************************************************  
$pl=array();
$play_ls_user = $GLOBALS['actuser']!="" ? '_'.$GLOBALS['actuser']: '';
$pl_pfad = OXYL_TEMP.'user/user_'.$GLOBALS['actuser'].'/'.$play_ls_user.'_Playlist_'.$mode_2.'.pls';

//wenn im Wiedergabelistenpfad eine standard.pls existiert
$apl =file_exists($pl_pfad) ? file($pl_pfad) : array(); //diese einlesen
reset($apl);                                            //zu ihrem ersten Eintrag springen
foreach($apl as $p)                                     //und von jeden Eintrag
 $pl_array[trim($p)]=trim($p);                          //berflssige Zeichen wie Zeilenvorschub etc. entfernen

//********************************************************************************************  
//* add if new playlistentry or delete if already in playlist
//********************************************************************************************  
if (isset($plmod) && isset($add))
{
  $add = trim($add);
  //berprfen ob der neue Eintrag bereits vorhanden ist und lschen bzw. setzen
  if(isset($pl_array[$add]))
    unset($pl_array[$add]);
  else
    $pl_array[$add]=$add;

  reset($pl_array);

  if(count($pl_array)>0)
  {
    $var='';
    foreach($pl_array as $lin)
      $var .= $lin."\r\n";
	create_file($pl_pfad,$var); //nderungen in Wiedergabelistendatei schreiben
  }
  else // wenn keine Playlist leer, wird auch Playlist geloescht
	@unlink($pl_pfad);
}
//********************************************************************************************  
//* Generate Headline
//********************************************************************************************  

$page['headline']=trans($pluginname,'plugin_'.$mode.'_name').' ';

if(strlen($ap)>0)
  $page['headline'].= $plmod=='PLAY'? trans($pluginname,'main_play').' '    :
                     ($plmod=='PL'  ? trans($pluginname,'main_playlist').' ' : trans($pluginname,'main_playshuffle').' ');

//********************************************************************************************  
// oxyl-file -> file filter
//********************************************************************************************  
//if($mode=='file')
//  $page['headline'].= $mode_1=='mp3'   ? trans($pluginname,'menu_file_mp3')   :
//                     ($mode_1=='video' ? trans($pluginname,'menu_file_video') :
//                     ($mode_1=='pic'   ? trans($pluginname,'menu_file_pic')   :''));
if($mode=="file"&&!$ap=='')
{
  if ($mode_1=='file')
  {
    $headlink = $pluginname.'_main.php?mode='.$mode.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.$st.'&his='.$his.'&mode_1=mp3';
    $headtext = trans('','menu_file_file');
  }
  elseif ($mode_1=='mp3')
  {
    $headlink = $pluginname.'_main.php?mode='.$mode.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.$st.'&his='.$his.'&mode_1=video';
    $headtext = trans('','menu_file_mp3');
  }
  elseif ($mode_1=='video')
  {
    $headlink = $pluginname.'_main.php?mode='.$mode.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.$st.'&his='.$his.'&mode_1=pic';
    $headtext = trans('','menu_file_video');
  }
  else
  {
    $headlink = $pluginname.'_main.php?mode='.$mode.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.$st.'&his='.$his.'&mode_1=file';
    $headtext = trans('','menu_file_pic');
  }
  
  $page['headline'].= '<a href="'.$headlink.'" TVID="'.IR_TVID_TAB.'"><img src="'.getimghref(IR_ICON_TAB).'" height='.ICON_ARROW_HEIGHT.' width='.ICON_ARROW_WIDTH.' border=0 align="absmiddle">'.gen_transpic(ICON_ARROW_HEIGHT,3,'align="absmiddle"').$headtext.'</a>';
}


$page['mode']='full';

//********************************************************************************************  
//* read devices (Basisverzeichnisse auslesen)
//********************************************************************************************  
$devices = get_devices('plugins_oxyl_'.$mode.'_devices.cfg');            //Basisverzeichnisse auslesen

//********************************************************************************************  
//* back navigation bar (BACK Knopf URL Erzeugung fr Basis- und Unterverzeichnisse)
//********************************************************************************************  
$page['nav']['back']['image']=getimghref('oxyl_nav_top.gif');          //Pfad auf Bild fr BACK-Button setzen
$page['nav']['back']['fo']=$fo.' TVID="'.IR_TVID_BACKSPACE.'"';        //BACKSPACE Knopf auf Fernbedienung mit Wechsel in nchsthhere Ebene belegen

if (strlen($ap)==0)                                                    //falls man gerade an der basis ist
{
  $page['nav']['back']['href']=OXYL_WEB.'/oxylstart.php';              //Verweis fr Back Gif auf Home von Oxyl setzen
  $his = 0;                                                            //Tiefenzhler fr aktuelle Verzeichnistiefe auf 0 setzen
}  
else                                                                     //ansonsten
{
  //bergeordnetes Verzeichnis ermitteln (da pfadangaben nie mit / enden liefert dir name das bergeordnete verzeichnis zurck)
  //wenn direkt in einem basisverzeichnis, dann nchstes ziel basisverzeichnisauswahl (archivauswahl)
  $newpath =strlen($his)<=2 ? '' : (substr($ap,0,2)=='//' ? '/' : '' ).dir_name($ap);
  $page['nav']['back']['href']=$pluginname.'_main.php?le=r&view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($newpath).'&st='.substr($his,strrpos($his,'~')+1).'&his='.substr($his,0,strrpos($his,'~'));
  //&his='.($his>0 ? $his-1:0);
}
//********************************************************************************************  
//* Seiteninhalt Basis
//********************************************************************************************  
if (strlen($ap)==0)
{
//********************************************************************************************  
//* LINKS - RECHTS Knpfe URL Erzeugung) fr Basis
//********************************************************************************************  
  if ((count($devices)>$maxlines) && ($st>0))                                               //falls mehr Verzeichnispfade vorhanden als auf einer Seite erlaubt sind und man nicht auf der ersten Seite ist
  {
    //wenn vorher gerade nach LINKS umgeblttert wurde
    $fo = $le=='l' ? ' name="MyFocus" ' : '';

    $page['nav']['left']['image']=getimghref('oxyl_nav_left.gif');                          //Pfad auf Bild fr LINKS Button setzen
    $page['nav']['left']['href']=$pluginname.'_main.php?le=l&view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.(int)($st-1).'&his='.$his;
    $page['nav']['left']['fo']=$fo.' TVID="'.IR_TVID_PGUP.'"';                              //Zuordnung auf PGUP Knopf auf Fernbedienung
  }

  if (count($devices)>$maxlines)                                                            //falls mehr Verzeichnispfade vorhanden als auf einer Seite erlaubt sind
  {
    $page['nav']['set']['pages']=(int)($st+1);                                              //setze aktuelle Seite zur Darstellung auf Seite
    $page['nav']['set']['countpages']=(int)(((count($devices)-1)/$maxlines)+1);             //ermittle Seitenanzahl und setze den Wert zur Darstellung auf Seite
  }

  if ((count($devices)>$maxlines) && ((int)($st+1)<(int)(((count($devices)-1)/$maxlines)+1)))  //falls mehr Verzeichnispfade vorhanden als auf einer Seite erlaubt sind und die aktuelle Seite nicht die letzte Seite ist
  {
    //wenn vorher gerade nach RECHTS umgeblttert wurde
    $fo = $le=='r' ? ' name="MyFocus" ' : ''; 

	$page['nav']['right']['image']=getimghref('oxyl_nav_right.gif');                        //Pfad auf Bild fr RECHTS Button setzen
    $page['nav']['right']['href']=$pluginname.'_main.php?le=r&view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.(int)($st+1).'&his='.$his;
    $page['nav']['right']['fo']=$fo.' TVID="'.IR_TVID_PGDN.'"';                             //Zuordnung auf PGDN Knopf auf Fernbedienung
  }

  $page['nav']['text']=htmlspecialchars(trans($pluginname,'main_archives'));                //Anzeigename fr Archivauswahl setzen
  $page['body']['typ']='lines';

  for ($i=($st*$maxlines);($i<(($st+1)*$maxlines)) && ($i<count($devices));$i++)            //Zeige die Basisverzeichnisse der aktuellen Seite an
  {
    if ((((int)($GLOBALS['actuserlevel']))<=((int)($devices[$i]['level']))) || ($GLOBALS['actuser']=='ADMIN'))
    {
      $page['body']['content'][$i]['image']=getimghref('oxyl_icon_folder.gif');
      $page['body']['content'][$i]['href']=$pluginname.'_main.php?view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($devices[$i]['path']).'&st=0&his='.$his;
      $page['body']['content'][$i]['text']=htmlspecialchars($devices[$i]['name']);
    }
  }

  //if($mode_1=="mp3"||$mode_1=="file"){ // Playlist wird nur bei mp3 und file modus angezeigt
    $page['body']['content'][$i+1]['image']=getimghref('oxyl_icon_folder.gif');
    $page['body']['content'][$i+1]['href']='oxyl_playlist_play.php?mode='.$mode_1;
    $page['body']['content'][$i+1]['text']=htmlspecialchars(trans($pluginname,'playlists'));
  //}
}
//********************************************************************************************  
//* Seiteninhalt nicht Basis
//********************************************************************************************  
else
{
  //ermittle alle Verzeichnisse in aktuellem Verzeichnis und sortiere
  switch ($dir_sort_mod){
    //keine Sortierung
	case 0:  $dirs=getdirs($ap);                                                                          break;
    //Sortierung nur nach Name und Datum
    case 2:  $dirs=!stristr($sort,'SIZE') ? getdirs($ap,FALSE,FALSE,$sort,$view_sort_add) : getdirs($ap); break;
    //Sortierung nach Name, Datum und Gre
    case 3:  $dirs=getdirs($ap,FALSE,FALSE,$sort,$view_sort_add);                                         break;
    //Sortiertung nur nach Name
    default: $dirs=stristr($sort,'NAME') ? getdirs($ap,FALSE,FALSE,$sort) : getdirs($ap); //case 1
  }

  $files = $view_all_files && $mode_1=='file' ? 
           getfiles($ap,'',TRUE,FALSE,FALSE,FALSE,$sort,$view_sort_add) : 
		   getvalidfiles($ap,0,false,false,$which,FALSE,$sort,$view_sort_add);

  //**** buda Hiddenfiles modified by brause
  if(($mode=='file'||$mode=='video') && $GLOBALS['system']=='windows') // geht nur bei Windows
  {
    if($mod_lastpod)
    {
	  $mod_lastpod = oxyl_decode($mod_lastpod);
      if(GetLastPos($mod_lastpod)==0)
	    create_file($mod_lastpod.'.lastpos','99%');
      else
        create_file($mod_lastpod.'.lastpos','0%');
      unset($mod_lastpod);
    }

    //Entferne ganz gesehene Filme 
    if($hiddenfiles_mod==1)
    {
      foreach ($files as $key => $f)
	  {
        if($lastpos = GetLastPos( $ap . '/' . $files[$key]))
          if ($lastpos > 97)
            unset($files[$key]);
	  }
    }

    //Zeige nur gestartete Filme
    if($hiddenfiles_mod==2)
	{
	  foreach ($files as $key => $f)
	  {
          if($lastpos = GetLastPos( $ap . '/' . $files[$key]))
		  {
            if ($lastpos > 97 or $lastpos < 3)
              unset($files[$key]);
	      }
          else
            unset($files[$key]);
	  }
    }

    //Zweige nur ganz gesehene Filme
    if($hiddenfiles_mod==3)
	{
	  foreach ($files as $key => $f)
	  {
        if($lastpos = GetLastPos( $ap . '/' . $files[$key])) 
        {
          if ($lastpos < 98)
           unset($files[$key]);
	    }
        else
          unset($files[$key]);
	  }
    }
  }
  //**** ENDE buda Hiddenfiles


  $dirdispcount = count($dirs);
  $fildispcount = count($files);
  $allfiles_sum = $dirdispcount + $fildispcount;

  /// COVER ART DISPLAY
  if($cover_play_mod)
    if($mode_1=="mp3") $pics  = getimages($ap,1);   //nur bei bei mp3 modus ermittle alle streamfaehigen Bilder

  if($view=='THUMB')
  {
    //if((count($dirs)-$st*$maxlines)>0)// nur wenn ordner auf seite zu sehen sind
	//{
	  foreach($dirs as $dir)
	  {
        $allfiles[]='|'.$dir;
		$dir_name = explode("|",$dir);
	    if(($tmp = getimages($ap.'/'.$dir_name[0],0,false,true))!='')
	      $dirpics['|'.$dir]=$tmp;
      }
	  $max_end = ($st*$maxlines)< $allfiles_sum ? $st*$maxlines : $allfiles_sum;

	  if($mode_1!='pic' && ( !count($dirpics) || (count($dirs)-$max_end)<0) )//
	  { $temp_view = 'LIST';
	    $max_chars  = $GLOBALS["maxchars"];
	    $maxlines   = $line;
	  }
	//}
  }
  else
    foreach($dirs as $dir)
      $allfiles[]='|'.$dir;

  $allfiles     = array_merge($allfiles,$files);  //dieses an $allfiles anfgen
  $allfiles_sum = count($allfiles); // sicher ist sicher

  if($disp_thumb && ($view=='LIST'|| $temp_view=='LIST') )
  {
    if    ($mode_1=='pic')                   $pics2 = isset($files[0]) ? $files[0] : array();
    elseif($mode_1=='mp3'&&isset($pics[0]))  $pics2 = $pics[0];
    else                                     $pics2 = getimages($ap,0,false,true); //alle ausser picmodus ermittle erstes darstellbaren Bild in aktuellem Verzeichnis
  }

  if( $view == 'LIST' || $temp_view == 'LIST' )
  {
    if (count($pics2)>0&&$disp_thumb)
	   $maxlines = $maxlines-1;

    if($view_textfile)// textdateien anzeigen (nur bei Video)
    {
	  $inhalt=getfiles($ap,'txt',true);
	  if (count($inhalt)>0)
	    $maxlines -= 2;
	  if (isset($showmore))
	    $maxlines -= 4;
	}
  }

  // Seitenzugriff ueber Anfangsbuchstaben
  if(!stristr($sort,'NAME'))//wenn sortiermodus nicht nach Name wird der Navigator deaktiviert
    $abc_navigator=0;
  if($abc_navigator){
	if($view!='LIST'&&$temp_view!='LIST')
	  $maxlines -= $cols;
    else
	  $maxlines--;
  }

  //Berechnung der Seitenanzahl
  if($dirdispcount<1||$mode_1=='pic'||$view=='LIST'||!count($dirpics)){
	foreach($allfiles as $key => $val)
	{
	  $site_x = floor($key/$maxlines);
	  $nav_sites[$key]     = $site_x;
	  $nav_side_i[$site_x] = $maxlines;
	  if(!isset($nav_side_start[$site_x]))
	    $nav_side_start[$site_x] = $key;
	}
  }
  else{
	if($view!='LIST'&&$temp_view!='LIST'){
      if(isset($pics[0]))
	    $pics2 = $pics[0];
      else
	    $pics2 = getimages($ap,0,false,true);
	  if($mode_1=='video' || $mode_1=='file')
	    $inhalt2 = getfiles($ap,'txt',true);
    }
	//if(isset($dirpics
	$maxlines_list = $abc_navigator ? 1 : 0;
    if(count($pics2)>0)
	  $maxlines_list += 1;
    if((isset($inhalt)&&count($inhalt)>0)||(isset($inhalt2)&&count($inhalt2)>0))
      $maxlines_list += 2;

	$maxlines_th   = $abc_navigator ? $cols*$rows - $cols : $cols*$rows;
	$maxlines_li   = $line - $maxlines_list;
	$site_with_dir = ceil($dirdispcount/$maxlines_th);
	$files_dirsite = $site_with_dir*$maxlines_th;
	foreach($allfiles as $key => $val)
	{
	  $site_x = ($key < $files_dirsite) ? floor(($key)/$maxlines_th) : $site_with_dir+floor(($key-$files_dirsite+1)/$maxlines_li);
	  $site_y = ($key < $files_dirsite) ? $maxlines_th : $maxlines_li;
	  $nav_sites[$key]     = $site_x;
	  $nav_side_i[$site_x] = $site_y;
	  if(!isset($nav_side_start[$site_x]))
	    $nav_side_start[$site_x] = $key;
	}
  }
  $max_sites = end($nav_sites)+1;
  //ENDE Berechnung der Seitenanzahl
  /*
  print_r($nav_sites);
  print_r($nav_side_start);
  print_r($nav_side_i);
  echo '<br>'.$files_dirsite.' '.$site_with_dir.' '.$maxlines_th.' '.$maxlines_li.' '.$maxlines.' '.$allfiles_sum.' '.ceil($allfiles_sum/$maxlines).' '.$max_sites;
  */
//********************************************************************************************  
//* Caching of Thumbnails -> nur oxyl_pic Thumbmodus oder wenn coverbilder angezeigt werden
//********************************************************************************************  
if(count($pics2)>0|| $temp_view=='THUMB' || ($view=='THUMB' && !$temp_view=='LIST'))
   thumb_caching('oxyl_'.$mode);

//********************************************************************************************  
//* LINKS - RECHTS Knpfe URL Erzeugung) fr Unterordner
//********************************************************************************************  
  if (($allfiles_sum>$maxlines) && ($st>0))                                              //falls mehr Eintrge vorhanden als auf einer Seite erlaubt sind und man nicht auf der ersten Seite ist
  {
    //wenn vorher gerade nach LINKS umgeblttert wurde
    $fo = $le=='l' ? ' name="MyFocus" ' : '';

    $page['nav']['left']['image']=getimghref('oxyl_nav_left.gif');                          //Pfad auf Bild fr LINKS Button setzen
    $page['nav']['left']['href']=$pluginname.'_main.php?le=l&view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.(int)($st-1).'&his='.$his;
    $page['nav']['left']['fo']=$fo.' TVID="'.IR_TVID_PGUP.'"';                              //Zuordnung auf PGUP Knopf auf Fernbedienung
  }

  if ($allfiles_sum>$maxlines)                                                           //falls mehr Eintrge vorhanden als auf einer Seite erlaubt sind
  {
    $page['nav']['set']['pages']=(int)($st+1);                                              //setze aktuelle Seite zur Darstellung auf Seite
    $page['nav']['set']['countpages']=$max_sites;                                           //ermittle Seitenanzahl und setze den Wert zur Darstellung auf Seite
  }

  if (($allfiles_sum>$maxlines) && ((int)($st+1)<(int)((($allfiles_sum-1)/$maxlines)+1)))//falls mehr Eintrge vorhanden als auf einer Seite erlaubt sind und die aktuelle Seite nicht die letzte Seite ist
  {
    //wenn vorher gerade nach RECHTS umgeblttert wurde
    $fo = $le=='r' ? ' name="MyFocus" ' : ''; 

    $page['nav']['right']['image']=getimghref('oxyl_nav_right.gif');                        //Pfad auf Bild fr RECHTS Button setzen
    $page['nav']['right']['href']=$pluginname.'_main.php?le=r&view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.(int)($st+1).'&his='.$his;
    $page['nav']['right']['fo']=$fo.' TVID="'.IR_TVID_PGDN.'"';                             //Zuordnung auf PGDN Knopf auf Fernbedienung
  }

//---------------show all pictures------------------------------
  if (count($pics)>0)
  {
    $play_ls_user = $GLOBALS['actuser']!="" ? '_'.$GLOBALS['actuser'] : '';
    $Album=$GLOBALS['temppath'].'/user/user_'.$GLOBALS['actuser'].'/'.$play_ls_user.'_playlistcover.txt';
    $varpic='';
    foreach ($pics as $pic) 
      $varpic .= $timer.'|'.$wipe.'||'.OXYL_WEB.'/plugins/oxyl_file/oxyl_file_showpic.php?fn='.oxyl_encode($ap .'/'.$pic).'&nix=1|'."\r\n";

    create_file($Album,$varpic);
  }

//--- Statusbalken bei mp3
  if($view_progressbar&&$mode_1=='mp3')BOX_PBAR_POS(215,475);

  if($no_winampplaylist&2&&!$GLOBALS['showcenter'])//ob winamplaylisten ber PC erstellt werden sollen
  {
    // ich kenne die gegenoperation nicht
  }
  else
  {
    // Play all files in directory
    if ($fildispcount > 0 && $plmod!='PL')//wenn im aktuellen Verzeichnis Dateien vorhanden sind und erlaubt
    {
      $page['nav']['action'][0]['key']=IR_TVID_KEYA;
      $page['nav']['action'][0]['button']=IR_ICON_KEYA;
      $page['nav']['action'][0]['top']=true;
      $page['nav']['action'][0]['image']=getimghref('oxyl_icon_'.$mode_2.'.gif');
      $page['nav']['action'][0]['text']=htmlspecialchars(trans($pluginname,'play'));

      $href = OXYL_WEB.'/plugins/oxyl_file/oxyl_file_play.php?t=all&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&post_port='.$GLOBALS['port'];
      if($cover_play_mod && count($pics)>0&&$mode_1=='mp3')// wenn bilder im Verzeichnis und playmod mit cover
      {
        $page['nav']['action'][0]['pod']=($view_progressbar ? 3 : 2).',0,'.OXYL_STREAM. geturl($Album);
        $page['nav']['action'][0]['href']=$href;
      }
      elseif    ($mode_1=='video')
   	  {
	    $page['nav']['action'][0]['vod']='playlist';
	    $page['nav']['action'][0]['href']=$href;
	  }
	  elseif($mode_1=='pic'&&$GLOBALS['showcenter'])
	  {
	    $page['nav']['action'][0]['pod']='1,0,'.$href;
	    $page['nav']['action'][0]['href']=$playlist;
	  }
	  else
	  {
	    $page['nav']['action'][0]['aod']='playlist';
	    $page['nav']['action'][0]['href']=$href;
	  }
    }

    // Play playlist if exist
    if ($plmod=='PL' &&file_exists($pl_pfad))
    {
      $page['nav']['action'][0]['key']=IR_TVID_KEYA;
      $page['nav']['action'][0]['button']=IR_ICON_KEYA;
      $page['nav']['action'][0]['top']=true;
      $page['nav']['action'][0]['image']=getimghref('oxyl_icon_'.$mode_2.'.gif');
      $page['nav']['action'][0]['text']=htmlspecialchars(trans($pluginname,'play'));
      $href = OXYL_WEB.'/plugins/oxyl_file/oxyl_file_play.php?t=allpl&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($pl_pfad).'&playlist_mod='.$mode_2.'&post_port='.$GLOBALS['port'];
      if    ($mode_1=='video')
  	  {
	    $page['nav']['action'][0]['vod']='playlist';
	    $page['nav']['action'][0]['href']=$href;
	  }
	  elseif($mode_1=='pic'&&$GLOBALS['showcenter'])
	  {
	    $page['nav']['action'][0]['pod']='1,0,'.$href;
	    $page['nav']['action'][0]['href']=$playlist;
	  }
	  else
	  {
	    $page['nav']['action'][0]['aod']='playlist';
	    $page['nav']['action'][0]['href']=$href;
	  }
    }

    // Play all files incl. subdirectories
    if ($dirdispcount > 0 && $plmod!='PL')
    {
      $page['nav']['action'][4]['top']=true;
      $page['nav']['action'][4]['image']=getimghref('oxyl_icon_'.$mode_2.'_all.gif');
      $page['nav']['action'][4]['text']=htmlspecialchars(trans($pluginname,'playsubdir'));

      $href = OXYL_WEB.'/plugins/oxyl_file/oxyl_file_play.php?t=allsub&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&post_port='.$GLOBALS['port'];
      if($cover_play_mod && count($pics)>0&&$mode_1=='mp3')// wenn bilder im Verzeichnis und playmod mit cover
      {
        $page['nav']['action'][4]['pod']=($view_progressbar ? 3 : 2).',0,'.OXYL_STREAM. geturl($Album);
        $page['nav']['action'][4]['href']=$href;
      }
      elseif    ($mode_1=='video')
	  {
	    $page['nav']['action'][4]['vod']='playlist';
	    $page['nav']['action'][4]['href']=$href;
	  }
	  elseif($mode_1=='pic'&&$GLOBALS['showcenter'])
	  {
	    $page['nav']['action'][4]['pod']='1,0,'.$href;
	    $page['nav']['action'][4]['href']=$playlist;
	  }
	  else
	  {
	    $page['nav']['action'][4]['aod']='playlist';
	    $page['nav']['action'][4]['href']=$href;
	  }
    }
  }
// Sort
//-----------------------------------------

  if(stristr($sort,'DESC'))
  {
     $page['nav']['desc']['image']=getimghref('oxyl_icon_desc.gif');
     $sort2=substr($sort,0,4);
  }
  else
  {
    $page['nav']['desc']['image']=getimghref('oxyl_icon_asc.gif');
    $sort2=$sort.'_DESC';
  }
  $page['nav']['desc']['href']=$pluginname.'_main.php?view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort2.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&his='.$his;

  if    (stristr($sort,'NAME'))
    $sort3 = str_replace('NAME','TIME',$sort);
  elseif(stristr($sort,'TIME'))
    $sort3 = str_replace('TIME','SIZE',$sort);
  else
    $sort3 = str_replace('SIZE','NAME',$sort);

  $page['nav']['sort']['href']=$pluginname.'_main.php?view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort3.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&his='.$his;
  $page['nav']['sort']['text']=trans($pluginname,'sort_'.strtolower(substr($sort,0,4)));


//********************************************************************************************  
//* show dirs or files
//********************************************************************************************  
  foreach($devices as $dev)                               //alle Basisverzeichnisse durchgehen - setzt automatisch auf 1. Eintrag!
  {
    $base = getbasedir($ap,$his);
    if($dev['path']==$base or $dev['path']==$base.'/')
	{                                                     //wenn Basisverzeichnis mit aktuellem Basisverzeichnis bereinstimmt
      $dispfile = $dev['name'].substr($ap,strlen($base)); //den Namen des Basisverzeichnisses statt des Pfads anzeigen
	  break;
	}
  }
  $page['nav']['text']=oxyl_utf8_decode($dispfile);

//---------------------------------------------------------------------------------------------
  $page['body']['typ']='full';
  $main  ='<table cellpadding=0 cellspacing=0 border=0 width="100%"><tr><td>'.gen_transpic(LAYOUT_BODY_HEIGHT-LAYOUT_NAVI_HEIGHT,1).'</td>'
         .'<td valign="top">'."\n";

  // Seitenzugriff ueber Anfangsbuchstaben
  if($abc_navigator){
    $nav_dir_by_alpha = $nav_file_by_alpha = array();

    foreach($allfiles as $key => $filename)
    {
      $first  = strtolower(substr(oxyl_utf8_decode($filename),0,1));

	  if($first=='|'){
	    $second = strtolower(substr(oxyl_utf8_decode($filename),1,1));
        if(!isset($nav_dir_by_alpha[$second]))
          $nav_dir_by_alpha[$second]=$nav_sites[$key];
	  }
	  else{
        if(!isset($nav_file_by_alpha[$first]))
          $nav_file_by_alpha[$first]=$nav_sites[$key];
	  }
    }

	$str_modi_nav = $GLOBALS['system']=='linux' && $GLOBALS['str_mod'] == 1 ? 0 : $GLOBALS['str_mod'];
    uksort($nav_dir_by_alpha,  $GLOBALS['str_mods'][$str_modi_nav]);
	uksort($nav_file_by_alpha, $GLOBALS['str_mods'][$str_modi_nav]);

    $abc_nav = '';

    if(count($nav_dir_by_alpha)>0){
      $abc_nav .= trans($pluginname,'nav_dir').':&nbsp;';
	  foreach( $nav_dir_by_alpha as $key => $val)
      {
        $href = $pluginname.'_main.php?view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&his='.$his.'&st='.$val;
	    $abc_nav .= '<a href="'.$href.'">'.$key.'</a>&nbsp;'.(!$GLOBALS['showcenter'] ? '&nbsp;' : '');
      }
    }
    if(count($nav_file_by_alpha)>0){
	  if($abc_nav != '')
	    $abc_nav .= ($view!='LIST'&&$temp_view!='LIST')||!$GLOBALS['showcenter'] ? '<br>':'&nbsp;';
      $abc_nav .= trans($pluginname,'nav_file').':&nbsp;';
	  foreach( $nav_file_by_alpha as $key => $val)
      {
        $href = $pluginname.'_main.php?view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&his='.$his.'&st='.$val;
	    $abc_nav .= '<a href="'.$href.'">'.$key.'</a>&nbsp;'.(!$GLOBALS['showcenter'] ? '&nbsp;' : '');
      }
    }

    if(isset($abc_nav))
      $main .= $abc_nav.'<br>';
  }  // ENDE Seitennavi mit Direktzugriff

  $main .= '<table cellpadding=0 cellspacing=0 border=0 width="100%">';

  if(count($pics2)>0&&$disp_thumb&&($view=='LIST'|| $temp_view=='LIST'))// wenn Bilder vorhanden, in Setup Cover view eingeschaltet und nicht Image Modus
  {
    $max_chars=$max_chars_md;
    $imghref=getthumbhref($ap.'/'.$pics2,$disp_md_h,$disp_md_w,$enlarge_md,'oxyl_'.$mode,'pre'); //zugehriges Thumbnail laden
	$main .='<tr><td valign="top" align="center">'.gen_transpic(5,$disp_md_w+5).'<br><img src="'.$imghref.'" border=0 valign="top"></td>'
           .'<td width="90%" valign="top"><table width="100%" cellspacing=0 cellpading=0 border=0>';
  }//ende Cover vorschau

  if($view_textfile && count($inhalt)>0)// textdateien anzeigen wenn vorhanden (nur bei Video)
  {
    $main .= '<tr><td colspan=3 valign="top"><table cellspacing=0 cellpading=0 border=0><tr><td>'.gen_transpic(1,3).'</td><td wrab class="text_back">';
	$txt_arr = array();
    foreach($inhalt as $key)
	{
      $txt=file($ap.'/'.$key);
      $txt_arr = array_merge($txt_arr,$txt);
	}
	if (!isset($showmore)) //Text wird default als gekrzt angezeigt
	{
	  $i=0;
	  $puffer ='';
      foreach($txt_arr as $txti)
	  {
	    if(trim($txti)!='')
	    {
	      $puffer .= dotrunc(trim($txti),$max_chars_md,true,$dot_mod).'<br>';
          $i++;
		  if($i==2) break;
		}
	  }
	  $main .= $puffer
 	        .'</td></tr><tr><td colspan=2><a href="'.$_SERVER["REQUEST_URI"].'&showmore=1"><font size=2> '
	        .'<img src="' . getimghref('oxyl_icon_file.gif') . '" width='.ICON_SMALL_WIDTH.' height='.ICON_SMALL_HEIGHT.' border=0 align="absmiddle">'
	        .trans($pluginname,'main_infos').'</a><br>';
	}
    else
      $main .=nl2br(trim(implode('',$txt_arr))).'<br>';
    $main .='</td></tr></table></td></tr>';
  }//ende textdateien anzeigen

  // for schleife fr dateien anzeige
  for ($i=$nav_side_start[$st];($i<($nav_side_start[$st]+$nav_side_i[$st])) && ($i<$allfiles_sum);$i++)//fr alle Eintrge die auf der aktuellen Seite anzuzeigen sind
  //for ($i=($st*$maxlines);($i<(($st+1)*$maxlines)) && ($i<count($allfiles));$i++)
  {
    $back_color = 0;
	$isdir = substr($allfiles[$i],0,1)=='|' ? 1 : 0;
    $allfilename = array();
	$allfilename = explode("|",$allfiles[$i]);
	if ($isdir) //wenn Eintrag mit | beginnt (Verzeichnis ist)
    {
	  if($view=='LIST' || $temp_view=='LIST')
      {
	    $img  = getimghref('oxyl_icon_folder.gif');
	    $txt  = htmlentities(dotrunc(disp_special($dispspec,oxyl_utf8_decode($allfilename[1]),1,$max_chars).(isset($allfilename[2]) ? ' ('.$allfilename[2].')' :''),$max_chars,true,$dot_mod));
	  }
	  else
	  {
	    if(isset($dirpics[$allfiles[$i]]))
		{
		  $img  = getthumbhref($ap.'/'.$allfilename[1].'/'.$dirpics[$allfiles[$i]],$disp_th_h,$disp_th_w,$enlarge_th,'oxyl_'.$mode);
		  $back_color = 1;
		}
		else
		  $img  = getimghref('folder.gif').'" width="'.ICON_BIG_WIDTH.'" height="'.ICON_BIG_HEIGHT;
	    $txt  = '<img src="'.getimghref('oxyl_icon_folder.gif').'" height=20 border=0 align="absmiddle">'.htmlentities(dotrunc(disp_special($dispspec,oxyl_utf8_decode($allfilename[1]),1,$max_chars-1,TRUE),$max_chars-1,true,$dot_mod));
	  }
	  $href = $pluginname.'_main.php?view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap.'/'.$allfilename[1]).'&st=0&his='.$his.'~'.$st;
	  $podi = '';
	}
	else // dateien
	{
	  $ext = get_ext($allfiles[$i]);
      $ispic = in_array($ext,$GLOBALS['imageextensions']) ? 1 : 0;

      if($view=='THUMB' && $ispic && !$temp_view=='LIST')
	  {
	    //Vorschaubild erzeugen bzw. Pfad dazu holen (Oxyl-Funktion)
		$img=getthumbhref($ap.'/'.$allfiles[$i],$disp_th_h,$disp_th_w,$enlarge_th,'oxyl_'.$mode);
        $back_color = 1;
	  }
	  else
	  {
	    if($mode_1 == 'file')
	      $icon = in_array($ext,$GLOBALS['imageextensions']) ? 'image' :
	             (in_array($ext,$GLOBALS['videoextensions']) ? 'video' :
		         (in_array($ext,$GLOBALS['audioextensions']) ? 'audio' : 'file'));
	    else
		  $icon = $mode_2;

	    //wenn der aktuelle Eintrag in der Standardwiedergabeliste enthalten ist, diesen als markiert kennzeichnen
        $img=isset($pl_array[$ap.'/'.$allfilename[0]]) ? getimghref('oxyl_icon_'.$icon.'_sel.gif') : getimghref('oxyl_icon_'.$icon.'.gif');
      }


	  //wenn aktueller Wiedergabemodus PL ist
      if($plmod=='PL')
	    $href = $pluginname.'_main.php?mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&add='.oxyl_encode($ap.'/'.$allfilename[0]).'&view='.$view.'&st='.$st.'&his='.$his;
	  //wenn Files einzeln am SC abgespielt werden sollen
      elseif( $GLOBALS['showcenter'] && !$play_all)
	    $href = OXYL_WEB.'/plugins/oxyl_file/oxyl_file_play.php?mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap.'/'.$allfilename[0]).'&post_port='.$GLOBALS['port'];
	  //wenn Files einzeln am PC abgespielt werden sollen
      elseif(!$GLOBALS['showcenter'] && $no_winampplaylist&1)
	    $href = geturl( $ap . '/' .$allfilename[0]);
      else
	    $href = OXYL_WEB.'/plugins/oxyl_file/oxyl_file_play.php?mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&t=all&startwith='.SpecialCharReplace($allfilename[0]).'&post_port='.$GLOBALS['port'];

	  if($GLOBALS['showcenter'] && $plmod!='PL'){
	    if($mode_1=='mp3')
	    {
	      $barmod = $view_progressbar ? 3 : 2;
	      $podi   = $cover_play_mod && $fildispcount > 0 && count($pics)>0 ? 'pod="'.$barmod.',0,'.OXYL_STREAM. geturl($Album).'"' : 'aod="playlist"';
	    }
	    elseif($mode_1=='video')
	      $podi = 'vod="playlist"';
	    elseif($mode_1=='pic'|| (in_array($ext,$GLOBALS['imageextensions']) && !$play_all))
	    {
          $podi = 'pod="1,0,'.$href.'"'; // startbild wird schon mit startwith bergeben
	      $href = $mode_1=='pic' ? $playlist : "MUTE";
	    }
	    else
          $podi = 'aod="playlist"';
	  }
	  else
	    $podi = '';

      $txt = htmlentities(dotrunc(disp_special($dispspec,oxyl_utf8_decode($allfilename[0]),$dispext,$max_chars,TRUE).(isset($allfilename[1]) ? ' ('.$allfilename[1].')' :''),$max_chars,true,$dot_mod));

	  //----------------- GetLastPos
	  if($mode_1 == "video"||$mode_1 == "file")
	  {
	    $txt2 = '';
        if($lastpos = GetLastPos( $ap . '/' . strtolower($allfilename[0]) ))
		{
		   $link = $pluginname.'_main.php?view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&his='.$his.'&mod_lastpod='.oxyl_encode($ap . '/' . strtolower($allfilename[0]));
           $txt2 = ' <a href="'.$link.'">('.$lastpos.')</a>';
		}
        //---------------------------------------------DAN
        if (SUBTITLE_CHECK($ap,$allfilename[0],'CHECK'))
           $txt2 .= ' <img src="images/oxyl_sub_ok.gif" align="absmiddle" border=0>';
      }
	}// ENDE Dateien

	// view listenmodus
	if($view=='LIST'||$temp_view=='LIST')
	{

	  $main.=(($i % $maxlines==0&&$line==$maxlines) ? '<tr><td height=5 colspan=2></td></tr>' : '')
	        .'<tr><td colspan="2" valign="bottom" align="left" nowrap>'
	        .'<table cellspacing=0 cellspacing=0 border=0><tr><td align="left" class="text_back" nowrap>'
            .'<a href="'.$href.'" '.$podi.'>'
	        .'<img src="' . $img. '" width='.ICON_SMALL_WIDTH.' height='.ICON_SMALL_HEIGHT.' border=0 align="absmiddle">&nbsp;'
            .$txt.'</a>'.$txt2
            .'</td></tr></table></td><td width="90%">'.gen_transpic(ICON_SMALL_HEIGHT+2,1).'</td></tr>'."\n";

	}// ENDE View List
	// view Thumbnailmodus
	elseif($view=='THUMB')
    {
	  if ($count==0)               //wenn noch kein Bild auf dieser Seite dargestellt wurde
	  {
        $main .= '<tr>'."\n";
        for($ix=0;$ix<$cols;$ix++)
		   $main.= '<td height=5 width='.$left_td.'></td><td width='.$disp_th_w.'></td><td width='.$right_td.'></td>';
        $main .= '</tr><tr>';
	  }
      elseif (($count % $cols)==0) //wenn Tabelle schon besteht aber kein Platz mehr frei ist
      {
        $main .= '</tr>'."\n"
                .'<tr><td height=5 colspan='.($cols*3).'></td></tr>'
                .'<tr>'."\n";       //weitere Tabellenzeile hinzufgen
      }
      if ($i<$allfiles_sum)
      {

        $main .= '<td></td><td>'
		        .'<table width='.$disp_th_w.' border=0 cellpadding=0 cellspacing=0>'."\n"
                .'<tr><td height='.($disp_th_h+2).' width=1></td><td align="center" valign="middle"'
				.($pic_back==1&&$back_color ? ' bgcolor="#FFFFFF">' : ($pic_back==2&&$back_color ? ' bgcolor="#000000">' :'>'))
                .'<a href="'.$href.'" '.$podi.'>'
				.($GLOBALS['showcenter'] ? gen_transpic(2,$disp_th_w).'<br>' : '') //damit lassen sich die links besser ansteuern (hoehe muss mind. 2 sein, sonst geht es nicht
                .'<img src="'.$img.'" border=0>'
                .'</a>'
                .'</td></tr>'."\n"
				.'<tr><td height=22></td><td align="center" valign="middle" class="text_back" nowrap>'
		         //Bildnamen als Bildunterschrift verwenden width=1
                .'<b>'.$txt.'</b>'
				.'</td></tr>'."\n"
                .'</table>'
				.'</td><td></td>'."\n";
      }

      $count++;
    }// ENDE thumb modus
  }// ENDE FOR Schleife

  $main .= '<tr><td height=8></td></tr>'
          .'</table>'
          .'</td></tr></table>';

  if (count($pics2)>0&&$disp_thumb)// wenn Bilder vorhanden, in Setup Cover view eingeschaltet
    $main .= '</td></tr></table>';

  $page['body']['content']['full']=$main;

//********************************************************************************************  
//* Writinge of Thumbnails
//********************************************************************************************  
  if(count($pics2)>0|| $temp_view=='THUMB' || ($view=='THUMB' && !$temp_view=='LIST'))
    create_file(OXYL_TEMP.'oxyl_'.$mode.'/thumbs.dat',serialize($GLOBALS['thumbs']));

}// ENDE Files anschauen
//********************************************************************************************  
//* botton keys
//********************************************************************************************  
if (strlen($ap)>0)//falls nicht gerade an der basis ist
{
  $page['nav']['action'][2]['key']   =IR_TVID_KEYB;
  $page['nav']['action'][2]['button']=IR_ICON_KEYB;
  $page['nav']['action'][2]['text']  =trans('','mode');

  if ($plmod=='PLAY') //Wechsel durch die verschiedenen Wiedergabemodi
    $page['nav']['action'][2]['href']=$pluginname.'_main.php?view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod=PL&ap='.oxyl_encode($ap).'&st='.$st.'&his='.$his;
  elseif ($plmod=='PL')
    $page['nav']['action'][2]['href']=$pluginname.'_main.php?view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod=SHUFFLE&ap='.oxyl_encode($ap).'&st='.$st.'&his='.$his;
  else
    $page['nav']['action'][2]['href']=$pluginname.'_main.php?view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod=PLAY&ap='.oxyl_encode($ap).'&st='.$st.'&his='.$his;
}

//********************************************************************************************  
// C Button fr oxyl-mp3/oxyl-pic -> Playlist Diashow Settings
//********************************************************************************************  
if(isset($showsetup) && $showsetup=='ON' && $mode_1=='pic' || ($mode_1=='mp3'&&!$view_progressbar&&(count($pics2)>0||$ap=='')))
{
  $page['nav']['action'][3]['key']    = IR_TVID_KEYC;
  $page['nav']['action'][3]['button'] = IR_ICON_KEYC;
  $page['nav']['action'][3]['text']   = trans('','menu_dias2');

  if ($ap=='')
    $page['nav']['action'][3]['href'] = $pluginname.'_diasettings.php?dias=devices&mode='.$mode.'&mode_1='.$mode_1;
  else
    $page['nav']['action'][3]['href'] = $pluginname.'_diasettings.php?ap='.oxyl_encode($ap).'&st='.$st.'&his='.$his.'&view=' . $view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod;
}
//********************************************************************************************  
// C Button fr oxyl-video -> IMDB
//********************************************************************************************  
elseif($mode_1=="video")
{
  if (isset($dirs) && (count($dirs)<1 || in_array('VIDEO_TS',$dirs))) // Nimmt den DirectoryNamen fr die IMDB Abfrage
  {
	$imdbquery = basename($ap)=='VIDEO_TS' ? basename($ap,'VIDEO_TS') : basename($ap);

    if ($allfiles_sum>0)
    {
	  if($OFDb)
	  {
        $page['nav']['action'][3]['href']   = 'oxyl_video_ofdb.php?&ap='.urlencode($ap).'&st='.$st.'&his='.$his.'&view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&msg=&start=';
        $page['nav']['action'][3]['text']   = 'OFDb';
	  }
	  else
	  {
	    $page['nav']['action'][3]['href']   = 'oxyl_video_imdb.php?fname=' . urlencode(SpecialCharReplace($imdbquery)) . '&ap='.urlencode($ap) . '&st=' . $st . '&his=' . $his . '&start=yes&view=' . $view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod;
        $page['nav']['action'][3]['text']   = 'IMDb';
	  }
      $page['nav']['action'][3]['key']    = IR_TVID_KEYC;
      $page['nav']['action'][3]['button'] = IR_ICON_KEYC;
    }
  }
}

//----------------------------------------------------------------------------------------
// Hilfe
//----------------------------------------------------------------------------------------

  $hlp_href = '/plugins/oxyl_file/'.(isset($plmod) && ($plmod=='PL') ? $pluginname.'_pl_help' : $pluginname.'_play_help');

  if (strlen($ap)<2)
    $hlp_href='/plugins/oxyl_file/'.$pluginname.'_main_help';                                                                                              //Hilfeaufruf

  $hlp_bref=OXYL_WEB.'/plugins/oxyl_file/'.$pluginname.'_main.php?view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.$st.'&his='.$his;

  $page['nav']['action'][5]['href']   = OXYL_WEB.'/common/help.php?bl='.SpecialCharReplace($hlp_bref).'&hf='.$hlp_href;
  $page['nav']['action'][5]['key']    = IR_TVID_HELP;
  $page['nav']['action'][5]['button'] = IR_ICON_HELP;
  $page['nav']['action'][5]['text']   = trans('','help');

//----------------------------------------------------------------------------------------
// Ansicht
//----------------------------------------------------------------------------------------
if (!$ap=='')
{
  $page['nav']['action'][6]['href'] = $view=='LIST' ? 
									     $pluginname.'_main.php?view=THUMB&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.$st.'&his='.$his :
                                         $pluginname.'_main.php?view=LIST&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.$st.'&his='.$his;
  $page['nav']['action'][6]['key']  = IR_TVID_VOUT;
  $page['nav']['action'][6]['text'] = trans('','menu_view');
  $page['nav']['action'][6]['button'] = IR_ICON_VOUT;
}

//----------------------------------------------------------------------------------------
// SETUP
//----------------------------------------------------------------------------------------
$GLOBALS['NO_DIRECT_SETUP_ACCESS'] = TRUE; // damit Setup Button nicht aus design.inc kommt
if ($GLOBALS['actuserlevel']==0&&!$GLOBALS['showcenter']&&$GLOBALS['VIEW_SETUP'])
{
  $page['nav']['action'][9]['href']   = 'oxyl_file_setup.php?&mode='.$mode.'&mode_1='.$mode_1;
  $page['nav']['action'][9]['text']   = trans('','setup');
  $page['nav']['action'][9]['key']    = 'setup';
  $page['nav']['action'][9]['button'] = 'oxyl_icon_menu_'.$mode_2.'.gif';
}

//+-----------------------------------------------------------------------------------------
//|  bergabe Variablen fr Seitenregister
//+-----------------------------------------------------------------------------------------
if($GLOBALS['SITE_NAV'])
{                         //Basisverzeichnis                  Explorer
  $sites = strlen($ap)==0 ? ceil(count($devices)/$maxlines) : $max_sites;
  $page['nav']['sitekeys']['href'] = $pluginname.'_main.php?view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&his='.$his.'&st=';

  // Seitenzugriff ueber Seitennummer
  for($i=0;$i<$sites;$i++)
    $site_nav[$i+1]=$i;

  // Seitenzugriff ueber Anfangsbuchstaben
  /*Baustelle fuer Seitenzugriff direkt mit Anfangsbuchstaben
  //TODOs:
  // - anpassung Funktion siteregister
  // - alternativ Mglichkeiten auch wenn Name mit Zahl beginnt
  // - konfigurierbar
  // - Hardware die Buchstabeneingabe untersttzt :-)
  $abc = array('z','y','x','w','v','u','t','s','r','q','p','o','n','m','l','k','j','i','h','g','f','e','d','c','b','a');
  foreach($name_arr as $key => $filename)
  { 
    $first = strtolower(substr($filename,0,1));
    if(!isset($nav_by_alpha[$first]) && in_array($first,$abc))
      $nav_by_alpha[$first]=floor($key/$maxlines);
  }
  $site=$sites-1;
  foreach($abc as $val)
  {
    if(isset($nav_by_alpha[$val]))
	{
	  $site = $nav_by_alpha[$val];
	  $site_nav[$val]=$site;
	}
	else
	  $site_nav[$val]=$site;
  }
  ksort($site_nav);
  reset($site_nav);
  */
  $page['nav']['sitekeys']['sites'] = $site_nav;
}

//+-----------------------------------------------------------------------------------------
//|  wenn leere Seite
//+-----------------------------------------------------------------------------------------
if (($allfiles_sum<1&&$ap!='')||(count($devices)<1&&$ap=='')) // erzeugt leere Seite
{
  gen_header(true);
  if (!(isset($page['headline']))) $page['headline'] = '&nbsp;&nbsp;';
  echo '<table width='.LAYOUT_TABLE_WIDTH.' cellspacing=3 cellpadding=0 border=0'
	  .($GLOBALS['showcenter'] ? ' align="center"':'').'>'."\n";
  gen_default_title($page);      
  gen_navbar($page);  
  echo '<tr><td><table border=0><tr><td>'.gen_transpic(LAYOUT_BODY_HEIGHT-LAYOUT_NAVI_HEIGHT-10,1).'</td></tr></table></td></tr>';
  gen_nav_footer($page);
}
else
  gen_full_page($page);
//+-------------------------------- EOF ----------------------------------------------
?>
