<?php
//###################################### Oxyl~Box 2.5.0 #####################################################
//+-------------------------------------------------------------------------------------------
//| plugin: oxyl_file_play.php
//| author : brause
//+-------------------------------------------------------------------------------------------
//| plays supported audiofiles (subroutine for oxyl_file_main.php)
//+-------------------------------------------------------------------------------------------
//| 050326 ...... Brause   - neu erstellt (Basis oxyl_playmp3)
//| 050917 ...... Brause   - FIX: lastpos wurde ignoriert
//| 060226 ...... Brause   - FIX: Dateien mit + Zeichen in Dateinamen konnten nicht angezeigt werden
//+-------------------------------------------------------------------------------------------

include_once('../../common/design.inc');

if(!isset($mode))   $mode   = 'file';
if(!isset($mode_1)) $mode_1 = 'file';
//vereinfachung so ist der auswertungsaufwand kleiner -> icons etc.
if    ($mode  =="mp3")   $mode_1='mp3';
elseif($mode  =="video") $mode_1='video';
elseif($mode  =="pic")   $mode_1='pic';

if    ($mode_1=='mp3')  {$mode_2='audio'; $which = 1;}
elseif($mode_1=='video'){$mode_2='video'; $which = 2;}
elseif($mode_1=='pic')  {$mode_2='image'; $which = 4;}
else                    {$mode_2='file';  $which = 7;}
if(!isset($playlist_mod))$playlist_mod           = 'audio';
if($playlist_mod=='file')$playlist_mod           = 'audio';

//------ configs einlesen und default werte setzen
if (file_exists(OXYL_CONF.'plugins_oxyl_'.$mode.'_disp.inc'))
   include_once(OXYL_CONF.'plugins_oxyl_'.$mode.'_disp.inc');

if(!isset($view_all_files))    $view_all_files     =0;
if(!isset($FURLING))           $FURLING            =1;
if(!isset($vdr_to_mpg))        $vdr_to_mpg         =0;
if(!isset($use_vcr_client))    $use_vcr_client     =0;
if(!isset($play_all))          $play_all           =1;

$devices=get_devices('plugins_oxyl_'.$mode.'_devices.cfg');

// falls Zeichenkette codiert wurde
$ap = oxyl_decode($ap);

//-------------------------------------------------------------------------------------------
$play_ls_user = $GLOBALS['actuser']!="" ? '_'.$GLOBALS['actuser'] : '';

$File = OXYL_TEMP.'user/user_'.$GLOBALS['actuser'].'/'.$play_ls_user.'_Playlist_'.$mode_2
      .($GLOBALS['showcenter'] ? '.txt' : '.m3u');

$streaming = $mode_1=='pic' ? 0 : 1;

if    (isset($t)&&$t=='allpl')  //Wiedergabeliste mit Playlist
  $files=file_exists($ap) ? file($ap) : array(OXYL_ROOT.$GLOBALS['default_'.$playlist_mod]);
elseif(isset($t)&&$t=='all')    //Wiedergabeliste alle Dateien im Verzeichnis
  $files=getvalidfiles($ap,$streaming,false,false,$which,FALSE,$sort);
elseif(isset($t)&&$t=='allsub') //Wiedergabeliste alle Dateien im Verzeichnis und Unterverzeichnisse
  $files=getvalidfiles($ap,$streaming,true, false,$which,FALSE,$sort);
elseif(isset($ap))              //Wiedergabeliste ein File
  $files[] = $ap;
else
  die();
//echo $files;
if (isset($t)&&$mode_1=='pic')
{
  $timer=3;
  $wipe=0;
  if (file_exists(OXYL_CONF.'plugins_oxyl_'.$mode_1.'_dias.cfg'))
  {
    $diaoptions    = file(OXYL_CONF.'plugins_oxyl_'.$mode_1.'_dias.cfg');
    $timer         = trim($diaoptions[0]);
    $wipe          = trim($diaoptions[1]);
    $music         = trim($diaoptions[2]);
    $showtit       = trim($diaoptions[3]);
    $showsetup     = trim($diaoptions[4]);
    $showsound     = trim($diaoptions[5]);
  }   
// Playlist pro Ordner
//--------------------------------------------
  if (file_exists(OXYL_CONF.'plugins_oxyl_'.$mode_1.'_diasdir.cfg'))
  {
    $dirplaylists=file(OXYL_CONF.'plugins_oxyl_'.$mode_1.'_diasdir.cfg');
    foreach ($dirplaylists as $dirplaylist)
    {
      if (substr($dirplaylist,0,strpos($dirplaylist,'|'))==$ap)
      {
      	$optarr = array();
      	$optarr = explode('|',$dirplaylist);
        $showtit  = trim($optarr[1]);
        $timer    = trim($optarr[2]);
        $wipe     = trim($optarr[3]);
        $playlist = trim($optarr[4]);
      }
    }
  }
}

if (isset($plmod) && ($plmod=='SHUFFLE'))    //und wenn Modus auf SHUFFLE steht diese umordnen
  shuffle($files);

if (isset($FURL)&&$FURLING)                  // wenn Lied markiert und A Button gedrckt wird
{
  $furl_arr=explode('&',$FURL);
  foreach($furl_arr as $furli)
  {
	if(substr($furli,0,9)=="startwith")
	  $startwith = urldecode(substr($furli,10));
  }
}

if (isset($startwith)){
  reset($files);
  $found=0;
  $files1 = $files2 = array();
  foreach($files as $file)
  {
    if($file==$startwith)$found = 1;
	if($found) $files1[] = $file; else $files2[] = $file;
  }
  $files = array_merge($files1,$files2);
}
reset($files);

$pl_var = '';
if (!$GLOBALS['showcenter'])
  $pl_var .= '#EXTM3U'."\r\n"; //Header fr Extended M3U Datei schreiben - damit sieht man nach dem ffnen der Playlist gleich alle Titel und nicht nur die URLs welche auf den Server verweisen

if(!isset($post_port))
  $post_port = $GLOBALS['port'];

$port2 = $GLOBALS['system']=='windows' // nur bei Windows
      && ($GLOBALS['showcenter']       // ist showcenter
	  || $use_vcr_client) ?            // vcr client support ist aktiviert
      GetStreamPort($post_port) :      // ermittele Streamport 
      $post_port;                      // sonst Oxyl Port

//wenn not Found File verwendet wird & stoweb muss stoweb umgangen werden
// Super krcke :-(
if(isset($t)&&$t=='allpl'&& !file_exists($ap))
  $port2 = $post_port;

foreach($files as $file)
{
  $apfile  = $file = trim($file);
  if(isset($t)&&($t=='all'||$t=='allsub'))
    $apfile = $ap.'/'.$apfile;

  $ext     = get_ext($file);

  if(in_array($ext,$GLOBALS['imageextensions']) && !isset($t)){
    $timer=9999;
    $wipe=0;
    if(!isset($showtit)) $showtit = 0;
  }

  $startpos= in_array($ext,$GLOBALS['videoextensions']) ? 
	         GetLastPos(strtolower($apfile)) : 0;
  $OXYLWEB = $GLOBALS['protokoll'].$GLOBALS['ip'].':'
            .(!in_array($ext,$GLOBALS['audioextensions'])&&!in_array($ext,$GLOBALS['videoextensions']) ?
             $post_port : $port2);

  if($vdr_to_mpg&&$GLOBALS['showcenter'])
    if(preg_match('/\\d{3,3}\\.vdr$/',$apfile))// gauckelt showcenter vdr als mpg vor
      $apfile .= '.mpg';
  $thefile = in_array($ext,$GLOBALS['imageextensions'])&& ( $mode_1=='pic' || !$play_all) ? '/plugins/oxyl_file/oxyl_file_showpic.php?fn='.oxyl_encode($apfile).'&nix=1' : geturl($apfile);

  if (strlen($thefile)>0)
  {
    if($dispext)
	  $file = del_ext($file);
    if ($GLOBALS['showcenter'])
    {
      if(( $mode_1=='pic' && isset($t)) || in_array($ext,$GLOBALS['imageextensions']) && !$play_all)  // nur pic
        $pl_var .= $timer.'|'.$wipe.'|'.($showtit=='ON'? oxyl_utf8_decode(basename($file)):'').'|'.$OXYLWEB.$thefile.'|'."\r\n";
	  else // video, audi, file und einzelnes image
        $pl_var .= oxyl_utf8_decode(basename($file)).'|'.$startpos.'|0|'.$OXYLWEB.$thefile.'|'."\r\n";
    }
    else
    {
      $pl_var .= '#EXTINF:-1,'.oxyl_utf8_decode(basename($file))."\r\n" //Extended Eintrag fr Datei schreiben: Dauer fix -1 (unbekannt) und danach der Dateiname zur Anzeige
                 .$OXYLWEB.$thefile."\r\n";
    }
  }
}
create_file($File,$pl_var);
download_file($File);
?>
