<?php
//###################################### Oxyl~Box 2.0.26 #####################################################
//+-------------------------------------------------------------------------------------------
//| plugin: oxyl_video_imdb.php
//| author : odu
//+-------------------------------------------------------------------------------------------
//| search imdb for Filmtitles and copy cover to local drive
//+-------------------------------------------------------------------------------------------
//|  20041103 .............. LongDan - Plugin erstellt
//|  20041103 .............. LongDan - Copy Cover (B) eingebaut.
//|                                  - Some bugfixes!
//|                                  - Create Textfile out of the IMDB Details
//|                                  - Verschieden Return Templates eingebaut!
//|                                  - Falls Bildname nicht herausgefiltert werden kann, 
//|                                    wird auch kein (B) Copy Pic angezeigt!
//|  20041210 .............. LongDan - Copy Text and Cover (B) eingebaut.
//|  20041222 .............. LongDan - Angepasst an neues IMDB Layout
//|  20041223 .............. LongDan - Angepasst an neues IMDB Layout
//|  20050703 .............. Brause  - Anpassungen an oxyl_file und neue funktionen
//+------------------------------------------------------------------------------------------  -

  include_once('../../common/design.inc');

// Default Settings
//----------------------------------------------------------------
  if(!isset($plmod)) $plmod='';
  if(!isset($mode))  $mode = 'file';
  
  ini_set("max_execution_time","0");
  $weburl      = 'http://www.imdb.com';
  $searchstr   = '/find?q=';

// Temp Text File 
  $temptext = OXYL_TEMP .'IMDB_Film_Desc.txt';

// Temp IMDB Link File 
  $tempimdb = OXYL_TEMP .'IMDB_Film_Link.imdb';


//------------------------------------------------------------------------------------
//Find Overview Lines
//
 $searchstart = "<b>Popular Titles</b>";
 $searchstop  = "<b>Names (Partial Matches)</b>";

 $startov = '<a href="/title/tt';
 $pattern_mixed = array(
				  "'[\n\r\t]*?'si",
                  "'<b>([\w\s]*)</b>.*?<ol>'si",
				  "'<b>([\w\s()]*)</b>.*?<ol>'si",
				  "'<h2>[\w\s()]*</h2>'si",
				  "'<p>'i",
				  "'</p>'i",
				  "'<li>([\s]*)<a'i",
                  "'<ol>'i",
                  "'</ol>'i",
                  "'</li>'i",
                  "'<a href=\"/title/tt([\d/]*)([^>]*?)>'si",
				  "'/name/nm'i"
				  );

 $replace_mixed = array(
				 '',
                 "<font size='+1'>\\1</font><br>\r\n",
				 "<br><font size='+1'>\\1</font><br>\r\n",
				 '',
				 '',
				 '',
				 '<a',
                 '',
                 '',
                 "<br>\r\n",
                 "<a href='oxyl_video_imdb.php?mode=".$mode."&mode_1=".$mode_1."&plmod=".$plmod."&ap=".urlencode($ap)."&st=".$st."&his=".$his."&fname=". $fname ."&view=". $view ."&startdetail=ON&detail=tt\\1'>",
				 'http://www.imdb.com/name/nm'
				 );

//Detail Page search Strings
  $startdet = 'strong class';

// Reset some variables to be shure they are empty
//
  $i=0; 

//  OXYL Demo Mode
//----------------------------------------------------------------
  if (isset($demo))
  {
    $page['headline']='oxyl_video imdb';
    $page['mode']='full';
    $page['body']['typ']='full';
    $page['body']['content']['full'] = "Auf dem Demo-System aus Urheberrechtsgrnden gesperrt";
    gen_full_page($page);
    flush();
    die();
  }

//  Copy Text & IMDB Cover
//----------------------------------------------------------------
if (isset($fullcopy))
 {
  $nfname=str_replace(' ','_',$fname);
  if (isset($kopy))
      copy($kopy,$ap .'/' . $nfname.'.jpg');

  copy($temptext,$ap .'/' . $nfname.'.txt');

//IMDB Link
  copy($tempimdb,$ap .'/' . $nfname.'.imdb');

  @unlink($temptext);
  @unlink($tempimdb);

  header('Location: oxyl_file_main.php?le=r&mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap=' . urlencode($ap) . '&st=' . $st . '&his=' . $his . '&ni=x&view=' . $view);
  die();
}

//  Copy IMDB Cover
//----------------------------------------------------------------
if (isset($kcopy))
 {
  $nfname=str_replace(' ','_',$fname);
  copy($kcopy,$ap .'/' . $nfname.'.jpg');

//IMDB Link
  copy($tempimdb,$ap .'/' . $nfname.'.imdb');

  @unlink($temptext);
  @unlink($tempimdb);

  header('Location: oxyl_file_main.php?le=r&mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap=' . urlencode($ap) . '&st=' . $st . '&his=' . $his . '&ni=x&view=' . $view);
  die();
}
//----------------------------------------------------------------

if (isset($start))
{
  header('Location: oxyl_video_imdb.php?mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&fname=' . urlencode($fname) . '&ap=' .urlencode($ap) . '&st=' . $st . '&his=' . $his . '&ni=x&view=' . $view);
  die();
}
//----------------------------------------------------------------

if (isset($startdetail))
{
  header('Location: oxyl_video_imdb.php?mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap=' . urlencode($ap) . '&st=' . $st . '&his=' . $his . '&fname=' . $fname . '&detail=' . $detail . '&ni=x&view=' . $view);
  die();
}

// START Get List from IMDB
//---------------------------------------------------------------
if (! isset($detail))
{
  if (substr($fname,0,1)=='_')
    $fname=substr($fname,1);
  $imdbsc=read_web($weburl . $searchstr . $fname);
  //$imdbsc=read_file(OXYL_TEMP.'temp_imdb_tmp2.txt',TRUE,filesize(OXYL_TEMP.'temp_imdb_tmp2.txt'));

  if (! preg_match("'<title>(.*)IMDb  Search(.*)</title>'smi",$imdbsc))
  {
	$ttspos=strpos($imdbsc,'keywords/title/tt');
    $ttepos=strpos($imdbsc,'/',$ttspos);
    $detail=substr($imdbsc,$ttspos+15,$ttepos+1-$ttspos);
    header('Location: oxyl_video_imdb.php?mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap=' . urlencode($ap) . '&st=' . $st . '&his=' . $his . '&fname=' . $fname . '&detail=' . $detail . '&ni=x&view=' . $view);
    die();
  }


  $pos1 = strpos($imdbsc,$searchstart);
  $pos2 = strpos($imdbsc,$searchstop)-$pos1;
  $var = substr($imdbsc,$pos1,$pos2);

  //modify hrefs
  $var    =preg_replace($pattern_mixed,$replace_mixed,$var);
  $var_arr=explode("\r\n",$var);

  $num=0;
  $main='<table border=0 width="100%" cellpadding=0 cellspacing=0><tr><td width=1>'.gen_transpic(385,1).'</td><td valign="top"><table>';

  foreach($var_arr as $line)
  {
    if (stristr($line,'<a'))
    {
      $num++;
      $main.='<tr><td valign="top" align="right" nowrap>' . $num .'. &nbsp;</td><td>' . $line . '</td></tr>' . "\r\n";
	  $check=1;
    }
	else
	{
	  $num=0;
	  $main.='<tr><td valign="top" align="left" nowrap colspan=2>' . $line . '</td></tr>' . "\r\n";
	}
  }

  // Nothing found
  if (!$check)
    $main ='<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . trans('oxyl_file','imdb_nf');

  $main .='</table></td></tr></table>';

// Page Header
//---------------
  $page['headline']= urldecode($fname);

  $page['body']['typ']='full';
  $page['body']['content']['full']=$main;

  $page['nav']['back']['image']=getimghref('oxyl_nav_top.gif');
  $page['nav']['back']['href']='oxyl_file_main.php?le=r&mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap=' . urlencode($ap) . '&st=' . $st . '&his=' . $his . '&view=' . $view .'&ni=x';

  $page['nav']['action'][3]['href']='oxyl_file_main.php?le=r&mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap=' . urlencode($ap) . '&st=' . $st . '&his=' . $his . '&view=' . $view .'&ni=x';
  $page['nav']['action'][3]['key']=IR_TVID_KEYC;
  $page['nav']['action'][3]['button']=IR_ICON_KEYC;
  $page['nav']['action'][3]['text']=htmlspecialchars(trans('','back'));

  gen_full_page($page);
  die();
}

// Detail
//---------------------------------------------------------------
if (isset($detail))
{
 $page['headline']= '<font size="3">&nbsp;';
 $imdbsc=read_web($weburl . '/title/' . $detail);
  //$imdbsc=read_file(OXYL_TEMP.'temp_imdb_tmp6.txt',TRUE,filesize(OXYL_TEMP.'temp_imdb_tmp6.txt'));

 create_file(OXYL_TEMP.'temp_imdb_debug.txt',$imdbsc);

 $selected='<table width="100%" border="0" cellpadding="0" cellspacing="0"><tr valign="top"><td width="80%"><h1><';
 $selected .=strstr($imdbsc,$startdet);
 $endpos=strpos($selected,'Certification:');
 if ($endpos<1)
     $endpos=strpos($selected,'<td width="171" align="right">');
 if ($endpos<1)
     $endpos=strlen($selected);
 $selected=substr($selected,0,$endpos);

  $pattern_mixed2 = array(
				 "'/Sections'i",
				 "'/name'i",
				 "'/wga'i",
				 "'/List?'i",
				 "'/rg/'i",
				 "'/mpaa'i",
				 "'fullcredits'i",
                 "'#comment'i"
				  );

 $replace_mixed2 = array(
				 'http://www.imdb.com/Sections',
				 'http://www.imdb.com/name',
				 'http://www.imdb.com/wga',
				 'http://www.imdb.com/List?',
				 'http://www.imdb.com/rg/',
				 'http://www.imdb.com/mpaa',
				 'http://www.imdb.com/title/' . $detail . '/fullcredits',
                 'http://www.imdb.com/title/' . $detail . '#comment'
				 );

// Href replacement

 $selected = preg_replace($pattern_mixed2,$replace_mixed2,$selected);

 create_file(OXYL_TEMP.'temp_imdb.txt',$selected);

 $imdbdets=file($GLOBALS['temppath'].'/temp_imdb.txt');
 $imdbgood='';

 $txtfile = '';

 foreach ($imdbdets as $line)
 {

//Text File    (Die Guten ins Tpfchen, die schlechten ins Krpfchen)
//--------------------------------------------------------------------
 if (strstr($line,$startdet))
     //$txtfile .= strip_tags(trim($line)) . "\r\n" . "\r\n";

 if (strstr($line,'<b class="ch">Tagline:'))
     $txtfile .= strip_tags(trim($line)) . "\r\n" . "\r\n";

 if (strstr($line,'<b class="ch">Plot Outline:'))
     $txtfile .= strip_tags(trim($line)) . "\r\n" . "\r\n";

 if (strstr($line,'<b class="ch">Plot Summary:'))
     $txtfile .= strip_tags(trim($line)) . "\r\n" . "\r\n";

 if (strstr($line,'<b class="ch">Runtime:'))
     $txtfile .= str_replace('Runtime: ','Runtime:  ' ,strip_tags(trim($line))) . ' ';

 if (strstr($line,' min '))
     $txtfile .= strip_tags(trim($line)) . "\r\n";

 if (strstr($line,'/Sections/Countries/'))
     $txtfile .= 'Country: ' . strip_tags(trim($line)) . "\r\n";

 if (strstr($line,'/Sections/Languages'))
     $txtfile .= 'Language ' . strip_tags(trim($line)) . "\r\n";

//------------------------------------------

 if (strstr($line,'table cellpadding="2" cellspacing="2" border="0"'))
    $uncount=$uncount+8;

 if (trim($line)=='')
    $uncount=$uncount+1;

 if (substr($line,0,3)=='<p>')
    $uncount=$uncount+1;

//VOte etc.

 if (strstr($line,'a href="http://www.imdb.com/rg/title-tease/rating-stars/title'))
    $uncount=$uncount+1;

// if (strstr($line,'<b class="ch">Color:'))
//    $uncount=$uncount+3;


 if (strstr($line,'a href="/rg/title-tease/rating-stars/title/'))
    $uncount=$uncount+1;

 if (strstr($line,'a href="/top_250_films"'))
    $uncount=$uncount+1;

 if (strstr($line,'a href="/rg/title-tease/rating-vote'))
    $uncount=$uncount+1;

 if (strstr($line,'a href="http://www.imdb.com/rg/title-tease/rating-vote/title'))
    $uncount=$uncount+1;

 if (strstr($line,'a name="poster" href=') or strstr($line,'a name="poster" >'))
    {
    $gfxname=substr($line,strpos(strtolower($line),'src="')+5,(strpos(strtolower($line),'.jpg')) - (strpos(strtolower($line),'src="'))-1);
    $imdbgood.='<img src="' . $gfxname . '" height="140" width="94" alt="Film Cover">' . "\n";
    $uncount=$uncount+1;
    }

 if ($uncount>0)
    $uncount=$uncount-1;
 else
   $imdbgood.=$line . "\n";
 }

 $imdbgood.='</table><br><hr>' . "\n";

// Page Detail
//
  $page['headline']= '<font size="3">IMDB&nbsp;&nbsp;';


 create_file(OXYL_TEMP.'temp_imdb_debug.txt',$imdbgood);


  $page['body']['typ']='full';
  $page['body']['content']['full']=$imdbgood;

  $page['nav']['back']['image']=getimghref('oxyl_nav_top.gif');
  $page['nav']['back']['href']='oxyl_file_main.php?le=r&plmod='.$plmod.'&mode='.$mode.'&mode_1='.$mode_1.'&ap=' . urlencode($ap) . '&st=' . $st . '&his=' . $his . '&view=' . $view . '&ni=x';
//--------------Keys-----------------------------

if (get_ext($gfxname)=='jpg')
{
  $page['nav']['action'][0]['href']='oxyl_video_imdb.php?mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&fullcopy=' . $temptext . '&kopy=' . $gfxname . '&st=' . $st . '&his=' . $his . '&fname=' . urlencode($fname) . '&ap=' . urlencode($ap) . '&view=' . $view . '&ni=x';
  $page['nav']['action'][0]['key']=IR_TVID_KEYA;
  $page['nav']['action'][0]['button']=IR_ICON_KEYA;
  $page['nav']['action'][0]['text']= htmlspecialchars(trans('oxyl_file','save_full'));
}
else
{
// Nur Text kopieren
  $page['nav']['action'][0]['href']='oxyl_video_imdb.php?mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&fullcopy=' . $temptext . '&kopy=' . $gfxname . '&st=' . $st . '&his=' . $his . '&fname=' . urlencode($fname) . '&ap=' . urlencode($ap) . '&view=' . $view . '&ni=x';
  $page['nav']['action'][0]['key']=IR_TVID_KEYA;
  $page['nav']['action'][0]['button']=IR_ICON_KEYA;
  $page['nav']['action'][0]['text']= htmlspecialchars(trans('oxyl_file','save_text'));
}

if (get_ext($gfxname)=='jpg')
{
  $page['nav']['action'][1]['href']='oxyl_video_imdb.php?mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&kcopy=' . $gfxname . '&st=' . $st . '&his=' . $his . '&fname=' . urlencode($fname) . '&ap=' . urlencode($ap) . '&view=' . $view . '&ni=x';
  $page['nav']['action'][1]['key']=IR_TVID_KEYB;
  $page['nav']['action'][1]['button']=IR_ICON_KEYB;
  $page['nav']['action'][1]['text']= htmlspecialchars(trans('oxyl_file','save_cover'));
}
  $page['nav']['action'][2]['href']='oxyl_file_main.php?le=r&mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap=' . urlencode($ap) . '&st=' . $st . '&his=' . $his . '&view=' . $view . '&ni=x';
  $page['nav']['action'][2]['key']=IR_TVID_KEYC;
  $page['nav']['action'][2]['button']=IR_ICON_KEYC;
  $page['nav']['action'][2]['text']=htmlspecialchars(trans('','back'));


  $txtfile=str_replace('(more)','',$txtfile);
  $txtfile=str_replace('(view trailer)','',$txtfile);

// Link zu IMDB Detail zwischenspeichern
  create_file($tempimdb,$weburl . '/title/' .$detail);

// Text zwischenspeichern
  create_file($temptext,$txtfile);

  gen_full_page($page);
  @unlink($GLOBALS['temppath'].'/temp_imdb.txt');
  die();
}

// ............so long, and thanks for all the fish.......
//-----------------------------------------E-O-F----------------------------------------------
?>

