<?php
//###################################### Oxyl~Box 2.0.21 #####################################
//+-------------------------------------------------------------------------------------------
//| kernel:  design.inc
//| author : odu, diverse
//+-------------------------------------------------------------------------------------------
//| renders the webpages for oxyl
//+-------------------------------------------------------------------------------------------
//| GEN_HEADER ......... erzeugt Header
//| GEN_HEADER_REFRESH . erzeugt einen Weiterleitungsheader
//| GEN_HEADER_SETUP ... erzeugt Header fr Setup
//| GEN_HEADER_HELP .... erzeugt Header fr Hilfe
//| GEN_TITLE .......... erzeugt berschrift
//| GEN_TITLE_SETUP .... erzeugt berschrift fr Setup
//| GEN_DEFAUT_TITLE ... erzeugt berschrift fr default Pagedesign
//| GEN_NAVBAR ......... erzeugt Navigationsleiste oben
//| GEN_BODY ........... erzeugt Hauptbody
//| GEN_NAV_FOOTER ..... erzeugt Navigationsleiste unten
//| GEN_TVID_LINKS ..... erzeugt TVID Links
//| GEN_END ............ erzeugt HTML Ende, hier Platz fr Scripte...
//| GEN_NAVI_ICONS ..... erzeugt Navigationsbutton (back, down,..)
//| GEN_ICON_LINK ...... erzeugt Link mit Icon und Text
//| HELP ............... erzeugt Hilfelink (fr seperaten Aufruf, da schon in GEN_NAV_FOOTER)
//| GEN_FULL_PAGE_OXYL . erzeugt Page mit Oxylayout
//| GEN_FULL_PAGE ...... erzeugt Seite und entscheidet ob oxyldesign oder skindesign verwendet wird
//+--------------------------------------------------------------------------------------------
//|HISTORY:
//|        ...... odu      - design.inc erstellt
//| 040710 ...... .fischer - alle urlencode() durch SpecialCharReplace() ersetzt
//|                        - an jedes href="link" ein leerzeichen eingefgt > href="link "
//|                          sc-browser interpretiert links die mit einer extension .xxx enden
//|                          falsch - ein leerzeichen korrigiert dieses problem
//| 041031 ...... LongDan  - Design Anpassungen fr StartSeite
//|                        - Einbau Global Keys
//| 041108 ...... Gagamehl - Href einbau
//| 041113 ...... LongDan  - POD fr Lines eingebaut
//| 041113 ...... LongDan  - Global-Keys Oxyl-Weit aktiv, wenn nicht vom Plugin anders gesetzt!
//| 041114 ...... LongDan  - ONFOCUSSRC eingebaut
//| 041121 ...... stolle   - pod fr Keys eingebaut, vod korrigiert
//| 050109 ...... Brause   - Link fuer Fernbedieunungsbutton "Home" eingefuegt
//|                        - Haupttabelle Groessenangaben geaendert
//| 050112 ...... Brause   - gen_full_page_oxyl in funktion unterteilt um von anderen PlugIns
//|                          direkt auf alle einzelnen Designelemente zuzugreifen
//|                        - skin/const.inc wird jetzt immer included
//|                        - Gre der Icons ber Skin einstellbat (skin/const.inc)
//| 050120 ...... Brause   - Nullcaching von Dateien bei PC hinzugefgt
//| 050126 ...... Brause   - FIX: maxchars wurde nicht an alle Funktionen bergeben
//|                        - FIX: falsche Parameterannahme bei Funktionen
//| 050307 ...... Brause   - CHANGE: include_once von functions.inc entfernt,
//|                          da bereits in const.inc vorhanden
//| 050319 ...... Gaga     - RELEASE: v20
//| 050508 ...... Gaga     - RELEASE: v21
//| 050328 ...... Brause   - NEW: Hardwareabhngige Links und TVIDs kommen jetzt aus ir_layout.inc
//| 050410 ...... Brause   - FIX: wenn skin ber Startseite gewechselt wurde, wurden falsche Icongren dargestellt
//| 050508 ...... Brause   - CHANGE: darstellung falscher Icongren nur in oxylstart.php gelt
//|                        - CHANGE: include_once von functions.inc wieder hinzu
//|                        - CHANGE: $GLOBALS ['OXYL_ROOT'] anstatt _SERVER['DOCUMENT_ROOT']
//|                        - FIX: Fehlernoticen entfernt
//| 050605 ...... Brause   - CHANGE: GEN_USERLEVELPOPUP aus design.inc jetzt in functions.inc
//|                        - NEW: Funktion GEN_HEADER_HELP
//| 050608 ...... Brause   - CHANGE: GLOBALS 'OXYL_ROOT' durch Konstanten ersetzt
//| 050614 ...... Brause   - RELEASE: v22
//| 050616 ...... Brause   - Code entschlackt, Header nach Pinnaclevorbild umgebaut
//| 050617 ...... Brause   - RELEASE: v24
//| 050628 ...... Brause   - FIX: (&$page durch ($page ersetzt, besonders aufrufe mit gen_full_page(&$page) fhrten zu fehlern
//| 050629 ...... Brause   - RELEASE: v27
//| 050630 ...... Brause   - NEW: Funktion gen_navi_icons() & gen_icon_link()
//| 050709 ...... Brause   - NEW: gen_header_refresh()
//| 050829 ...... Brause   - RELEASE: v29
//| 050917 ...... Brause   - RELEASE: v30
//| 060221 ...... Brause   - NEW: OXYLBOX_VERSION, OXYL_RELEASE, OXYLBOX_KERN, OXYLBOX_BRAND als constante hinzu
//| 060221 ...... Brause   - RELEASE: v35
//+-------------------------------------------------------------------------------------------

  include_once('functions.inc');

  // skin/design.inc wird jetzt immer included
  if (file_exists(OXYL_SKIN.$GLOBALS['actskin'].'/design.inc'))
     include_once(OXYL_SKIN.$GLOBALS['actskin'].'/design.inc');

  // ICON Gren werden festgelegt
  if(!defined('ICON_START_HEIGHT'))  define('ICON_START_HEIGHT'  ,32);
  if(!defined('ICON_START_WIDTH'))   define('ICON_START_WIDTH'   ,32);
  if(!defined('ICON_BUTTON_HEIGHT')) define('ICON_BUTTON_HEIGHT' ,25);
  if(!defined('ICON_BUTTON_WIDTH'))  define('ICON_BUTTON_WIDTH'  ,25);
  if(!defined('ICON_SMALL_HEIGHT'))  define('ICON_SMALL_HEIGHT'  ,25);
  if(!defined('ICON_SMALL_WIDTH'))   define('ICON_SMALL_WIDTH'   ,25);
  if(!defined('ICON_ARROW_HEIGHT'))  define('ICON_ARROW_HEIGHT'  ,25);
  if(!defined('ICON_ARROW_WIDTH'))   define('ICON_ARROW_WIDTH'   ,25);
  if(!defined('ICON_BIG_HEIGHT'))    define('ICON_BIG_HEIGHT'    ,50);
  if(!defined('ICON_BIG_WIDTH'))     define('ICON_BIG_WIDTH'     ,50);

  // Seitengren werden festgelegt
  if(!defined('LAYOUT_BODY_WIDTH'))  define('LAYOUT_BODY_WIDTH'  ,$GLOBALS['showcenter'] ? 618 : 624);
  if(!defined('LAYOUT_BODY_HEIGHT')) define('LAYOUT_BODY_HEIGHT' ,488);
  if(!defined('LAYOUT_TABLE_WIDTH')) define('LAYOUT_TABLE_WIDTH' ,600);
  if(!defined('LAYOUT_NAVI_HEIGHT')) define('LAYOUT_NAVI_HEIGHT' , 91);

//+-------------------------------------------------------------------------------------------
//|FUNKTION: GEN_HEADER
//| generates header for box
//| $full ....... Auswahl ob nach Anwahl einer Mediendatei diese Fullscreen oder PIP
//|               wiedergegeben werden soll (optional - DEFAULT FALSE/Fullscreen)
//| $pip ........ Ob PIP aktiviert oder deaktiviert sein soll (optional - DEFAULT TRUE/aktiviert)
//|HISTORY:
//|        ...... odu? Funktion erstellt
//| 040711 ...... .fischer - Ergnzung um Parameter $pip (z.B. fr Bilder keine PIP notwendig)
//| 041205 ...... LongDan  - Ergnzung um Parameter $htmtitel 
//| 050111 ...... Brause   - Focusfarben zugefuegt, werden in skin design.inc definiert
//|                        - Doctype zugefuegt (HTML konform)
//|                        - Hintergrund zugefuegt (da bei Hintergrundbild PIP deaktiviert
//|                          ist dies ueber config einstellbar
//| 050120 ...... Brause   - noCaching for PC hinzu
//| 050605 ...... Brause   - FIX: mit Hintergrundbild
//| 050616 ...... Brause   - CHANGE: angepasste bernahme von Pinnacle
//| 050617 ...... Brause   - vereinfacht, Caching entfernt
//|                        - meta IR KEY entfernt, jetzt lassen sich die links wieder ansurfen
//+-------------------------------------------------------------------------------------------
  function gen_header($full=false,$pip=true,$pipx=32,$pipy=32,$piph=176,$pipw=112,$htmtitel='')//pip werte mssen durch 16 teilbar sein
  {
    if($htmtitel=='')$htmtitel=strtoupper(OXYLBOX_BRAND).' '.OXYLBOX_VERSION;
    $out = $full ? FALSE : TRUE; //gibt an ob bei der Auswahl der Start der Wiedergabe als PIP oder FULLSCREEN erfolgen soll

	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'."\n"
	    .'<html>'."\n"
        .'<head>'."\n"
        .'<meta SYABAS-FULLSCREEN>'."\n"
        .'<meta syabas-keyoption="lowercase">'."\n"
	    //.'<meta IRKEY="9,132">'."\n"
		.( $GLOBALS['PIP_DISABLE']&&$GLOBALS['showcenter'] ? '<meta SYABAS-BACKGROUND="'.getimghref('oxyl_back.jpg').'">'."\n" : '')
        .( $pip && !$GLOBALS['PIP_DISABLE'] ? '<meta myibox-pip="'.$pipx.','.$pipy.','.$piph.','.$pipw.','. $out .'">'."\n" : '')
        .'<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">'."\n"
        .'<meta name="generator" content="lyra-box UI">'."\n"
        .'<title>' . $htmtitel . '</title>'."\n";
    include (getstyle());
    echo '</head>'."\n"
	    .'<body onLoadSet="MyFocus"'
	    .(defined('FOCUS_COLOR') ? ' FOCUSCOLOR="'.FOCUS_COLOR.'"' : '')
	    .(defined('FOCUS_TEXT')  ? ' FOCUSTEXT ="'.FOCUS_TEXT.'"'  : '')
	    .(!$GLOBALS['showcenter']||!$GLOBALS['PIP_DISABLE'] ? ' background="'.getimghref('oxyl_back.png').'"' : '')
	    .' TOPMARGIN=0 LEFTMARGIN=0 MARGINHEIGHT=0 MARGINWIDTH=0>'."\n";
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_header_refresh
//| generate redirector
//| $url ........ Weiterleitungsurl
//| $time ....... Weiterleitungszeit
//|HISTORY:
//| 050709 ...... Brause   - erstellt
//+-------------------------------------------------------------------------------------------
  function gen_header_refresh($url,$time=0)
  {
 	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'."\n"
	    .'<html>'."\n"
        .'<head>'."\n"
        .'<meta SYABAS-FULLSCREEN>'."\n"
        .'<meta syabas-keyoption="lowercase">'."\n"
	    .( $GLOBALS['PIP_DISABLE']&&$GLOBALS['showcenter'] ? '<meta SYABAS-BACKGROUND="'.getimghref('oxyl_back.jpg').'">'."\n" : '')
        .'<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">'."\n"
        .'<meta name="generator" content="lyra-box UI">'."\n"
		.'<meta http-equiv="refresh" content="'.$time.'; URL='.$url.'">'
        .'<title>'.strtoupper(OXYLBOX_BRAND).'~Redirector '.OXYLBOX_VERSION.'</title>'."\n";
    include (getstyle());
    echo '</head>'."\n"
	    .'<body onLoadSet="MyFocus"'
	    .(defined('FOCUS_COLOR') ? ' FOCUSCOLOR="'.FOCUS_COLOR.'"' : '')
	    .(defined('FOCUS_TEXT')  ? ' FOCUSTEXT ="'.FOCUS_TEXT.'"'  : '')
	    .' background="'.getimghref('oxyl_back.png').'"'
	    .' TOPMARGIN=0 LEFTMARGIN=0 MARGINHEIGHT=0 MARGINWIDTH=0>'."\n";
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_header_setup
//| generates header for boxsetup
//|HISTORY:
//| 050111 ...... Brause   - Focusfarben zugefuegt, werden in skin design.inc definiert
//|                        - Doctype zugefuegt (HTML konform)
//| 050120 ...... Brause   - no Caching hinzugefgt
//| 050617 ...... Brause   - vereinfacht, Caching entfernt
//+-------------------------------------------------------------------------------------------
  function gen_header_setup()
  {
 	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'."\n"
	    .'<html>'."\n"
        .'<head>'."\n"
        .'<meta SYABAS-FULLSCREEN>'."\n"
        .'<meta syabas-keyoption="lowercase">'."\n"
	    .'<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">'."\n"
        .'<meta name="generator" content="lyra-box UI">'."\n"
        .'<title>'.strtoupper(OXYLBOX_BRAND).'~SETUP '.OXYLBOX_VERSION.'</title>'."\n";
    include (getstyle());
    echo '</head>'."\n"
	    .'<body onLoadSet="MyFocus"'
	    .(defined('FOCUS_COLOR') ? ' FOCUSCOLOR="'.FOCUS_COLOR.'"' : '')
	    .(defined('FOCUS_TEXT')  ? ' FOCUSTEXT ="'.FOCUS_TEXT.'"'  : '')
	    .' background="'.getimghref('oxyl_backsetup.png').'"'
	    .' TOPMARGIN=0 LEFTMARGIN=0 MARGINHEIGHT=0 MARGINWIDTH=0>'."\n";
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_header_help
//| generates header for help
//|HISTORY:
//| 050605 ...... Brause   - erstellt
//| 050617 ...... Brause   - vereinfacht, Caching entfernt
//+-------------------------------------------------------------------------------------------
  function gen_header_help()
  {
 	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'."\n"
	    .'<html>'."\n"
        .'<head>'."\n"
        .'<meta SYABAS-FULLSCREEN>'."\n"
        .( $GLOBALS['PIP_DISABLE']&&$GLOBALS['showcenter'] ? '<meta SYABAS-BACKGROUND="'.getimghref('oxyl_backhelp.jpg').'">'."\n" : '')
        .'<meta syabas-keyoption="lowercase">'."\n"
	    .( !$GLOBALS['PIP_DISABLE'] ? '<meta myibox-pip="32,288,176,112,1">'."\n" : '')
        .'<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">'."\n"
        .'<meta name="generator" content="lyra-box UI">'."\n"
        .'<title>'.strtoupper(OXYLBOX_BRAND).'~HELP '.OXYLBOX_VERSION.'</title>'."\n";
    include (getstyle());
    echo '</head>'."\n"
	    .'<body onLoadSet="MyFocus"'
	    .(defined('FOCUS_COLOR') ? ' FOCUSCOLOR="'.FOCUS_COLOR.'"' : '')
	    .(defined('FOCUS_TEXT')  ? ' FOCUSTEXT ="'.FOCUS_TEXT.'"'  : '')
	    .(!$GLOBALS['showcenter']||!$GLOBALS['PIP_DISABLE'] ? ' background="'.getimghref('oxyl_backhelp.png').'"' : '')
	    .' TOPMARGIN=0 LEFTMARGIN=0 MARGINHEIGHT=0 MARGINWIDTH=0>'."\n";
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_title
//| generates header for box / not used by default page design
//| $image ...... href of source for header
//| $title ...... title
//|HISTORY:
//+-------------------------------------------------------------------------------------------
  function gen_title($image='',$title='')
  {
    echo ($image!='' ? '<img src="'.OXYL_WEB.'/images/'.$image.'">&nbsp;&nbsp;' : '')
         .'<table><tr><td valign="middle">'
         .'<span class="titel">'.$title.'</span>'
         .'</td></tr></table>';
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_title_setup
//| generates header for box setup / not used by default page design
//| $image ...... href of source for header
//| $title ...... title
//|HISTORY:
//+-------------------------------------------------------------------------------------------
  function gen_title_setup($image='',$title='')
  {
    echo ($image!='' ? '<img src="'.OXYL_WEB.'/images/'.$image.'">&nbsp;&nbsp;' : '')
         .'<table><tr><td valign="middle">'
         .'<span class="titel">'.$title.'</span>'
         .'</td></tr></table>';
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_default_title
//| generates header for box / is used by default page design
//|HISTORY:
//| 050111 ...... Brause   - Funtion aus gen_full_page_oxyl ausgelst
//+-------------------------------------------------------------------------------------------
  function gen_default_title($page){
    echo '<tr><td valign="middle">'
        .'<span class="titel">'.$page['headline'].'</span>'
        .($GLOBALS['show_clock']==1 ? '</td><td align="right">' . date("H:i:s")."\n" : '')// Show Clock
        .'</td></tr>';
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_navbar
//| generates head includes backbuttons and title
//|HISTORY:
//| 050111 ...... Brause   - Funtion aus gen_full_page_oxyl ausgelst
//| 050630 ...... Brause   - NEW: gen_navi_icons() & gen_icon_link()
//+-------------------------------------------------------------------------------------------
  function gen_navbar($page,$maxchars=0){
    if(!$maxchars)$maxchars=$GLOBALS["maxchars"];

    // titel backcolor    
    echo (isset($page['design']['table']['color']) ?
         '<tr><td bgcolor="'.$page['design']['table']['color'].'" valign="middle">'."\n" :
         '<tr><td valign="middle">')
        .'<table cellpadding=0 cellspacing=0 border=0><tr>';

    gen_navi_icons($page); //erzeugt navigationspfeile

	echo '<td>';

    // show action top buttons
    if (isset($page['nav']['action']))
    { 
      reset($page['nav']['action']);
      foreach($page['nav']['action'] as $cont)
      {
	    if (isset($cont['top']))
          echo '&nbsp;'.gen_icon_link($cont,$maxchars,ICON_ARROW_WIDTH,ICON_ARROW_HEIGHT)."\n";
      }
    }

    // show navigation text and sort button
    echo (isset($page['nav']['text']) ? '&nbsp;('.dotrunc($page['nav']['text'],(isset($page['nav']['text_max']) ? $page['nav']['text_max']:20),true,'L').')' : '')
	    .(isset($page['nav']['desc']) ? '&nbsp;&nbsp;'.gen_icon_link($page['nav']['desc'],$maxchars,ICON_ARROW_WIDTH,ICON_ARROW_HEIGHT) : '')
        .(isset($page['nav']['sort']) ? '&nbsp<a href="'.$page['nav']['sort']['href'].'">'.$page['nav']['sort']['text'].'</a>' : '')
		.'</td></tr></table>'
        .'</td></tr>'."\n";
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_body
//| generates head includes backbuttons and title
//|HISTORY:
//| 050111 ...... Brause   - Funtion aus gen_full_page_oxyl ausgelst
//| 050630 ...... Brause   - NEW: gen_icon_link()
//+-------------------------------------------------------------------------------------------
  function gen_body($page,$maxchars=0){
    if(!$maxchars)$maxchars=$GLOBALS["maxchars"];

    echo '<tr><td valign="top" nowrap>';
    
    // body type lines
    if (isset($page['body']['typ']) && ($page['body']['typ']=='lines'))
    {
      if (isset($page['body']['content']))
      {
        // LD MOD
        echo '<table cellpadding=0 cellspacing=0 border=0 width="100%"><tr><td>'.gen_transpic(LAYOUT_BODY_HEIGHT-LAYOUT_NAVI_HEIGHT,1).'</td>'
		    .'<td valign="top"><table cellpadding=0 cellspacing=0 border=0 width="100%">'
			.'<tr><td height=5 colspan=2></td></tr>'."\n";

        reset($page['body']['content']);
        foreach($page['body']['content'] as $line)
        {
         // LD MOD
         echo '<tr>'
             //.'<td valign="left" nowrap><table cellspacing=0 cellspacing=0 border=0><tr><td align="left" class="text_back" nowrap>'
             .'<td align="left" class="text_back" nowrap>'
             .gen_icon_link($line,$maxchars,ICON_SMALL_WIDTH,ICON_SMALL_HEIGHT,TRUE)
             //.'</td></tr></table>'
             .'</td><td width="90%">'.gen_transpic(ICON_SMALL_HEIGHT+2,1)
             .(isset($line['eol']) ? $line['eol'] : '')
             .'&nbsp;</td></tr>'."\n";       
        }
        echo '</table></td><tr></table>';
      }
    }
    // body type full content created by plugin
    if (isset($page['body']['typ']) && ($page['body']['typ']=='full'))
      echo $page['body']['content']['full'];
    echo '</td></tr>'."\n";
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_nav_footer
//| generates head includes backbuttons and title
//|HISTORY:
//| 050111 ...... Brause   - Funtion aus gen_full_page_oxyl ausgelst
//| 050217 ...... Brause   - unterscheidung der Hardware bei den abc? Tasten
//|                          Neuston und Elegato haben andere Button (red,blau,..)
//|                          Button nur bei Showcenter, Neuston, Elegato und PC verfgbar
//| 050310 ...... Brause   - FIX: wenn Button fr Hardware nicht vorhanden, dann war kein Login mglich
//| 050328 ...... Brause   - NEW: Hardwareabhngige Button und TVIDs kommen aus ir_layout.inc
//| 050607 ...... Brause   - NEW: mit $GLOBALS['NO_DIRECT_SETUP_ACCESS'] lt sich der Zugriff auf Setup direkt 
//|                          vom Plugin abschalten
//|                        - NEW: $cont['space_after'] fgt abstand nach ABC Button ein, Wert gleich Abstand in Pixel
//| 050630 ...... Brause   - NEW: gen_navi_icons() & gen_icon_link()
//| 050705 ...... Brause   - NEW: mit $page['nav']['action']['no_footer_navi'] werden keine navi icons angezeigt
//+-------------------------------------------------------------------------------------------
  function gen_nav_footer($page,$maxchars=0){
    if(!$maxchars)$maxchars=$GLOBALS["maxchars"];

    echo '<tr><td valign="middle"'.($page['headline']=='START' ? ' align="center"':'').'>'
        .'<table cellpadding=0 cellspacing=0 border=0><tr>';

	if(!isset($page['nav']['action']['no_footer_navi'])&&$page['headline']<>'START')
      gen_navi_icons($page); //erzeugt navigationspfeile

	echo '<td nowrap>';

	// ABC? Button
    if (isset($page['nav']['action'])) 
    {
      ksort($page['nav']['action']);
      reset($page['nav']['action']);
      foreach($page['nav']['action'] as $cont)
      {
        if (isset($cont['key']))
	      echo '&nbsp;'.gen_icon_link($cont,$maxchars,ICON_BUTTON_WIDTH,ICON_BUTTON_HEIGHT,TRUE,'footer');
      }
    }

	// help button
	if (isset($page['help']['href']) && isset($page['help']['backhref'])) // kompatibilitt fr alte help button
	{
	   $help['href']   = OXYL_WEB.'/common/help.php?bl='.SpecialCharReplace($page['help']['backhref']).'&hf='.SpecialCharReplace($page['help']['href']);
	   $help['text']   = trans('','help');
	   $help['key']    = IR_TVID_HELP;
       $help['button'] = IR_ICON_HELP;

	   echo '&nbsp;'.gen_icon_link($help,$maxchars,ICON_BUTTON_WIDTH,ICON_BUTTON_HEIGHT,TRUE,'footer');
	}

	//stellt setup button zu Verfgung => kompatibilitt fr setup help button
    if($page['headline']<>'START'&&$GLOBALS['actuserlevel']==0&&!$GLOBALS['showcenter']&&!isset($GLOBALS['NO_DIRECT_SETUP_ACCESS'])&&$GLOBALS['VIEW_SETUP']){//stellt SETUP Button bei jedem Plugin zu Verfgung 
	  $pfad_array = explode("/",$_SERVER["PHP_SELF"]);
	  foreach($pfad_array as $key => $pfad)
	   if($pfad=="plugins") $plugin = $pfad_array[$key+1];

	  if(isset($plugin))
	    $contents = read_plugin_cfg($plugin);

      if(isset($contents['setup']))
	  {
	    $setup['href']   = OXYL_WEB.'/plugins/'.$plugin.'/'.$contents['setup'];
		$setup['text']   = trans('','setup');
		$setup['button'] = $contents['image'];

		echo '&nbsp;'.gen_icon_link($setup,$maxchars,ICON_BUTTON_WIDTH,ICON_BUTTON_HEIGHT,TRUE,'footer');

	  }
	}
    echo '</td></tr></table>'
	    .'</td></tr>'."\n";
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_tvid_links
//| generates head includes backbuttons and title
//|HISTORY:
//| 050123 ...... Brause   - Funktion erstellt
//| 050302 ...... Brause   - Change: ob Showcenter wird jetzt vor Funktionaufruf geprft
//| 050327 ...... Brause   - NEW: neue Button in Variable $page['nav']['misc']
//|                        - NEW: TVIDs kommen aus ir_layout.inc
//| 050709 ...... Brause   - CHANGE: Umstellung auf UniversalExplorer
//+-------------------------------------------------------------------------------------------
  function gen_tvid_links($page){

	// von user gespeicherten und sys tvid links
    echo list_gkeys();

    // weitere links zu finden in $page['nav']['misc']
	if (isset($page['nav']['misc'])) 
       foreach($page['nav']['misc'] as $miscs)
	     echo '<a href="'.$miscs['href'].'" TVID='.$miscs['key'].'></a>'."\n";

	// stellt Seitenregister dar, z.Zt. in oxyl_pic, vid und mp3 benutzt
	if($GLOBALS['SITE_NAV']&&isset($page['nav']['sitekeys']))// ruft Direktzugriff per Tasten auf Seitenregister auf
      echo list_sitekeys($page['nav']['sitekeys']['href'],$page['nav']['sitekeys']['sites']);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_end
//| generates end
//|HISTORY:
//| 050509 ...... brause   - CHANGE: Rendertime und sysvars hinzu
//| 050605 ...... brause   - FIX: body und html muss letzter Tag sein
//| 050630 ...... Brause   - NEW: gen_end gibt jetzt auch javascript wieder
//+-------------------------------------------------------------------------------------------
  function gen_end($page=''){
	if($GLOBALS["VIEW_SYS_VARS"])//stellt systemvariablen dar
      view_sysvars();

    if($GLOBALS["VIEW_RENDERTIME"])// stopt timer und zeigt rendertime
	{
	  $rendertime = number_format(skriptingtime_stop(), 4);
      echo '<br><br>&nbsp;<a href="'.$_SERVER["REQUEST_URI"].'">'.$rendertime.' sec.msec</a><br><br>';
	  check_dirs(OXYL_TEMP.'stats');
	  $url_arr = parse_url(OXYL_WEB.$_SERVER["REQUEST_URI"]);
	  $path  = isset($url_arr['path'])  ? $url_arr['path']  : '';
	  $query = isset($url_arr['query']) ? $url_arr['query'] : '';
	  create_file(OXYL_TEMP.'stats/rendertime.txt',$path.'|'.$query.'|'.time().'|'.$rendertime."\r\n",'a');
	}

    echo '</body>'."\n"
	    .(isset($page['body']['javascript'])? $page['body']['javascript'] : '')
		.'</html>';
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_navi_icons
//| generates Navigationsbutton (back, down,..)
//|HISTORY:
//| 050630 ...... Brause   - Funktion aus gen_navbar und gen_nav_footer ausgelst
//+-------------------------------------------------------------------------------------------
  function gen_navi_icons($page){
    // back button
	echo '<td width='.ICON_ARROW_WIDTH.'>'
	    .(isset($page['nav']['back']['image']) ?
         '<a href="'.$page['nav']['back']['href'].' " '
	    .(isset($page['nav']['back']['fo'])?$page['nav']['back']['fo']:'').'>'
        .'<img src="'.$page['nav']['back']['image'].'" border=0 width='.ICON_ARROW_WIDTH.' height='.ICON_ARROW_HEIGHT.' align="absmiddle">'
        .'</a>' :'')
		.'</td>'

		.'<td width=5></td>'

    // page down button
        .'<td width='.ICON_ARROW_WIDTH.'>'
	    .(isset($page['nav']['left']['image']) ?
         '<a href="'.$page['nav']['left']['href'].' " '.(isset($page['nav']['left']['fo'])? $page['nav']['left']['fo'] : '').'>'
        .'<img src="'.$page['nav']['left']['image'].'" border=0 width='.ICON_ARROW_WIDTH.' height='.ICON_ARROW_HEIGHT.' align="absmiddle">'
        .'</a>':'')
		.'</td>'

    // navigation sets
        .'<td width=70 align="center">'
	    .(isset($page['nav']['set']['pages']) ?
         '('.$page['nav']['set']['pages'].'/'.$page['nav']['set']['countpages'].')' :'')
		.'</td>'

    // page up button
        .'<td width='.ICON_ARROW_WIDTH.'>'
	    .(isset($page['nav']['right']['image']) ?
         '<a href="'.$page['nav']['right']['href'].' " '.(isset($page['nav']['right']['fo'])?$page['nav']['right']['fo']:'').'>'
        .'<img src="'.$page['nav']['right']['image'].'" border=0 width='.ICON_ARROW_WIDTH.' height='.ICON_ARROW_HEIGHT.' align="absmiddle">'
        .'</a>':'')
		.'</td>';
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_icon_link
//| generates link mit Icon
//|HISTORY:
//| 050630 ...... Brause   - Funktion aus gen_navbar und gen_body ausgelst
//| 050917 ...... Brause   - FIX: falsche Image auswertung
//+-------------------------------------------------------------------------------------------
  function gen_icon_link($line,$maxchars=0,$WIDTH=ICON_SMALL_WIDTH,$HEIGHT=ICON_SMALL_HEIGHT,$TEXT=FALSE,$WHO=''){
    if(!$maxchars)$maxchars=$GLOBALS["maxchars"];

    $var=(isset($line['href']) ?
         (isset($line['update'])? '<a href="'.$line['href'].' " update':
         ($line['href']=='MUTE' ? '<a href="'.$line['href'].'"' : '<a href="'.$line['href'].' "')):'')
        .(isset($line['key']) ?
         ' TVID="'.$line['key'].'"' : '')
        .(isset($line['target']) ?
         ' target="'.$line['target'].'"' : '')
        .(isset($line['aod']) ?
         ' aod="'.$line['aod'].'"' : '')
        .(isset($line['vod']) ?
         ' vod="'.$line['vod'].'"' : '')
        .(isset($line['pod']) ?
         ' pod="'.$line['pod'].'"' : '')
        .(isset($line['href']) ?
         '>' : '')
        .(isset($line['button']) && $WHO=='footer' ?
         '<img src="'.getimghref($line['button'],'').'" ' :
         (isset($line['image'])  ?
         '<img src="'.$line['image'].'" ' : ''))
		.(isset($line['onfocus']) ?
         ' ONFOCUSSRC="' . $line['onfocus'] . '" ' : '')
        .(isset($line['image'])||(isset($line['button']) && $WHO=='footer') ?
         ' height='.$HEIGHT.' width='.$WIDTH.' border=0 align="absmiddle">' : '')
        .(isset($line['text']) && $TEXT ?
         gen_transpic($HEIGHT,3,'align="absmiddle"').dotrunc($line['text'],$maxchars,true,'R') : '')
        .(isset($line['href']) ?
         '</a>' : '')
		.(isset($line['space_after']) && $WHO=='footer' ?
		 gen_transpic(1,$line['space_after'],' align="absmiddle"'):'');
  return $var;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: help
//| generates help page
//| $backlink ... fulllink to switch back to foreign page
//| $helpfile ... url to helfile without language and .inc
//|HISTORY:
//| 050328 ...... Brause   - NEW: TVIDs kommen aus ir_layout.inc
//+-------------------------------------------------------------------------------------------
  function help($backlink,$helpfile)
  {
    echo '<a href="'.OXYL_WEB.'/common/help.php?bl='.SpecialCharReplace($backlink).'&hf='.SpecialCharReplace($helpfile).' " TVID="'.IR_TVID_HELP.'">'.gen_button(IR_ICON_HELP).'</a>'."\n";
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_full_page_oxyl
//| this is the default template
//| $page ....... array for this template
//|HISTORY:
//| 050111 ...... Brause   - Funtion aus gen_full_page_oxyl ausgelst
//|                        - Title erzeugt gen_default_title
//|                        - Navigation Bar oben erzeugt gen_navbar
//|                        - Body erzeugt gen_body
//|                        - Navigation Bar unten erzeugt gen_navbar_footer
//| 050122 ...... Brause   - $maxchars default wert aus const.inc
//| 050126 ...... Brause   - FIX: Parameter $maxchars wurde bei body und footer nicht bergeben
//+-------------------------------------------------------------------------------------------
  function gen_full_page_oxyl($page,$maxchars=0){
  if(!$maxchars)$maxchars=$GLOBALS["maxchars"];

    if (isset($page['mode']) && ($page['mode']=='full'))
      gen_header(true);
    else
      gen_header(false);

    // MUTTER TABELLE (umfasst den kompletten body, fr leichtere Layoutanpassung)
    if (!isset($page['headline'])) $page['headline'] = 'Infos';

	echo '<table width='.LAYOUT_BODY_WIDTH.' cellspacing=2 cellpadding=0 border=0'
	    .($GLOBALS['showcenter'] ? ' align="center"':'').'>'."\n";

   // TITLE & NAVIGATION BAR -----------------------------------------------------------------

    if ($page['headline']<>'START')
    {
	  gen_default_title($page,$maxchars);
	  gen_navbar($page,$maxchars);
    }

   // BODY ----------------------------------------------------------------------------------
   gen_body($page,$maxchars);

   // NAVIGATION BOTTOM ----------------------------------------------------------------------
   gen_nav_footer($page,$maxchars);

   // END MUTTER TABELLE
    echo '</table>';

   // TVID Links-----------------------------------------------------------------------------
    if ($GLOBALS['showcenter'])
	   gen_tvid_links($page);

   // END --------------------------------------------------------------------------------
    gen_end($page);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_full_page
//| generates whole page for plugins with template
//| if file design.inc in actual skin exists include this file
//| in the design.inc a function gen_full_page_skin($page) has to be definde
//| if $skin_design is set
//| $page ....... array for this template
//|HISTORY:
//| 050112 ...... brause   - skin/design.inc wird jetzt immer geladen (soweit vorhanden)
//| 050120 ...... brause   - FIX: seperates Skin Design wurde ignoriert
//| 050302 ...... brause   - FIX: Rendertime (wenn aktiviert) war nicht immer auf SC sichtbar
//| 050509 ...... brause   - CHANGE: Rendertime und sysvars jetzt in gen_end()
//+-------------------------------------------------------------------------------------------
  function gen_full_page($page){
  global $skin_design;

   if (isset($skin_design))
      gen_full_page_skin($page);
   else
      gen_full_page_oxyl($page);
  }
//---------------------------------------------E-O-F------------------------------------------------
?>
