<?php
//###################################### Oxyl~Box 2.0.21 #####################################################
//+-------------------------------------------------------------------------------------------
//| include: function.inc
//| author : odu, gaga, stolle, fischer, LongDan, Brause
//+-------------------------------------------------------------------------------------------
//| collection of function
//+-------------------------------------------------------------------------------------------
//| GETFILES ........... liefert Datei/en und Ordner
//| GETDIRS ............ liefert Feld mit Verzeichnisnamen in gegebenem Verzeichnis
//| GETFILE ............ liefert erste Datei aus Pfad
//| GETVALIDFILES ...... liefert Dateien, die von Hardware dargestellt werden knnen
//| GETAUDIOS .......... liefert von Hardware unterstzte Audios
//| GETVIDEOS .......... liefert von Hardware unterstzte Videos
//| GETIMAGES .......... liefert von Hardware unterstzte Images
//| LINUX_STRCOLL ...... sortier Funktion "strcoll" fr Linux
//| LINUX_STRCOLL_R .... umkehrfunktion zu linux_strcoll
//| STRCASECMP_R ....... umkehrfunktion zu strcasecmp
//| STRCOLL_R .......... umkehrfunktion zu strcoll
//| STRNATCMP_R ........ umkehrfunktion zu strnatcmp
//| STRNATCASECMP_R .... umkehrfunktion zu strnatcasecmp
//| CHECK_GKEYS ........ checkt ob GLOBAL KEY schon vergeben
//| LIST_GKEYS ......... erstellt Linkliste mit GKEYS
//| LIST_SITEKEYS ...... erstellt Linkliste mit Direktzugriff auf Seitenregister
//| GET_PLAYLISTPATH ... Gibt den PlaylistPfad aus
//| GET_DEVICES ........ liefert Feld mit allen Eintrgen aus gegebener Datei
//| GETIMGHREF ......... liefert Bild passend zu Skin
//| GETURL ............. liefert gltige Web URL aus Dateipfad
//| SPECIALCHARREPLACE . macht Sonderzeichen darstellbar mit Ausnahme von /
//| OXYL_UTF8_DECODE ... macht utf8_decode wenn notwendig
//| TRANS .............. liefert bersetzung passend zu Plugin und Sprache
//| GETBASEDIR ......... liefert den Pfad des aktuellen Basisverzeichnisses zurck
//| GET_EXT ............ liefert Extensions aus Pfad/Dateinamen
//| DEL_EXT ............ lscht  Extensions aus Pfad/Dateinamen
//| DIR_NAME ........... liefert Pfad ohne Dateinamen (PHP Funktion basename spinnt bei backslashes)
//| CLEAR_NAME ......... subert Name, ersetzt z.B. - durch Leerzeichen
//| DOTRUNC ............ krzt Zeichenkette auf angegebene Lnge
//| DISP_SPECIAL ....... krzt $var um -, z.B. verwendet fr MP3 Special Ansicht
//| GETMIMETYPE ........ liefert MIMETYPE zurck
//| READ_PLUGIN_CFG .... Liest Config eines Plugins aus
//| READ_PLUGINORDER ... Liest Pluginorder.cfg aus
//| READ_PLUGINS ....... Liest Plugins aus
//| WRITE_PLUGINLOCKS .. sperrt Plugins
//| PUT_DEVICES ........ schreibt Devices
//| GETSTYLE ........... liefert Style zu Skin
//| GEN_BUTTON ......... liefert Button ???
//| GEN_TRANSPIC ....... erzeugt transparentes Bild
//| READ_SKINS ......... liest Skinconfig
//| CHECK_SKIN ......... kontrolliert Skin
//| READVERSION ........ liest Version der Plugins aus
//| GEN_USERLEVELPOPUP . erzeugt Popup mit Usern
//| GET_USERS .......... liefert user
//| SET_USER ........... speichert eingeloggten User
//| UNSET_USER ......... lscht User nach Logout
//| AKTIV_USER ......... ermittelt alle aktiven User (ohne direkten Remote User)
//| PUT_USERS .......... fgt User hinzu
//| READ_WEB ........... liest Weburl
//| GETSTREAMPORT ...... liest streamport aus config aus
//| BOX_LED_MODE ....... schaltet LED von Showcenter ein/aus
//| BOX_PBAR_POS ....... definiert die Position der Audio Progress Bar
//| BOX_REFRESH ........ lsst Showcenter refreshen
//| BOX_REMOTE ......... Steuert das Showcenter via TCP/IP
//| SUBTITLE_CHECK ..... Funktionen fr die Subtitel
//| REMOTE_FILE_EXISTS . prft ob URL existiert oder nicht
//| REMOTE_FILESIZE .... gibt filesize von remote Datei zurck
//| REMOTE_FILEMTIME ... gibt letztes Modifikationsdatum von remote Datei zurck
//| REMOTE_FILETYP ..... gibt mime typ von remote Datei wieder
//| GET_SERVER_HEADER .. forder Server zu http request auf
//| GET_FOLDERSIZE ..... gibt Gre von Ordner zurck
//| FORMAT_BYTESIZE .... formatiert bytes in lesbare Gre
//| FORMAT_NUMBER ...... formatiert Zahl mit tausender Trennzeichen
//| IP_CHECK ........... prft ob IP syntaktisch korrekt ist
//| THUMB_CACHING ...... speichert Liste mit erzeugten Thumbnails
//| GETTHUMBHREF ....... liefert Thumbnail falls vorhanden bzw. erstellt es
//| GETSIZE_MINIMAXI ... berechnet neue Bildgre ohne Verzerrung
//| DO_IMGCONVERT ...... konvertiert und/oder skaliert Bilder
//| DOWNLOAD_FILE ...... download a File (send to Box)
//| OXYL_ENCODE ........ "verschlsselt" bergabe Werte, dient um code sauberer zu bertragen
//| OXYL_DECODE ........ "entschlsselt" bergabe Werte, welche mit OXYL_ENCODE "verschlsselt" wurden
//| GETLASTPOS ......... liefert den Text von der letzten angeschauten Filmposition
//+-------------------------------------------------------------------------------------------
//|OLD FUNCTIONS: Don't use anymore !
//| GET_BASEDIR ........ liefert den Pfad des aktuellen Basisverzeichnisses zurck
//| IS_SHOWCENTER ...... berprft ob Client ein Pinnacle Showcenter bzw. Derivat ist oder nicht
//| READ_PLUGINS_CFG ... Liest Config eines Plugins aus
//+-------------------------------------------------------------------------------------------
//|HISTORY:
//| 050319 ...... Gaga     - RELEASE: v20
//| 050508 ...... Gaga     - RELEASE: v21
//| 050508 ...... Brause   - CHANGE: $GLOBALS ['OXYL_ROOT'] anstatt _SERVER['DOCUMENT_ROOT']
//|                        - FIX: Fehlernoticen entfernt
//| 050516 ...... Brause   - NEW: Funktion REMOTE_FILESIZE und REMOTE_FILEMTIME
//| 050517 ...... Brause   - NEW: Funktion CREATE_FILE
//| 050605 ...... Brause   - NEW: Funktion GET_FOLDERSIZE und FORMAT_BYTESIZE
//|                        - CHANGE: GEN_USERLEVELPOPUP aus design.inc jetzt in functions.inc
//| 050608 ...... Brause   - CHANGE: GLOBALS 'OXYL_ROOT' durch Konstanten ersetzt
//| 050612 ...... Brause   - NEW: Funktion READ_PLUGIN_CFG
//| 050614 ...... Brause   - RELEASE: v22
//| 050616 ...... Brause   - diverse FIXES und Code entschlackt
//| 050617 ...... Brause   - RELEASE: v24
//| 050625 ...... stolle   - video_geturl: Liefert eine URL fr ein Video (Bei NONE SC-Client)
//| 050629 ...... Brause   - RELEASE: v28
//| 050718 ...... Brause   - NEW: GET_BASEDIR; GETBASEDIR -> OLD Function
//|                        - CHANGE: SHOW_GKEY -> OLD Function; READ_PLUGINS_CFG umbenannt in READ_PLUGINORDER
//| 050826 ...... Brause   - CHANGE: VIDEO_GETURL -> OLD Function
//| 050829 ...... Brause   - RELEASE: v29
//| 051016 ...... Brause   - NEW: oxyl_utf8_decode; Thx to jjwin2k
//|                        - CHANGE: GETBASEDIR back from OLD Function
//|                        - CHANGE: SHOW_GKEY and VIDEO_GETURL gelscht
//|                        - CHANGE: STRRCASECMP umbenannt in STRCASECMP_R
//|                        - NEW: Funktionen LINUX_STRCOLL, LINUX_STRCOLL_R, STRCASECMP_R, STRCOLL_R
//|                                          STRNATCMP_R und STRNATCASECMP_R
//| 051024 ...... Brause   - RELEASE: v30
//| 051028 ...... Brause   - FIX: UNC Laufwerke funktionierten nicht
//| 051121 ...... Brause   - NEW: Datum und Gre in getfiles darstellen
//| 051121 ...... Brause   - RELEASE: v31
//| 060121 ...... Brause   - FIX: UNC Laufwerke wurden nicht zurckgegeben
//| 060121 ...... Brause   - RELEASE: v32
//| 060222 ...... Brause   - RELEASE: v35
//| 060407 ...... Brause   - NEW: getimagehref sucht auch nach png's
//| 060407 ...... Brause   - NEW: sicherere bertragung von Dateipfaden mit oxyl_decode
//| 060407 ...... Brause   - RELEASE: v36
//+-------------------------------------------------------------------------------------------

  include_once('const.inc');

//+-------------------------------------------------------------------------------------------
//|FUNKTION: GETFILES
//| liefert Feld mit Verzeichnis- bzw. Dateinamen in gegebenem Verzeichnis
//| $path ....... Pfad in welchem gesucht werden soll
//| $mask ....... Filter nach Datei Erweiterung (Dateiname muss damit enden)
//| $files ...... True/False Wert ob Dateien bzw. Verzeichnisse gesucht werden
//| $sub ........ ob Unterverzeichnisse auch durchsucht werden sollen
//| $firstfile .. ob nur das allererst gefunde File gefunden werden soll
//| $add_path ... ob bergabepfad vor den Dateinamen gestellt werden soll
//| $sort ....... nach was sortiert werden soll, time, time_desc, size, size_desc, name und name_desc
//| $view_value . ob Gre oder Datum angezeigt werden soll
//| $subdirfile . interner Schalter um arrays mit gre und zeit zu erhalten
//|HISTORY:
//|        ...... Odu? - erstellt
//| 040703 ...... .fischer - Filterung mit $mask auf Dateiende fixiert
//| 040917 ...... .fischer - Funktion umgestrickt damit auch Unterverzeichnisse mit erfasst werden knnen
//| 040918 ...... .fischer - max_execution_time nach Hinweis von Gagamehl eingebaut damit auch umfangreiche Verzeichnisscans ohne Timeout bewltigt werden knnen
//| 041110 ...... LongDan  - 'RECYCLER' & 'System Volume Information' erscheinen
//|                          nicht mehr in der DateiListe (Windows spezifisch!)
//| 041210 ...... LongDan  - Get_files kreiert
//| 050114 ...... Brause   - Array Reset hinzu
//|                        - GETFILES UND GET_FILES zusammengelegt, da doppel funktion
//| 050126 ...... Brause   - FIX: Netzlaufwerke wurden nicht erkannt
//| 050302 ...... Brause   - FIX: Gro und Kleinschreibung von Recycler und System Volu... wird jetzt ignoriert
//|                        - CHANGE: Funktion vereinfacht
//|                        - CHANGE: Funktion getfile in getfiles integriert, da doppel Funktion
//|                          Achtung: wenn firstfile dann wird variable mit Filename zurckgegeben, sonst array mit Filenamen !
//|                        - FIX: $Mask hat nicht bei allen Maskarrays funktioniert, umgestellt auf in_array mit get_ext
//|                          str_replace Krcke falls Funktion mit .Extension und nicht nur mit Extension als Mask aufgerufen wird
//| 050308 ...... Brause   - FIX: Ergebnisse wurden nicht mehr sortiert
//| 050327 ...... Brause   - CHANGE: Windowslikere sortierung
//| 050613 ...... Brause   - FIX: wenn $mask = '' wurden keine Files gefunden
//| 050615 ...... Brause   - NEW: $add_path bergabepfad wir voran gestellt, wird von MediaCatch genutzt
//| 050703 ...... Brause   - NEW: $sort nach was sortiert werden soll und ermittelt gre und Dateidatum
//| 050718 ...... Brause   - NEW: im firstfile modus wird Suche nach ersten File abgebrochen (Achtung Sortierung hat hier keinen Einfluss)
//| 050724 ...... Brause   - FIX: wenn sort = '' wurde falsche Sortierung angewendet
//| 050918 ...... Brause   - NEW: $files defaultmig TRUE
//|                        - NEW: Dirs knnen auch nach Name, Gre und Datum sortiert werden
//|                        - NEW: Benutzer kann Sortierart whlen
//|                        - FIX: unntige schleifen entfernt
//| 051121 ...... Brause   - NEW: Darstellung von Gre und Datum wenn gewnscht
//| 060121 ...... Brause   - FIX: Pfad von Netzlaufwerken wurde nicht zurckgegeben
//| 060221 ...... Brause   - FIX: uasort fhrte zu falschen sortierungen (nur dateiname sortiert nicht incl Pfad) => Lsung uksort
//|                        - FIX: Unterordner werden im Winlikemodus so sortiert wie man es erwartet => Ordner zuerst sortiert, danach drunter liegene Files
//| 060225 ...... Brause   - NEW: $GLOBALS['NO_SHOW_DIRS'] dient zur Filterung von nicht gewnschten Directorys (., .., etc.)
//+---------------------------------------------------------------------------------------------------
  function getfiles($path,$mask,$files=true,$sub=false,$firstfile=false,$add_path=false,$sort='',$view_value=false,$subdirfile=false){
    ini_set("max_execution_time",0);
    if($firstfile)                                                //wenn nur das erste file gefunden werden soll, keine subordnerdurchsuchung
      $sub=false; 
    $erg = array();
    $first=FALSE;
	$IS_UNC = substr($path,0,2)=='//' ? 1 : 0;
    $sort_what = stristr($sort,'TIME') ? 2 :
                (stristr($sort,'SIZE') ? 4 : 1);                  // 1 = NAME und alles andere; 2 = TIME; 4 = SIZE
    $sort_mod = $GLOBALS['str_mods'][$GLOBALS['str_mod']].(stristr($sort,'DESC')?'_r':''); //Sort mod fr Namenssortierung

    if(!is_array($mask))
      $maskarr[] = str_replace('.','',$mask);                     //str_replace ist Krcke da auch extensions mit . angegeben werden
    else
      $maskarr =  $mask;

    if ((is_dir($path)||$IS_UNC) && !in_array($path,$GLOBALS['NO_SHOW_DIRS'])) //wenn gegebenes Verzeichnis existiert
    {
      $handle=opendir ($path);                                    //Handle darauf ffnen
      while ( ($file = readdir($handle)) !== false && !$first)    //alle Verzeichniseintrge nacheinander lesen
      {                                                           //wenn entweder keine Maske angegeben (Verzeichnisse) oder Maske zutrifft (Dateierweiterung) und nicht die speziellen Verzeichnisse . und .. aktuell sind
        if (is_dir($path.'/'.$file))
        {
          if (!in_array($file,$GLOBALS['NO_SHOW_DIRS']))          //wenn aktuelles Element VERZEICHNIS ist
          {
            if($sub)                                              // wenn Subdirectorys durchsucht werden sollen
            {
              $serg=getfiles($path.'/'.$file,$mask,$files,$sub,false,false,$sort,$view_value,TRUE);
              foreach($serg as $key => $sergi)
                $erg[$file.'/'.$key]=$sergi;
            }
            if(!$files)
			{
              if    ($sort_what&1)
                $erg[$file]=$file;                                //Ergebnis erfassen - hier werden noch keine Sonderzeichen ersetzt da diese Ersetzungen leider direkt als Text ausgegeben werden                                            //Ergebnis erfassen - hier werden noch keine Sonderzeichen ersetzt da diese Ersetzungen leider direkt als Text ausgegeben werden
              elseif($sort_what&2)
                $erg[$file]=filemtime     ($path.'/'.$file);      //array mit dateidatum
              elseif($sort_what&4)
                $erg[$file]=get_foldersize($path.'/'.$file);      //array mit dateigre
			}
          }
        }
        else // wenn kein directory
        {
          if($files && (in_array(get_ext($file),$maskarr)||$maskarr[0]==''))
          {
            if    ($sort_what&1)
              $erg[$file]=$file;                                  //Ergebnis erfassen - hier werden noch keine Sonderzeichen ersetzt da diese Ersetzungen leider direkt als Text ausgegeben werden                                            //Ergebnis erfassen - hier werden noch keine Sonderzeichen ersetzt da diese Ersetzungen leider direkt als Text ausgegeben werden
            elseif($sort_what&2)
              $erg[$file]=filemtime($path.'/'.$file);             //array mit dateidatum
            elseif($sort_what&4)
              $erg[$file]=filesize ($path.'/'.$file);             //array mit dateigre
            if($firstfile)                                        //bricht weitere Suche nach Dateien ab, wenn erste Datei gefunden (nur Firstfile Modus)
              $first=TRUE;
          }
        }
      }
      closedir($handle);                                          //Handle auf Verzeichnis schlieen
    }

    if(!$subdirfile)
    {
      if($sort_what&1)// nach Namen
      {
	    // wenn mit unterordner und Sortierung nicht Linuxlike muss recht aufwendig sortiert werden (Directory zuerst danach Files)
		if($sub&&$GLOBALS['str_mod']!=2&&$GLOBALS['str_mod']!=4)
		{
		  // Part I Ordner werden sortiert
		  $dirs = array();
          foreach($erg as $key => $value)
          { 
			$xkey=substr($key,0,strrpos($key,'/'));
			if($xkey!=''&&!isset($dirs[$xkey]))
			  $dirs[$xkey]=$xkey;
		  }
          uksort($dirs, $sort_mod);

		  // Part II Files zu den Ordnern werden sortiert
		  $new_erg = $zwischen_erg = $zwischen_rest = array();
		  if(count($dirs)>0)
		  {
            foreach($dirs as $value)
            {
		      foreach($erg as $key2 => $value2)
			  {
			    if(strpos($key2,$value)!==FALSE)
			      $zwischen_erg[$key2]=$value2;
			    else
			      $zwischen_rest[$key2]=$value2;
			  }
			  uasort($zwischen_erg, $sort_mod);
			  $new_erg = array_merge($new_erg,$zwischen_erg);
			  $erg = $zwischen_rest;
		    }
		    uasort($zwischen_rest, $sort_mod);
		    $erg = array_merge($new_erg,$zwischen_rest);
		  }
		  else
		    uksort($erg, $sort_mod);
		}
		else // wenn ohne Unterordner oder Linuxlike geht es einfacher zu sortieren
          uksort($erg, $sort_mod);
      }
      else                                                        //time und size sortierung funktioniert nicht mit uksort
      {
        if(stristr($sort,'DESC'))
          arsort($erg);                                           //Ergebnis rckwrts sortieren
        else
          asort($erg);                                            //Ergebnis sortieren
      }

      $erg2=$erg;
      $erg = array();
      foreach ($erg2 as $key => $value)
	    // wenn Sortierung nach Gre oder Datum und Darstellung erwnscht wird Gre und Datum angehngt
        $erg[] = $key.($view_value ? ($sort_what&2 ? '|'.date('d.m.y H:m',$value) : ($sort_what&4 ? '|'.format_bytesize($value) : '')) :'');

      if($add_path)
      {
        $paths = ($IS_UNC ? '/':'').change_slashes($path.'/');    // Pfad wird vorangestellt, changeslashes fngt das Problem mit (nicht) bergebenesn Slash ab
        $erg2=$erg;
        $erg = array();
        foreach ($erg2 as $value)
          $erg[] = $paths.$value;
      }
    }

    if($firstfile)
      return array_shift($erg);                                   //nur erstes File zurckliefern
  return $erg;                                                    //array rckliefern
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GETDIRS
//| liefert Feld mit Verzeichnisnamen in gegebenem Verzeichnis
//| $path ....... Pfad in welchem gesucht werden soll
//| $sub ........ ob Unterverzeichnisse auch durchsucht werden sollen
//| $add_path ... ob bergabepfad vor den Verzeichnisnamen gestellt werden soll
//| $sort ....... nach was sortiert werden soll, time, time_desc, size, size_desc, name und name_desc
//| $view_value . ob Gre oder Datum angezeigt werden soll
//|HISTORY:
//| 050615 ...... Brause   - Funktion erstellt
//| 050703 ...... brause   - NEW: $sort hinzu
//| 051121 ...... Brause   - NEW: $view_value hinzu
//+---------------------------------------------------------------------------------------------------
  function getdirs($path,$sub=false,$add_path=false,$sort='',$view_value=false){//ermittle Unterverzeichnisse in gegebenem Verzeichnis
  return getfiles($path,'',FALSE,$sub,FALSE,$add_path,$sort,$view_value);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GETFILE
//| liefert erste gefundene Datei in gegebenem Verzeichnis
//| $path ....... Pfad in welchem gesucht werden soll
//| $mask ....... Filter nach Datei Erweiterung (Dateiname muss damit enden)
//| $add_path ... ob bergabepfad vor den Dateinamen gestellt werden soll
//| $sort ....... nach was sortiert werden soll, time, time_desc, size, size_desc, name und name_desc
//| $view_value . ob Gre oder Datum angezeigt werden soll
//|HISTORY:
//| 041213 ...... LongDan  - aus Getfiles erstellt
//| 050302 ...... Brause   - Funktion wieder in Getfiles integriert, jetzt wird auch das alphabetisch erste File geliefert
//|                          Funktion nur als Sicherheit vorhanden
//| 050615 ...... brause   - NEW: $add_path hinzu
//| 050703 ...... brause   - NEW: $sort hinzu
//| 051121 ...... Brause   - NEW: $view_value hinzu
//+---------------------------------------------------------------------------------------------------
  function getfile($path,$mask,$add_path=false,$sort='',$view_value=false){
  return getfiles($path,$mask,TRUE,FALSE,TRUE,$add_path,$sort,$view_value); // liefert ersten Eintrag aus GETFILES Array
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GETVALIDFILES
//| liefert alle zugelassenen Dateien in einem Verzeichnis
//| $path ....... Pfad in welchem gesucht werden soll
//| $stream ..... soll Bild gestreemt werden ?
//|               0 = nur Streamfaehige Bilder anzeigen
//|               1 = nur direkt von Hardware untersttze Bilder anzeigen
//| $sub ........ ob Unterverzeichnisse auch durchsucht werden sollen
//| $firstfile .. ob nur das allererst gefunde File gefunden werden soll
//| $which ...... welche files gesucht werden sollen, 1 = audio; 2 = video ; 4 = images
//| $add_path ... ob mit bergebenen Pfad zurckgegeben werden soll
//| $sort ....... nach was sortiert werden soll, time, time_desc, size, size_desc, name und name_desc
//| $view_value . ob Gre oder Datum angezeigt werden soll
//|HISTORY:
//| 050326 ...... brause   - Funktion erstellt
//| 050615 ...... brause   - NEW: $add_path hinzu
//| 050703 ...... brause   - NEW: $sort hinzu
//| 050712 ...... brause   - CHANGE: alle Bilder darstellen entfernt, durch streamfhig ersetzt
//| 051121 ...... Brause   - NEW: $view_value hinzu
//+---------------------------------------------------------------------------------------------------
  function getvalidfiles($path,$stream=0,$sub=false,$firstfile=false,$which=7,$add_path=false,$sort='',$view_value=false){
    $mask_arr = array();
    if($which&1)
      $mask_arr = $GLOBALS['audioextensions'];
    if($which&2)
      $mask_arr = array_merge($mask_arr,$GLOBALS['videoextensions']);
    if($which&4)
	{
	  if($stream)
	    $mask_pic = array_diff($GLOBALS['imageextensions'],$GLOBALS['imageextensions_nohtml'],$GLOBALS['imageextensions_nosc']);
	  else
	    $mask_pic = $GLOBALS['GDLIB_SUPPORT']?$GLOBALS['imageextensions']:array_diff($GLOBALS['imageextensions'],$GLOBALS['imageextensions_nosc']);
	  $mask_arr = array_merge($mask_arr,$mask_pic);
	}
  return getfiles($path,$mask_arr,true,$sub,$firstfile,$add_path,$sort,$view_value);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GETAUDIOS
//| liefert alle zugelassenen Audios aus einem Verzeichnis
//| $path ....... Pfad in welchem gesucht werden soll
//| $sub ........ ob Unterverzeichnisse auch durchsucht werden sollen
//| $firstfile .. ob nur das allererst gefunde File gefunden werden soll
//| $add_path ... ob mit bergebenen Pfad zurckgegeben werden soll
//| $sort ....... nach was sortiert werden soll, time, time_desc, size, size_desc, name und name_desc
//| $view_value . ob Gre oder Datum angezeigt werden soll
//|HISTORY:
//| 050123 ...... brause   - Funktion erstellt
//| 050302 ...... brause   - Funktion vereinfacht
//|                        - New: ob nur erstes File gefunden werden soll
//| 050615 ...... brause   - NEW: $add_path hinzu
//| 050703 ...... brause   - NEW: $sort hinzu
//| 051121 ...... Brause   - NEW: $view_value hinzu
//+---------------------------------------------------------------------------------------------------
  function getaudios($path,$sub=false,$firstfile=false,$add_path=false,$sort='',$view_value=false){
  return getvalidfiles($path,$stream,$sub,$firstfile,1,$add_path,$sort,$view_value);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GETVIDEOS
//| liefert alle zugelassenen Videos aus einem Verzeichnis
//| $path ....... Pfad in welchem gesucht werden soll
//| $sub ........ ob Unterverzeichnisse auch durchsucht werden sollen
//| $firstfile .. ob nur das allererst gefunde File gefunden werden soll
//| $add_path ... ob mit bergebenen Pfad zurckgegeben werden soll
//| $sort ....... nach was sortiert werden soll, time, time_desc, size, size_desc, name und name_desc
//| $view_value . ob Gre oder Datum angezeigt werden soll
//|HISTORY:
//| 050114 ...... brause   - Funktion erstellt
//| 050302 ...... brause   - Funktion vereinfacht
//|                        - New: ob nur erstes File gefunden werden soll
//| 050615 ...... brause   - NEW: $add_path hinzu
//| 050703 ...... brause   - NEW: $sort hinzu
//| 051121 ...... Brause   - NEW: $view_value hinzu
//+---------------------------------------------------------------------------------------------------
  function getvideos($path,$sub=false,$firstfile=false,$add_path=false,$sort='',$view_value=false){
  return getvalidfiles($path,$stream,$sub,$firstfile,2,$add_path,$sort,$view_value);
 }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GETIMAGES
//| liefert alle zugelassenen Bilder in einem Verzeichnis
//| $path ....... Pfad in welchem gesucht werden soll
//| $stream ..... soll Bild gestraemt werden ?
//| $sub ........ ob Unterverzeichnisse auch durchsucht werden sollen
//| $firstfile .. ob nur das allererst gefunde File gefunden werden soll
//| $add_path ... ob mit bergebenen Pfad zurckgegeben werden soll
//| $sort ....... nach was sortiert werden soll, time, time_desc, size, size_desc, name und name_desc
//| $view_value . ob Gre oder Datum angezeigt werden soll
//|HISTORY:
//| 050114 ...... brause   - Funktion erstellt
//| 050302 ...... brause   - Funktion vereinfacht
//|                        - New: ob nur erstes File gefunden werden soll
//| 050326 ...... brause   - CHANGE: greift jetzt auf getvalidfiles zu
//| 050615 ...... brause   - NEW: $add_path hinzu
//| 050703 ...... brause   - NEW: $sort hinzu
//| 051121 ...... Brause   - NEW: $view_value hinzu
//+---------------------------------------------------------------------------------------------------
  function getimages($path,$stream=0,$sub=false,$firstfile=false,$add_path=false,$sort='',$view_value=false){
  return getvalidfiles($path,$stream,$sub,$firstfile,4,$add_path,$sort,$view_value);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: LINUX_STRCOLL
//| sortier Funktion "strcoll" fr Linux
//| "BUG": unter Linux Sonderzeichen werden ignoriert und als nicht existent behandelt
//|HISTORY:
//| 051024 ...... Brause   - Funktion erstellt
//+---------------------------------------------------------------------------------------------------
  function linux_strcoll($a,$b){
    $xa = strlen($a);
    $xb = strlen($b);
    $x = $xa < $xb ? $xb : $xa;

    $wert = $i =0;

    while($i<$x && $wert==0) :
      $wert = strcoll(substr($a,$i,1),substr($b,$i,1));
      $i++;
    endwhile;

  return $wert;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: LINUX_STRCOLL_R
//| umkehrfunktion zu linux_strcoll
//|HISTORY:
//| 051024 ...... Brause   - Funktion erstellt
//+---------------------------------------------------------------------------------------------------
function linux_strcoll_r($a,$b) {
return -linux_strcoll($a,$b);
}
//+-------------------------------------------------------------------------------------------
//|FUNKTION: STRCASECMP_R
//| umkehrfunktion zu strcasecmp
//|HISTORY:
//| 050703 ...... Brause   - Funktion erstellt
//| 051025 ...... Brause   - Funktion umbenannt hie strrcasecmp
//+---------------------------------------------------------------------------------------------------
  function strcasecmp_r($a, $b){
  return -strcasecmp($a, $b);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: STRCOLL_R
//| umkehrfunktion zu strcoll
//|HISTORY:
//| 051021 ...... Brause   - Funktion erstellt
//+---------------------------------------------------------------------------------------------------
  function strcoll_r($a, $b){
  return -strcoll($a, $b);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: STRNATCMP_R
//| umkehrfunktion zu strnatcmp
//|HISTORY:
//| 051024 ...... Brause   - Funktion erstellt
//+---------------------------------------------------------------------------------------------------
  function strnatcmp_r($a, $b){
  return -strnatcmp($a, $b);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: STRNATCASECMP_R
//| umkehrfunktion zu strnatcasecmp
//|HISTORY:
//| 051024 ...... Brause   - Funktion erstellt
//+---------------------------------------------------------------------------------------------------
  function strnatcasecmp_r($a, $b){
  return -strnatcasecmp($a, $b);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: CHECK_GKEYS
//| Check ob TV-Key schon vergeben ist.
//|HISTORY:
//| 041105 ...... LongDan  - erstellt
//| 050718 ...... Brause   - CHANGE: show_gkeys integriert (setup angepasst)
//+-------------------------------------------------------------------------------------------
  function check_gkeys($ckey){
    $retkey='';
    if (in_array($ckey,$GLOBALS['sys_tvid_key'])) //reservierte tvids
      return 'System';
    if ($ckey=='') 
      return '';
    if ($ckey==0 or !is_numeric($ckey)) 
      return '-';
    $chkkeys=read_pluginorder();
    while(list($name,$cplugin)=each($chkkeys))
    {
      if ($cplugin['gkey']==$ckey)
	    return $cplugin['path'];
    }
  return $ckey;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: list_gkeys
//| Erstellt eine HREF Liste mit den GKEYS
//|HISTORY:
//| 041113 ...... LongDan  - erstellt
//| 041118 ......          - 999 gilt nun systemwide
//| 050302 ...... Brause   - FIX: 998 aus oxylstart bernommen
//|                        - FIX: read_plugins durch read_pluginorder ersetzt und abgespeckt -> Performance !!!
//|                          oxyl_setup dahingehend angepasst das keine plugins mit tvid belegt werden
//|                          knnen die nicht im SC sichtbar und in pluginorder wird userlevel abgespeichert
//|                        - FIX: nur plugins wurden angezeigt die kein oder nur genau das level des user hatten
//| 050731 ...... Brause   - CHANGE: 999 in 997 gendert, 999 ist oxylstart
//|                        - NEW: Zugriff auf pic, video und mp3 (ehemals in design.inc)
//+-------------------------------------------------------------------------------------------
  function list_gkeys(){
    $plugins=read_pluginorder();
    reset($plugins);
    $gkeylist = '';
	$oxyl_file = $oxyl_mp3 = $oxyl_video = $oxyl_pic = 1;
    while(list($key,$val)=each($plugins))
    {
      if (isset($val['level'])  &&  $val['level']<$GLOBALS['actuserlevel'] && $val['level']<>'')
      {
	   //echo $key." - ".$val['path']." - ".$val['level']."<br>";
      }
      else
      {
	    if( isset($val['path']) && isset($val['show']))
		{
	      if( $val['path'] == 'oxyl_file')
		    $oxyl_file = $val["show"];
	      if( $val['path'] == 'oxyl_mp3')
		    $oxyl_mp3 = $val["show"];
	      if( $val['path'] == 'oxyl_video')
		    $oxyl_video = $val["show"];
	      if( $val['path'] == 'oxyl_pic')
		    $oxyl_pic = $val["show"];
          if (isset($val['start']) && isset($val['path']) && $val['gkey'] > 0)
            $gkeylist .= '<a href="'.OXYL_WEB.'/plugins/'.$val['path'].'/'.$val['start'].'" TVID="'. $val['gkey'] .'"></a>'."\n";
		}
	  }
    }

// System tvid Links
//------------------

   $gkeylist .= '<a href="'.OXYL_WEB.'/oxylstart.php" TVID="'.IR_TVID_HOME.'"></a>'."\n"
        //.'<a href="'.OXYL_WEB.'/plugins/oxyl_file/oxyl_file_main.php?'.($oxyl_file && !$oxyl_mp3   ? 'mode=file&mode_1=' : 'mode=' ).'mp3" TVID="'.IR_TVID_MUSIC.'"></a>'."\n"
		//.'<a href="'.OXYL_WEB.'/plugins/oxyl_file/oxyl_file_main.php?'.($oxyl_file && !$oxyl_video ? 'mode=file&mode_1=' : 'mode=' ).'video" TVID="'.IR_TVID_MOVIE.'"></a>'."\n"
		//.'<a href="'.OXYL_WEB.'/plugins/oxyl_file/oxyl_file_main.php?'.($oxyl_file && !$oxyl_pic   ? 'mode=file&mode_1=' : 'mode=' ).'pic" TVID="'.IR_TVID_PHOTO.'"></a>'."\n";
        .($oxyl_mp3   ? '<a href="'.OXYL_WEB.'/plugins/oxyl_file/oxyl_file_main.php?mode=mp3" TVID="'.IR_TVID_MUSIC.'"></a>'."\n" :
		 ($oxyl_file  ? '<a href="'.OXYL_WEB.'/plugins/oxyl_file/oxyl_file_main.php?mode=file&mode_1=mp3" TVID="'.IR_TVID_MUSIC.'"></a>'."\n" : ''))
        .($oxyl_video ? '<a href="'.OXYL_WEB.'/plugins/oxyl_file/oxyl_file_main.php?mode=video" TVID="'.IR_TVID_MOVIE.'"></a>'."\n" :
	     ($oxyl_file  ? '<a href="'.OXYL_WEB.'/plugins/oxyl_file/oxyl_file_main.php?mode=file&mode_1=video" TVID="'.IR_TVID_MOVIE.'"></a>'."\n" : ''))
        .($oxyl_pic   ? '<a href="'.OXYL_WEB.'/plugins/oxyl_file/oxyl_file_main.php?mode=pic" TVID="'.IR_TVID_PHOTO.'"></a>'."\n" :
         ($oxyl_file  ? '<a href="'.OXYL_WEB.'/plugins/oxyl_file/oxyl_file_main.php?mode=file&mode_1=pic" TVID="'.IR_TVID_PHOTO.'"></a>'."\n" : ''));

// 997 & 998
//----------
    global $show;
    $gkeylist .= '<a href="'.OXYL_WEB.'/oxylstart.php'.(isset($show)&&$page['headline']<>'START' ? '' : '?show').'" TVID="997"></a>'."\n"
                .'<a href="'.OXYL_WEB.'/common/oxyl_voice.php" TVID="998" aod="playlist"></a>'."\n"
				.'<a href="'.OXYL_WEB.'/oxylstart.php" TVID="999"></a>'."\n";
  return $gkeylist;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: list_sitekeys
//| Erstellt eine HREF Liste mit den KEYS um die einzelnen Seiten z.B. in oxyl_pic darzustellen
//| $url    ..... Ziel Url, am Schluss muss Parameter stehen an dem die Seitenzahl angehngt wird
//|               z.B.  oxyl_pic_maiun.php?ap= ... &st=
//| $sites  ..... Gesamtanzahl der Seiten
//|HISTORY:
//| 050116 ...... Brause   - erstellt
//| 050827 ...... Brause   - CHANGE: Funktion fr Navigation per Anfangsbuchstaben umgebaut
//+-------------------------------------------------------------------------------------------
  function list_sitekeys($url,$sites){
    $sitekeylist = '';
	foreach($sites as $tvid => $site)
       $sitekeylist .= '<a href="'.$url.$site.'" TVID="'.$tvid.'"></a>'."\n";
  return $sitekeylist;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: Get PlayListPath
//| Gibt den PlaylistPfad aus!
//|HISTORY:
//| 041112 ...... LongDan  - erstellt
//| 050123 ...... Brause   - falls nicht existent eingebaut (aus oxyl_mp3)
//| 050328 ...... Brause   - mkdir durch check_dirs ersetzt
//| 050608 ...... Brause   - FIX: Variable war falsch
//|                        - CHANGE: fopen durch read_file und create_file ersetzt
//| 050716 ...... Brause   - falls nicht existent ausgebaut
//+-------------------------------------------------------------------------------------------
  function get_playlistpath(){
  return file_exists(OXYL_CONF.'plugins_oxyl_mp3_playlist.cfg') ?
         read_file(OXYL_CONF.'plugins_oxyl_mp3_playlist.cfg')   : FALSE;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GET_DEVICES
//| liefert Feld mit allen Eintrgen aus gegebener Datei
//| $confi ...... Konfigurationsdatei aus der die Eintrge ausgelesen werden
//|HISTORY:
//|        ...... Odu?     - erstellt
//+-------------------------------------------------------------------------------------------
  function get_devices($confi){
    $devs = array();
    if (file_exists(OXYL_CONF.$confi))                 //wenn angegebene Konfig-Datei existiert
    {
      $counter = 0;	
      $alldevs=file(OXYL_CONF.$confi);                 //Datei in $alldevs erfassen
      reset($alldevs);                                 //zu erstem Element von $alldevs springen
      foreach($alldevs as $dev)                        //und fr jeden Eintrag folgendes durchfhren:
      {
      	$devarr = array();
      	$devarr = explode('|',$dev);                   //nach Trennzeichen trennen
      	if (count($devarr)>1)                          //wenn in $devarr mehr als 1 Feld ist
      	{
      	  $devs[$counter]['name']=trim($devarr[0]);    //1. Feld als Name zuweisen
      	  $devs[$counter]['path']=trim($devarr[1]);    //2. Feld als Pfad zuweisen
          if (count($devarr)>2)                        //wenn in $devarr auch noch mehr als 2 Felder sind
      	    $devs[$counter]['level']=trim($devarr[2]); //3. Feld als Level mit Wert aus $devarr zuweisen
      	  else                                         //ansonsten
      	    $devs[$counter]['level']=3;                //3. Feld als Level "3" fix zuweisen
      	  $counter++;                                  //Feldzhler fr Ergebnisfeld erhhen
      	}
      }
    }
  return $devs;                                        //Ergebnisfeld rckliefern
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GETIMGHREF
//| liefert Pfad zu gegebenem Bild entweder aus aktuellem Skin oder Default Skin Verzeichnis
//| $filename ... gesuchte Bilddatei
//| $pluginimagepath . optional Pfad zu Plugin
//| $default ......... ob bild im default skin gesucht werden soll
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 050328 ...... Brause   - FIX: berprft jetzt auch oxyl images Verzeichnis und liefert leerbild wenn nichts gefunden
//| 050611 ...... Brause   - FIX: doppelte Slashes bei berprfung ob bild in pluginpath
//| 050809 ...... Brause   - NEW: ob bild im default skin gesucht werden soll, jetzt abschaltbar
//| 060331 ...... Brause   - NEW: wenn im Skin nicht als gif auffindbar, dann wird im skin nach png Variante gesucht
//+-------------------------------------------------------------------------------------------
  function getimghref($filename,$pluginimagepath='',$default=TRUE){
    if($pluginimagepath!='') $pluginimagepath .= '/';
	if     (file_exists(OXYL_SKIN.$GLOBALS['actskin'].'/'.$filename)) //falls angeforderte datei im aktuellen skinverzeichnis existiert
      return OXYL_WEB.'/skins/'.$GLOBALS['actskin'].'/'.$filename;    //verweis darauf setzen
    elseif (file_exists(OXYL_SKIN.$GLOBALS['actskin'].'/'.del_ext($filename).'.png') && get_ext($filename)=='gif') //falls angeforderte datei im aktuellen skinverzeichnis als PNG existiert
      return OXYL_WEB.'/skins/'.$GLOBALS['actskin'].'/'.del_ext($filename).'.png';    //verweis darauf setzen
    elseif (file_exists(OXYL_SKIN.'default/'.$filename)&&$default)    //ansonsten berprfen ob sie im default-skin verzeichnis existiert (nur wenn im default dir gesucht werden soll)
      return OXYL_WEB.'/skins/default/'.$filename;                    //falls ja verweis darauf setzen
    elseif (file_exists(OXYL_PLUG.$pluginimagepath.$filename))        //ansonsten berprfen ob sie im plugin verzeichnis existiert
      return OXYL_WEB.'/plugins/'.$pluginimagepath.$filename;         //verweis darauf setzen
    elseif (file_exists(OXYL_PICS.$filename))                         //ansonsten berprfen ob sie im oxylimage verzeichnis existiert
      return OXYL_WEB.'/images/'.$filename;                           //verweis darauf setzen
    else                                                              //ansonsten schicke leeres Bild
      return $GLOBALS['web_trans_image'];                             //verweis darauf setzen
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GETURL
//| wandelt gegebenen Verzeichnispfad in gltige WebURL um - 
//| hier Anpassungen fr andere Webserver vornehmen!!!!
//| $file .......... lokaler Pfad der in WebURL gewandelt werden soll
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 040803 ...... .fischer - Unterscheidung zwischen Apache2 und restlichen Webservern eingebaut
//| 040819 ...... .fischer - verfeinert: APACHE 1/2 werden direkt untersttzt - fr andere Webserver
//|                          wird getestet wie kodiert werden muss
//| 041120 ...... stolle   - UNC eingebaut
//| 041130 ...... Gaga     - Versionen zusammengefhrt
//| 050123 ...... Brause   - check auf Linux und apache => kein utf8_encode
//| 051027 ...... Brause   - FIX: UNC wurden falsch umgewandelt
//+-------------------------------------------------------------------------------------------
  function geturl($file){                                                                  //weburl erzeugen
    if (substr($file,0,2)!='//')
    {
	  if (substr($file,1,1)==':')                                                          //falls pfad zu $file doppelpunkt enthlt (also windows pfad mit laufwerksangabe ist)
		$thefile = '/lw'.substr(strtolower($file),0,1).'/'.substr($file,3);                //pfad an apache laufwerksmapping anpassen
	  else
		$thefile = '/root'.$file;                                                          //ansonsten annahme dass es ber root angesprochen werden kann????????
	}
	else
	  $thefile='/UNC'.substr($file,1);

    if    (stristr($_SERVER["SERVER_SOFTWARE"],"Apache/2")&&$GLOBALS['system']=="windows") //wenn APACHE2 auf Windows Server
      return SpecialCharReplace(utf8_encode($thefile));                                    //alle sonderzeichen durch webkompatible % zeichen ersetzen
    elseif(stristr($_SERVER["SERVER_SOFTWARE"],"Apache"))                                  //wenn APACHE Server
      return SpecialCharReplace($thefile);                                                 //alle sonderzeichen durch webkompatible % zeichen ersetzen
    else                                                                                   //wenn unbekannter Webserver
    {
      if( remote_file_exists(SpecialCharReplace($thefile)) )                               //prfen ob webkompatible Zeichen gengen
        return SpecialCharReplace($thefile);
      elseif ( remote_file_exists(SpecialCharReplace(utf8_encode($thefile))) )             //oder ob UTF8 verwendet werden muss
        return SpecialCharReplace(utf8_encode($thefile));
    }
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: SPECIALCHARREPLACE
//| wandelt Sonderzeichen in gebebenem String in passende %-Sonderzeichen mit Rcksicht auf
//| Verzeichnistrennzeichen um
//| $uri ........ String der gewandelt werden soll
//|HISTORY:
//|        ...... gaga     - taken from Pinnacle (and fixed)
//| 040702 ...... .fischer - Funktion von Andrew Eigus - php.net - (alten Code ersetzt)
//+-------------------------------------------------------------------------------------------
  function SpecialCharReplace($uri){         //funktion zum kodieren einzelner sonderzeichen mit rawurlencode - von php.net kopiert
    $parts = explode('/', $uri);             //splitte kompletten pfad in einzelne elemente (ordner und dateiname)
    for ($i = 0; $i < count($parts); $i++)   //fr jeden teil
      $parts[$i] = rawurlencode($parts[$i]); //fhre ein rawurlencode durch
  return implode('/', $parts);               //und setze danach den kodierten pfad wieder zusammen
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: OXYL_UTF8_DECODE
//| fhrt utf8_decode durch, wenn vorhanden
//| $par ........ String der gewandelt werden soll
//|HISTORY:
//| 0051016 ...... Brause   - Funktion erstellt, Thx to jjwin2k
//+-------------------------------------------------------------------------------------------
  function oxyl_utf8_decode($par){
  return preg_match("/^([\x09\x0A\x0D\x20-\x7E]|[\xC2-\xDF][\x80-\xBF]|\xE0[\xA0-\xBF][\x80-\xBF]|[\xE1-\xEC\xEE\xEF][\x80-\xBF]{2}|\xED[\x80-\x9F][\x80-\xBF]|\xF0[\x90-\xBF][\x80-\xBF]{2}|[\xF1-\xF3][\x80-\xBF]{3}|\xF4[\x80-\x8F][\x80-\xBF]{2})*$/", $par) ?
	     utf8_decode($par) : $par;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: TRANS
//| liefert fr geliefertes Plugin den fr die aktuelle Sprache richtige bersetzung fr Label
//| $plugin ..... Name des Plugins fr welches die bersetzung bentigt wird
//| $label ...... Name des Labes welches bersetzt werden soll
//|HISTORY:
//|        ...... Odu? - erstellt
//| 040703 ...... .fischer - Bei Zuweisung der bersetzungswerte an Feld berprfen
//|                          ob = Zeichen in Quellstring vorhanden ist
//| 050131 ...... Brause   - falls Languagefile nicht existiert, wird default Languagefile genommen
//|                          default Languagefile wird in const.inc festgelegt
//+-------------------------------------------------------------------------------------------
  function trans($plugin,$label){
    $translation = $label;                                             //sollte keine passende beretzung mglich sein wird stattdessen die Labelbezeichnung rckgeliefert
    if (!(isset($GLOBALS['transplugins'])))                            //wenn bersetzung fr aktuelles Plugin noch nicht geladen
    {
      $lang_plugin_file    = OXYL_PLUG.$plugin.'/lang_'.$GLOBALS['language'].'.txt';
      if (!file_exists($lang_plugin_file))                             //wenn bersetzungsdatei in Sprache nicht existiert, versucht es in default DE Sprache
         $lang_plugin_file = OXYL_PLUG.$plugin.'/lang_'.$GLOBALS['language_def'].'.txt';

      if (file_exists($lang_plugin_file))                              //wenn bersetzungsdatei existiert
      {
      	$GLOBALS['transplugins'] = $alltrans = array();
      	$alltrans = file ($lang_plugin_file);                          //diese komplett in Feld $alltrans laden
      	reset($alltrans);                                              //zu erstem Element von Alltrans springen
      	foreach($alltrans as $line)                                    //und fr jedes Element folgendes durchfhren:
      	{
          if (substr(trim($line),0,1)!='#' && strpos(' '.$line,"=")>0) //wenn keine # als Kommentar Symbol am Zeilenanfang steht und = Zeichen enthalten ist
      	    $GLOBALS['transplugins'][substr($line,0,strpos($line,'='))] = substr($line,strpos($line,'=')+1); //dann am = Zeichen in Bezeichner und Wert aufteilen
        }
      }
    }

    if (!(isset($GLOBALS['transmain'])))                               //wenn bersetzung fr Hauptmen noch nicht geladen
    {
      $lang_main_file = OXYL_KERN.'lang_'.$GLOBALS['language'].'.txt';
      if (!file_exists($lang_main_file))                               //wenn bersetzungsdatei in Sprache nicht existiert, versucht es in default DE Sprache
         $lang_main_file = OXYL_KERN.'lang_'.$GLOBALS['language_def'].'.txt';

      if (file_exists($lang_main_file)) //wenn bersetzungsdatei existiert
      {
      	$GLOBALS['transmain'] = $alltrans = array();
      	$alltrans = file ($lang_main_file);                            //diese komplett in Feld $alltrans laden
      	reset($alltrans);
      	foreach($alltrans as $line)                                    //und fr jedes Element folgendes durchfhren:
      	{
          if (substr(trim($line),0,1)!='#' && strpos(' '.$line,"=")>0) //wenn keine # als Kommentar Symbol am Zeilenanfang steht und = Zeichen enthalten ist
            $GLOBALS['transmain'][substr($line,0,strpos($line,'='))] = substr($line,strpos($line,'=')+1); //dann am = Zeichen in Bezeichner und Wert aufteilen
        }
      }
    }
    if     (isset($GLOBALS['transplugins'][$label]))                   //wenn bersetzungsdatei geladen und bersetzung fr bentiges Label vorhanden
      $translation = $GLOBALS['transplugins'][$label];                 //diese zuweisen
    elseif (isset($GLOBALS['transmain'][$label]))                      //wenn bersetzungsdatei geladen und bersetzung fr bentiges Label vorhanden
      $translation = $GLOBALS['transmain'][$label];                    //diese zuweisen
  return trim($translation);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GETBASEDIR
//| liefert den Pfad des aktuellen Basisverzeichnisses zurck
//| $path ....... Pfad zum aktuellen Verzeichnis
//| $hist ....... History String mit welchem die Anzahl der Unterverzeichnisse seit
//|               Basisverzeichnis berechnet werden kann - fr jedes Unterverzeichniss
//|               nur 1 Stelle!!! - Trennung durch ~
//|HISTORY:
//| 040704 ...... .fischer - Funktion erstellt
//| 050516 ...... Brause   - Funktion aus getbasedirnew eingesetzt
//+-------------------------------------------------------------------------------------------
  function getbasedir($path, $hist){
    $hists = array();
    $hists = explode('~',$hist);
    for($i=count($hists);$i>1;$i--)
      $path=substr($path,0,strrpos($path, "/"));
  return $path;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GET_EXT
//| liefert die Extension zu einer Datei, immer klein geschrieben
//| $path ....... Pfad zum aktuellen Verzeichnis
//|HISTORY:
//| 040828 ...... brause   - Funktion erstellt
//| 050122 ...... brause   - FIX wenn Pfad keinen Punkt enthlt, kam was zurck
//| 050327 ...... brause   - FIX: extension konnte Leerzeichen enthalten
//|                        - CHANGE: preg_match durch strpos ersetzt
//| 050616 ...... brause   - FIX: wenn Datei keine ext hat aber pfad bergeben wurde mit .
//| 050617 ...... brause   - FIX: extension in Grobuchstaben Problem
//+-------------------------------------------------------------------------------------------
  function get_ext($pfad){
    $ext = strpos($pfad,'.') ? substr($pfad,strrpos($pfad,'.')+1): '';
  return   strpos($ext ,'/') ? '' : strtolower($ext);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: DEL_EXT
//| entfernt die Extension einer Datei
//| $path ....... Pfad zum aktuellen Verzeichnis
//|HISTORY:
//| 040828 ...... brause   - Funktion erstellt
//| 050122 ...... brause   - FIX wenn Pfad keinen Punkt enthlt, kam leer zurck
//| 050327 ...... brause   - FIX: get_ext entfernt, da ext ohne leerzeichen zurckgeliefert wird
//|                        - CHANGE: preg_match durch strpos ersetzt
//| 050616 ...... brause   - FIX: wenn Datei keine ext hat aber pfad bergeben wurde mit .
//+-------------------------------------------------------------------------------------------
  function del_ext($pfad){
    $ext = get_ext($pfad);
  return $ext !='' ? substr($pfad,0,-(strlen($ext)+1)) : $pfad;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: DIR_NAME
//| entfernt Dateinamen aus Pfad (PHP Funktion dirname spinnt bei backslashes)
//| $path ....... Pfad mit Dateiname
//| $what ....... 0 => leere Rckgabe wenn kein Dirname, 1 => . als Rckgabe wenn kein Dirname (POSIX-Standard)
//|HISTORY:
//| 050122 ...... brause   - Funktion erstellt
//| 060222 ...... brause   - NEW: ob . fr aktuelles Verzeichnis zurckgegen werden soll
//+-------------------------------------------------------------------------------------------
  function dir_name($pfad,$what=0){
	$pfad = change_slashes(dirname($pfad));
  return (!$what && $pfad=='.') ? '' : $pfad;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: CLEAR_NAME
//| entfernt unerwnschte Zeichen aus Name
//| $par ........ zu subernder Text
//|HISTORY:
//| 050328 ...... brause   - Funktion erstellt
//+-------------------------------------------------------------------------------------------
  function clear_name($par){
 	// umlaute erstetzen
 	//$par = ereg_replace('', 'ae', $par);
 	//$par = ereg_replace('', 'oe', $par);
 	//$par = ereg_replace('', 'ue', $par);
 	//$par = ereg_replace('', 'sz', $par);
 	// nur diese zeichen zulassen alle anderen ersetzen durch _
 	//$par = preg_replace("/[^a-z0-9.]/","_",$par);

	//ersetzt _ durch Leerzeichen
	$par = substr($par,0,1) =='_' ? '_'.str_replace('_' ,' ',substr($par,1)):str_replace('_' ,' ',$par);
	// entfernt doppelte leerzeichen
	$par = preg_replace("/ {2,}/"," ",$par);
  return trim($par);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: DOTRUNC
//| krzt Zeichenkette auf angegebene Lnge an gegebener Seite und ergnzt auf Wunsch mit ...
//| $was ........ aktuelle Zeichenkette
//| $max ........ max. Zeichenkettenlnge
//| $dots ....... ob Punkte gesetzt werden sollen (true/false)
//| $lr ......... ob links oder rechts abgeschnitten werden soll
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 040828 ...... brause   - Funktion ergaenzt, kuerzt jatzt auch aus mitte
//| 050126 ...... brause   - FIX: wenn nicht dots, dann auch nicht noch 3 Zeichen krzer
//|                        - Funktion gekrzt
//+-------------------------------------------------------------------------------------------
  function dotrunc($was,$max=FALSE,$dots=TRUE,$lr='r'){
  if(!$max)$max=$GLOBALS["maxchars"];
    $out = $was;
	$max2 = $max-3; // die 3 Punkte abziehen
    if (strlen($was)>$max){
       if     (strtolower($lr)=='r')
	     $out = $dots ? substr($was,0,$max2).'...'            : substr($was,0,$max);
       elseif (strtolower($lr)=='l')
         $out = $dots ? '...'.substr($was,strlen($was)-$max2) : substr($was,strlen($was)-$max);
       else
       {
         $out  = substr($was,0,ceil($max2/2));
		 $out .= $dots ? '...' : '&nbsp;&nbsp;&nbsp;';
		 $out .= substr($was,-floor($max2/2));
       }
    }
  return $out;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: DISP_SPECIAL
//| truncates filename before 2nd hyphen from the right
//| $dispspec ... 1 = specialdisplay active
//| $fn ......... filename
//| $dispext .... ob extension angeziegt werden soll
//| $maxchars ... maximal Lnge der Ausgabe
//| $clearname .. ob $fn von unerwnschten Zeichen gesubert werden soll
//|HISTORY:
//|        ...... odu? Funktion erstellt
//| 040710 ...... .fischer - Entfernen der Erweiterung .mp3 ans Ende verschoben
//|                          damit dies immer passiert, unabhngig von der Anzahl der -
//| 050114 ...... brause   - del_extension hinzugefgt
//| 050327 ...... brause   - CHANGE: folder parm entfernt (war auch nur ein bug von get_ext)
//| 050328 ...... brause   - NEW: clear_name hinzu
//| 050419 ...... brause   - NEW: ob clear_name ausgefhrt werden soll
//+-------------------------------------------------------------------------------------------
  function disp_special($dispspec,$fn,$dispext=FALSE,$maxchars=FALSE,$clearname=FALSE){
  if(!$maxchars)$maxchars=$GLOBALS["maxchars"];
    $dispfn = $fn;
    if ($dispspec)                                                         //wenn DispSpec aktiviert
    {
      $allarr = explode('-',$fn);                                          //den Dateinamen an seinen "-" trennen;
      $arrcou = count($allarr);
      /*if($arrcou-4>=0)
	    $first  = trim($allarr[$arrcou-4]).' - ';
	  if($arrcou-3>=0)
	    $second = trim($allarr[$arrcou-3]).' - ';*/
	  if($arrcou-2>=0)
	    $third  = trim($allarr[$arrcou-2]).' - ';
	  $last   = trim($allarr[$arrcou-1]);
      $maxi   = floor($maxchars/3*2);
	  if(isset($third)&&strlen($last)<$maxi)                               //wenn mehr als 2 Elemente nach der Trennung vorhanden sind (mehr als 1 "-" vorhanden war)
        $dispfn = $third.$last;                                            //die letzten beiden Elemente mit einem "-" als Trennzeichen zusammensetzen
	  else
		$dispfn = $last;
	}
	 if(!$dispext)  $dispfn=del_ext($dispfn);                              //neuen String bzw. originalen ohne der Erweiterung .mp3 . wav ....rckgeben;
     if($clearname) $dispfn=clear_name($dispfn);                           // subert Dateiname

  return $dispfn;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GetMimeType
//|  ...
//|HISTORY:
//|        ...... Pinnacle - erstellt
//| 050326 ...... Brause   - CHANGE: neue Mimetypen und break hinzu
//| 050509 ...... Brause   - FIX: default x-type/subtype, war vorher null
//+-------------------------------------------------------------------------------------------
  function GetMimeType($FileExt){
    $FileExt = strtolower($FileExt);
    switch ($FileExt)
    {
      case "bmp":  return "image/bmp";                      break;
      case "png":  return "image/png";                      break;
      case "gif":  return "image/gif";                      break;
      case "jpeg": return "image/jpeg";                     break;
      case "jpg":  return "image/jpeg";                     break;
      case "jpe":  return "image/jpeg";                     break;
      case "tif":  return "image/tiff";                     break;
      case "tiff": return "image/tiff";                     break;
      case "wav":  return "audio/x-wav";                    break;
      case "mp3":  return "audio/mpeg";                     break;
      case "mov":  return "video/quicktime";                break;
      case "mpe":  return "video/mpeg";                     break;
      case "mp2":  return "video/mpeg";                     break;
      case "mpeg": return "video/mpeg";                     break;
      case "mpg":  return "video/mpeg";                     break;
      case "avi":  return "video/x-msvideo";                break;
      case "txt":  return "text/plain; charset-ISO-8859-1"; break;
	  case "pls":  return "audio/x-scpls pls";              break;
      case "m3u":  return "audio/x-mpegurl";                break;
      default:     return "x-type/subtype";
    }
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: read_plugin_cfg 
//| Liest Pluginconfig aus.
//| $plugin ..... Pfad zu Plugin Directory
//|HISTORY:
//| 050612 ...... brause   - Funktion erstellt
//+-------------------------------------------------------------------------------------------
  function read_plugin_cfg($plugin){
    $plugin_conf = array();
	if (file_exists(OXYL_PLUG.$plugin.'/oxyl_plugin.cfg'))
	{
       $contents=file(OXYL_PLUG.$plugin.'/oxyl_plugin.cfg');
       reset($contents);
       foreach($contents as $content)
       {
    	  $line=trim($content);
      	  if (substr($line,0,1)!='#' && strpos(' '.$line,"=")>0)
      	    $plugin_conf[substr($line,0,strpos($line,'='))]=substr($line,strpos($line,'=')+1);
       }
	   if(!isset($plugin_conf['level'])) $plugin_conf['level'] = 3;
	}
  return $plugin_conf;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: read_pluginorder 
//| Liest config aller Plugins aus.
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 040828 ...... brause   - readplugin Funktion neu aufgebaut, Plugins lassen sich jetzt frei sortieren
//| 050508 ...... brause   - FIX: wenn pluginorder.cfg noch nicht existent kam Fehlermeldung
//| 050718 ...... brause   - CHANGE: sortierung vereinfacht
//| 050718 ...... brause   - CHANGE: read_plugins_cfg umbenannt in read_pluginorder
//| 050731 ...... brause   - FIX: manuell hinzugefgte Pluginsproblem
//+-------------------------------------------------------------------------------------------
  function read_pluginorder(){
    $plugin_view = array();
    if  (file_exists(OXYL_CONF.'pluginorder.cfg'))
    {
	  $contents=file(OXYL_CONF.'pluginorder.cfg');
      reset($contents);
	  $zaehler = 0;
      foreach($contents as $plug_zeile)
      {
    	if ($plug_zeile!="")
		{
    	  $exp = explode("|", $plug_zeile);
		  if(file_exists(OXYL_PLUG.$exp[0])
    	  && file_exists(OXYL_PLUG.$exp[0].'/oxyl_plugin.cfg'))
		  {
			$plugin_view[$zaehler]["path"]  = $exp[0];
			$plugin_view[$zaehler]["show"]  = $exp[1];
			$plugin_view[$zaehler]["gkey"]  = $exp[3];
			$plugin_view[$zaehler]["start"] = $exp[4];
			$plugin_view[$zaehler]["level"] = $exp[5];
			$zaehler++;
    	  }
	    }
	  }
	  ksort($plugin_view);
      reset($plugin_view);
  	}
  return $plugin_view;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: read_plugins
//| Liest Plugins aus.
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 050509 ...... Brause   - FIX: doppelt erscheinende Plugins Bug beseitigt (liegt am Dateisystem)
//| 050514 ...... Brause   - FIX: Notice ber nicht gesetzte Variable
//| 050612 ...... Brause   - CHANGE: einzelnen Code durch read_plugin_cfg ersetzt
//| 050718 ...... Brause   - CHANGE: trans plugin_name entfernt, name jetzt oxyl_plugin.cfg
//|                          wenn bentigt z.B. plugin_name_fr fr FR sonst wird name verwendet
//+-------------------------------------------------------------------------------------------
  function read_plugins(){
    $plugin_dirs =array();
    $plugins = read_pluginorder();

	$zaehler = count($plugins);

    foreach($plugins as $plugis)
	    $plugin_dirs[]=$plugis["path"];
    reset($plugins);

    $directorys=getdirs(OXYL_PLUG);

	foreach($directorys as $directory)
	{
	  if (file_exists(OXYL_PLUG.$directory.'/oxyl_plugin.cfg') && !in_array($directory,$plugin_dirs))
	  {
		$plugins[$zaehler]["path"] = $directory;
		$plugins[$zaehler]["show"] = 1;
		$zaehler++;
	  }
	}

    $plugarr = array();
	if (count($plugins)>0)
	{
	  while (list ($pos, $plugin) = each ($plugins))
	  {
		$tmp = read_plugin_cfg($plugin["path"]);
	    if(!isset($plugarr[$tmp["path"]])) // doppelt erscheinende plugins FIX
		{
		  $plugarr[$plugin["path"]]           = $tmp;
          $plugarr[$plugin["path"]]['locked'] = $plugin["show"] && $plugarr[$plugin["path"]]['Release']>=$GLOBALS['plugin_min_version'] ?
		                                        FALSE : TRUE;
          $plugarr[$plugin["path"]]['pos']    = $pos;
		  $plugarr[$plugin["path"]]['gkey']   = isset($plugins[$pos]["gkey"]) ? $plugins[$pos]["gkey"] : '';
      	  $plugarr[$plugin["path"]]['name']   = isset($plugarr[$plugin["path"]]["plugin_name_".strtolower($GLOBALS['language'])]) ?
		                                        $plugarr[$plugin["path"]]["plugin_name_".strtolower($GLOBALS['language'])] : $plugarr[$plugin["path"]]["name"];
		}
      }
	}

  return $plugarr;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: write_pluginlocks
//| ..
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 050515 ...... Brause   - FIX: Notice fehler entfernt
//| 050608 ...... Brause   - CHANGE: fopen durch create_file ersetzt
//| 050731 ...... brause   - FIX: manuell hinzugefgte Pluginsproblem
//+-------------------------------------------------------------------------------------------
  function write_pluginlocks($plugins){
	$var = '';
	reset($plugins);
	$new_plug = array();
    foreach($plugins as $plugin)
	{
	  $new_plug[$plugin['pos']]['path']   = $plugin['path'];
	  $new_plug[$plugin['pos']]['locked'] = $plugin['locked'] ? 0 : 1;
	  $new_plug[$plugin['pos']]['gkey'] = $plugin['gkey'];
	  $new_plug[$plugin['pos']]['start'] = isset($plugin['start']) ? $plugin['start'] : '';
      $new_plug[$plugin['pos']]['level'] = isset($plugin['level']) ? $plugin['level'] : 3;
	}
	ksort($new_plug);
	reset($new_plug);
    $pos = 0;
	foreach($new_plug as $value)
	{
      $var .= $value['path'].'|'.$value['locked'].'|'.$pos.'|'.$value['gkey'].'|'.$value['start'].'|'.$value['level']."\r\n";
	  $pos++;
	}
 	create_file(OXYL_CONF.'pluginorder.cfg',$var);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: put_devices
//| .......
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 050608 ...... Brause   - CHANGE: fopen create_file ersetzt
//+-------------------------------------------------------------------------------------------
  function put_devices($confi,$devs){
    $var = '';
    reset($devs);
    foreach($devs as $dev)
    {
      if (! isset($dev['level'])) $dev['level']=3;
      $var .= $dev['name'].'|'.$dev['path'].'|'.$dev['level']."\r\n";
    }
	create_file(OXYL_CONF.$confi,$var);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: getstyle
//| .......
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 050616 ...... Brause   - Code verkleinert
//+-------------------------------------------------------------------------------------------
  function getstyle(){
    $path = OXYL_SKIN.$GLOBALS['actskin'].'/oxyl_style.inc';
  return file_exists($path) ? $path : OXYL_SKIN.'default/oxyl_style.inc';
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_button
//| .......
//|HISTORY:
//|        ...... Odu?     - erstellt
//+-------------------------------------------------------------------------------------------
  function gen_button($but,$show=false){
    if((! $GLOBALS['showcenter']) && (! $show))
      return '<img src="'.getimghref('oxyl_nav_key'.$but.'.gif','').'" border=0>';
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GEN_TRANSPIC
//| erzeugt transparentes Bild
//|HISTORY:
//| 050703 ...... Brause   - erstellt
//+-------------------------------------------------------------------------------------------
  function gen_transpic($height=1,$width=1,$add=''){
    return '<img src="'.$GLOBALS['web_trans_image'].'" height='.$height.' width='.$width.' border=0 '.$add.'>';
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: read_skins
//| Liest Plugins aus.
//|HISTORY:
//|        ...... Odu?     - erstellt
//|        ...... LD       - Bugfix wenn skin.cfg im Direcory nicht gefunden wird!
//+-------------------------------------------------------------------------------------------
  function read_skins(){
    $skinarr = array();
    $skins=getdirs(OXYL_SKIN);

	foreach($skins as $skin)
    {
      if (file_exists(OXYL_SKIN.$skin.'/skin.cfg'))
      {
        $contents=file(OXYL_SKIN.$skin.'/skin.cfg');
        reset($contents);
        foreach($contents as $content)
        {
      	  $line=trim($content);
      	  if ((substr($line,0,1)!='#') && (strlen($line)>0))
            $skinarr[$skin][substr($line,0,strpos($line,'='))]=substr($line,strpos($line,'=')+1);
        }
      }
    }
  return $skinarr;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: check_skin
//| Checkt einen Skin. Existieren folgende Dateien: skin.cfg \ oxyl_back.png 
//|HISTORY:
//|        ...... LongDan  - erstellt
//| 050617 ...... Brause   - vereinfacht
//+-------------------------------------------------------------------------------------------
  function check_skin($cskin){
  return   file_exists(OXYL_SKIN.$cskin.'/skin.cfg')
         &&file_exists(OXYL_SKIN.$cskin.'/oxyl_back.png') ? TRUE : FALSE;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: readversion
//| $name ....... Name des versions File
//| $what ....... wieviel Infos notwendig => 1 nur Version, 2 nur Version & datum, 3 nur Version, datum & typ, 0 alle
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 060221 ...... Brause   - NEW: nur version, datum, typ oder all hinzu
//+-------------------------------------------------------------------------------------------
  function readversion($name,$what=0){
    $back = array();
    if (file_exists(OXYL_ROOT.'versions/'.$name.'.ver'))
    {
      $fullfile=file(OXYL_ROOT.'versions/'.$name.'.ver');
      reset($fullfile);
      foreach($fullfile as $line)
      { 
      	$line=trim($line);
      	if (substr($line,0,2)=='V=')
		{
      	  $back['version']=substr($line,2);
		  if($what==1) break;
      	}
		elseif (substr($line,0,2)=='D=')
		{
      	  $back['datum']  =substr($line,2);
		  if($what==2) break;
      	}
      	elseif (substr($line,0,2)=='T=')
		{
      	  $back['typ']    =substr($line,2);
		  if($what==3) break;
      	}
      	else
      	  $back['files'][]=$line;

      }
    }	
    else
    {
      $back['version']=0;
      $back['typ']='?';
      $back['datum']='00.00.0000';
    }
  return $back;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: gen_userlevelpopup
//| generates popup with users
//| $level ...... Level of user
//| $name ....... name of component
//|HISTORY:
//|        ...... Odu?     - erstellt
//+-------------------------------------------------------------------------------------------
  function gen_userlevelpopup($level,$name)
  {
    $userlevels = array( "Admin", "Superuser", "User", "Gast" );
    $out = '<select name="'.$name.'" >'."\n";
    reset($userlevels);
    while(list($nr,$ul)=each($userlevels))
      $out .= '<option value="'.$nr.'"'.($nr==$level?' selected':'').'>'.$ul.'</option>'."\n";
    $out .= '</select>'."\n"; 
    return $out; 
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: get_users
//| ..
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 050327 ...... Brause   - GLOBALS['actuser'],.. jetzt in get_user
//+-------------------------------------------------------------------------------------------
  function get_users(){
    $users = array();
    if (file_exists(OXYL_CONF.'users.cfg'))
    {
      $counter = 0;	
      $allusers=file(OXYL_CONF.'users.cfg');
      reset($allusers);
      foreach($allusers as $user)
      {
      	$userarr = array();
      	$userarr = explode('|',$user);
      	if (count($userarr)>1)
      	{
      	  $users[$counter]['name']=trim($userarr[0]);
      	  $users[$counter]['code']=trim($userarr[1]);
      	  $users[$counter]['level']=trim($userarr[2]);
      	  $counter++;
      	}
      }
      $GLOBALS['users'] = $users;
    }
    else
    {
       $GLOBALS['actuserlevel']=0;
       $GLOBALS['actuser']='ADMIN';
       $GLOBALS['users'][0]['level']=0;
       $GLOBALS['users'][0]['name']='ADMIN';
       $GLOBALS['users'][0]['code']='XXXXXXXXXXXX'; 
    }
  return $users;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: get_user
//| ..
//|HISTORY:
//| 050327 ...... Brause   - erstellt mit Multiusersupport
//| 050610 ...... Brause   - FIX: Onlinezeit wurde falsch berechnet
//|                        - CHANGE: Useraktive Zeite luft wieder neu los, Funktion vereinfacht
//+-------------------------------------------------------------------------------------------
  function get_user(){
    if (!file_exists(OXYL_CONF.'users.cfg')){
      @unlink($OXYL_CONF.'actuser.dat');
      $GLOBALS['actuserlevel']=0;
      $GLOBALS['actuser']='ADMIN';
	}
	else
	{
	  $GLOBALS['actuser']='';
      $GLOBALS['actuserlevel']=3;

      if (file_exists(OXYL_CONF.'actuser.dat'))
      {
         $var = '';
         $actusers = $userdat = array();
         $actusers = file(OXYL_CONF.'actuser.dat');
         foreach($actusers as $actuser)
         {
            $userdat = explode('|',$actuser);
			$now = $GLOBALS['max_online_time']>0 ? date('U') : 0;// wenn autologout deaktiviert
			if((int)$userdat[1]+$GLOBALS['max_online_time']>$now)
			{
               if($userdat[0]==session_id())
               {
                  $GLOBALS['actuser']      =$userdat[2];
                  $GLOBALS['actuserlevel'] =(int)$userdat[3];
			      $var .= $userdat[0].'|'.date('U').'|'.$userdat[2].'|'.$userdat[3].'|'."\r\n";
			   }
			   else
			      $var .= $userdat[0].'|'.$userdat[1].'|'.$userdat[2].'|'.$userdat[3].'|'."\r\n";
            }
         }
	   create_file(OXYL_CONF.'actuser.dat',$var);
	  }
	}
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: set_user
//| ..
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 050308 ...... Brause   - FIX: wenn logindo muss get_users neue eingelesen werden, sonst noch ausgeloggt
//| 050327 ...... Brause   - NEW: Multiusersupport
//| 050508 ...... Brause   - CHANGE: aufruf von getuser entfernt (nicht mehr bentigt)
//|                        - FIX: falsche Startzeit fr Autologout wurde uebergeben
//| 050608 ...... Brause   - CHANGE: Komplettumbau und umstellung auf create_file
//|                        - FIX: Onlinezeit wurde falsch berechnet
//| 050610 ...... Brause   - CHANGE: Funktion vereinfacht
//+-------------------------------------------------------------------------------------------
  function set_user($name){
	$act_users = array();

    $var = aktiv_user();

    get_users();

    foreach($GLOBALS['users'] as $user)
    {
      if (($user['name']==$name))
         $var .= session_id().'|'.date('U').'|'.$user['name'].'|'.$user['level'].'|'."\r\n";
    }
	create_file(OXYL_CONF.'actuser.dat',$var);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: unset_user
//| ..
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 050308 ...... Brause   - FIX: wenn logout muss get_users neue eingelesen werden, sonst noch eingeloggt
//| 050327 ...... Brause   - NEW: Multiusersupport
//| 050508 ...... Brause   - CHANGE: aufruf von getuser entfernt (nicht mehr bentigt)
//|                        - FIX: falsche Startzeit fr Autologout wurde uebergeben
//| 050608 ...... Brause   - CHANGE: Komplettumbau und umstellung auf create_file
//|                        - FIX: Onlinezeit wurde falsch berechnet
//| 050610 ...... Brause   - CHANGE: Funktion vereinfacht
//+-------------------------------------------------------------------------------------------
  function unset_user(){
  return ($v=aktiv_user()) ? create_file(OXYL_CONF.'actuser.dat',$v) : @unlink(OXYL_CONF.'actuser.dat');
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: AKTIV_USER
//| ermittelt alle aktiven User (ohne direkten Remote User)
//|HISTORY:
//| 050608 ...... Brause   - NEW: Funktion erstellt
//+-------------------------------------------------------------------------------------------
  function aktiv_user(){
	$var = '';
    if (file_exists(OXYL_CONF.'actuser.dat'))
	{
	   $act_users = file(OXYL_CONF.'actuser.dat');
       foreach($act_users as $act_user)
	   {
	     $user_parm = explode('|',trim($act_user));
		 $now = $GLOBALS['max_online_time']>0 ? date('U') : 0;// wenn autologout deaktiviert
	     if($user_parm[0]!=session_id()&&(int)$user_parm[1]+$GLOBALS['max_online_time']>$now)
		   $var .= $user_parm[0].'|'.$user_parm[1].'|'.$user_parm[2].'|'.$user_parm[3].'|'."\r\n";
	   }
	}
  return $var;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: put_users
//| ..
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 050608 ...... Brause   - CHANGE: umstellung auf create_file
//+-------------------------------------------------------------------------------------------
  function put_users($confi,$users){
    if ((is_array($users)) && (count($users)>0))
    { 
	  $var = '';
      reset($users);
      foreach($users as $user)
        $var .= $user['name'].'|'.$user['code'].'|'.$user['level']."\r\n";
      create_file(OXYL_CONF.'users.cfg',$var);
    }
    else
    @unlink(OXYL_CONF.'users.cfg');
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: read_web
//| ..
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 050718 ...... Brause   - CHANGE: Fehlermeldung verbessert
//+-------------------------------------------------------------------------------------------
  function read_web($url,$maxsize=1000000){
    $content = '';
    $counter = 0;
	$c_max = 5;
    while(($counter<$c_max) && (strlen($content)<10))    
    {
      $counter++;
	  if(!$fh = @fopen($url,'rb'))
	  {
	    echo "Can't connect to ".$url." -> ".($c_max-$counter)." trys left<br>";
		sleep(2);
        flush();
	  }
	  else
	  {
        while (!feof($fh))
          $content .= fread($fh,1024);
        fclose($fh);
	  }
    }
  return $content;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GetStreamPort
//| Wenn config/StreamPort.cfg existiert wird die Datei ausgelesen und dieser Port zurckgegeben!
//|HISTORY:
//|        ...... stolle   - erstellt
//| 050608 ...... Brause   - CHANGE: umstellung auf read_file
//+-------------------------------------------------------------------------------------------
  function GetStreamPort($port){
  return ($p2 = read_file(OXYL_CONF.'StreamPort.cfg')) ? $p2 : $port;
  }
//===================================BOX CONTROL==============================================
//+-------------------------------------------------------------------------------------------
//|FUNKTION: BOX_LED_MODE
//| Steuert die "New Media" LED am Showcenter
//| ON    = Led ON
//| OFF   = Led Off
//| blink = Led blinks
//|HISTORY:
//| 041129 ...... LongDan  - erstellt
//| 050110 ...... Brause   - FIX lange Zugriffszeit vom PC
//| 050308 ...... Brause   - FIX: in Verbindung mit EVER_SHOWCENTER lange Zugriffszeit vom PC
//+-------------------------------------------------------------------------------------------
  function BOX_LED_MODE($mode){
    if(!isset($GLOBALS['PC'])){
      $ledmode ='http://' . $_SERVER['REMOTE_ADDR'] . ':2020/LED_indicate.cgi?%7FStatusLED=' . strtoupper($mode) . '"';
      $box=@fopen($ledmode,'r');
      @fclose($box);
    }
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: PBar_Position
//| Steuert die Position der Audio Progress Bar.
//|  x=".$x."y=".$y    = Led ON
//|HISTORY:
//| 041129 ...... LongDan  - erstellt
//| 050308 ...... Brause   - FIX: lange Zugriffszeit vom PC
//+-------------------------------------------------------------------------------------------
  function BOX_PBAR_POS($xpos,$ypos){
    if(!isset($GLOBALS['PC'])){
      $pbarpos ='http://' . $_SERVER['REMOTE_ADDR'] . ':2020/pod_audio_info.cgi?x=' . $xpos . '?y=' . $ypos . '"';
      $box=@fopen($pbarpos,'r');
      @fclose($box);
    }
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: BOX_REFRESH
//| Refresht die Box
//|HISTORY:
//| 041129 ...... LongDan  - erstellt
//+-------------------------------------------------------------------------------------------
  function BOX_REFRESH(){
    $boxref ='http://' . $GLOBALS['showcenter_ip'] . ':2020/refresh_browser.cgi';
    $box=@fopen($boxref,'r');
    @fclose($box);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: BOX_REMOTE
//| Steuert das Showcenter via TCP/IP
//| $remkey = Taste der Fernbedienung
//| KEY_MUTE     = Mute
//| KEY_ENTER    = OK
//|HISTORY:
//| 041129 ...... LongDan  - erstellt
//+-------------------------------------------------------------------------------------------
  function BOX_REMOTE($remkey){
    $remmode ='http://' . $GLOBALS['showcenter_ip'] . ':2020/ethernet_rc.cgi?%7Fsim_key=' . strtoupper($remkey);
    $box=@fopen($remmode,'r');
    @fclose($box);
  }
//===================================BOX CONTROL END==========================================
//+-------------------------------------------------------------------------------------------
//|FUNKTION: SUBTITLE_CHECK
//| Funktionen fr die Subtitel
//|HISTORY:
//| 041129 ...... LongDan  - erstellt
//| 050828 ...... Brause   - CHANGE: Funktion vereinfacht
//+-------------------------------------------------------------------------------------------
  function SUBTITLE_CHECK($acpa,$file='',$func){
    if ($func=='FILE')
    {
      $sfilebase = DEL_EXT($acpa.'/'.$file).'.sub';
      if(file_exists($sfilebase))
	    return $sfilebase;
    }

    if ($func=='CHECK')
      return file_exists(DEL_EXT($acpa.'/'.$file).'.sub') ? TRUE : FALSE;

    if ($func=='EXIST')
      return count(getfiles($acpa,array('sub','suo'),true));

    if ($func=='LIST')
      return getfiles($acpa,'sub',true); 
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: REMOTE_FILE_EXISTS
//| prft ob URL existiert oder nicht
//| $url ........ zu prfende URL
//| $agent ...... welcher User Agent verwendet werden soll
//| $extend ..... ob auch nicht bekannte Codes ausgewertet werden sollen
//| $timeout .... timeout der fsockverbindung
//|HISTORY:
//| 040819 ...... .fischer - aus dem Internet geklaut und adaptiert...
//| 050710 ...... Brause   - Change: Funktionalitt in get_server_header ausgelagert
//| 050731 ...... Brause   - FIX: erkennung von ICY (bei Shoutcast verwendet)
//| 050731 ...... Brause   - NEW: $agent bergabe hinzu (bergabe an GET_SERVER_HEADER Funktion)
//| 060322 ...... Brause   - NEW: $timeout bergabe hinzu (bergabe an GET_SERVER_HEADER Funktion)
//+-------------------------------------------------------------------------------------------
  function remote_file_exists($url,$agent='Mozilla/4.0',$extend=FALSE,$timeout = 10){
    if(!$headers = get_server_header($url,$agent,$timeout))
	  return FALSE;

    if (preg_match('"(HTTP/1\.\d|ICY)\s20\d"i', $headers))
      return TRUE;
    if (preg_match('"(HTTP/1\.\d|ICY)\s(4\d\d|50\d)"i', $headers))
      return FALSE;
    if (preg_match('"(HTTP/1\.\d|ICY)\s30\d"i', $headers))
    {
       preg_match("/Location:\s(.+)\r/i", $headers, $matches);
       if(!isset($matches[1]))
         return false;
       return remote_file_exists(trim($matches[1]),$agent,$extend,$timeout);
    }
    if($extend)
	{
      preg_match('"(HTTP/1\.\d|ICY)\s\d\d\d"i', $headers, $matches);
      echo 'Status Code not supported'.(isset($matches[1])?": $matches[1]":'').'<br>';
	}
  return FALSE;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: REMOTE_FILESIZE
//| gibt Filesize von Remote File zurck
//| $url ........ zu prfende Datei
//| $agent ...... welcher User Agent verwendet werden soll
//| $timeout .... timeout der fsockverbindung
//|HISTORY:
//| 050516 ...... Brause   - Funktion erstellt
//| 050710 ...... Brause   - Change: Funktionalitt in get_server_header ausgelagert
//| 050731 ...... Brause   - NEW: $agent bergabe hinzu (bergabe an GET_SERVER_HEADER Funktion)
//+-------------------------------------------------------------------------------------------
  function remote_filesize($url,$agent='Mozilla/4.0',$timeout = 10){
  return preg_match('/Content-Length:\s([0-9]*)\s/',get_server_header($url,$agent,$timeout),$matches) ? $matches[1] : 0; 
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: REMOTE_FILEMTIME
//| gibt letzte Modifikationszeit als Unixtimestamp von Remote Files zurck
//| $uri ........ zu prfende Datei
//| $agent ...... welcher User Agent verwendet werden soll
//| $timeout .... timeout der fsockverbindung
//|HISTORY:
//| 050516 ...... Brause   - Funktion erstellt
//| 050710 ...... Brause   - Change: Funktionalitt in get_server_header ausgelagert
//| 050731 ...... Brause   - NEW: $agent bergabe hinzu (bergabe an GET_SERVER_HEADER Funktion)
//+-------------------------------------------------------------------------------------------
  function remote_filemtime($url,$agent='Mozilla/4.0',$timeout = 10){
  return preg_match('/Last-Modified:\s(.*)\n/i',get_server_header($url,$agent,$timeout),$matches) ? strtotime(trim($matches[1])) : 0;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: REMOTE_FILETYP
//| gibt mime typ von remote Datei wieder
//| $uri ........ zu prfende Datei
//| $agent ...... welcher User Agent verwendet werden soll
//| $timeout .... timeout der fsockverbindung
//|HISTORY:
//| 050715 ...... Brause   - Funktion erstellt
//| 050731 ...... Brause   - NEW: $agent bergabe hinzu (bergabe an GET_SERVER_HEADER Funktion)
//+-------------------------------------------------------------------------------------------
  function remote_filetyp($url,$agent='Mozilla/4.0',$timeout = 10){
  return preg_match('/Content-Type:\s(.*)\n/i',get_server_header($url,$agent,$timeout),$matches) ? trim($matches[1]) : 0;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GET_SERVER_HEADER
//| forder Server zu http request auf
//| $uri ........ zu prfende Datei
//| $agent ...... welcher User Agent verwendet werden soll
//| $timeout .... timeout der fsockverbindung
//|HISTORY:
//| 050710 ...... Brause   - Funktion neu erstellt, da alte bugig war (jetzt sauberer Code)
//| 050731 ...... Brause   - FIX: falls Gegenstelle HEAD Request nicht akzeptiert
//|                        - NEW: $agent bergabe hinzu (da einige Website den request Agent abhngig gestalten)
//+-------------------------------------------------------------------------------------------
  function get_server_header($url,$agent='Mozilla/4.0',$timeout = 10){
    $url_p = parse_url($url);
	if (isset($url_p['host']))
	{
	  $host = $url_p['host'];
	  $port = isset($url_p['port']) ?     $url_p['port']  : 80;
      $path = isset($url_p['path']) ?     $url_p['path']  : '/';
      $parm = isset($url_p['query'])? '?'.$url_p['query'] : '';
    }
	else // bei Oxyl prfen
	{
      $host = $_SERVER['SERVER_ADDR'];
      $port = $_SERVER['SERVER_PORT'];
      $path = substr($url,0,1)=='/' ? $url : '/'.$url ;
      $parm = '';
    }
    if(!$fp = @fsockopen ($host, $port, $errno, $errstr, $timeout))
      return FALSE;
    else
    {
      fputs($fp, "HEAD ".$path.$parm." HTTP/1.1\r\n");
      fputs($fp, "HOST: ".$host.($port!=80 ? ':'.$port : '')."\r\n");
      fputs($fp, "User-Agent: ".$agent."\r\n");
      fputs($fp, "Accept: */*\r\n");
      fputs($fp, "Connection: close\r\n\r\n");

      $headers = '';
      while (!feof($fp))
        $headers .= fgets ($fp,128);
	}
    fclose ($fp);
    if(trim($headers) == '')// falls gegenstelle HEAD Request nicht akzeptiert (nicht besonders tolle Lsung)
	{
      if(!$fp2 = @fsockopen ($host, $port, $errno, $errstr, $timeout))
        return FALSE;
      else
      {
        fputs($fp2, "GET ".$path.$parm." HTTP/1.1\r\n");
        fputs($fp2, "HOST: ".$host.($port!=80 ? ':'.$port : '')."\r\n");
        fputs($fp2, "User-Agent: ".$agent."\r\n");
        fputs($fp2, "Accept: */*\r\n");
        fputs($fp2, "Connection: close\r\n\r\n");

		$z=0;
        while ($z<10&&!isset($close))// wertet die ersten 10 Zeilen des request aus bzw. bis "Connection close" gesendet wird
		{
		  $line = fgets ($fp2,128);
		  if(preg_match('"Connection:\sclose"i',$line))
		    $close = 1;
   	      $headers .= $line;
		  $z++;
		}
	  }
      fclose ($fp2);
	}
	//debugging
	//echo '<b>'.$host.($port!=80 ? ':'.$port : '').$path.$parm.'</b><br>'.nl2br($headers).'<br>';
    return $headers;
}//+-------------------------------------------------------------------------------------------
//|FUNKTION: GET_FOLDERSIZE
//| gibt Gre von Ordner zurck
//| $folder ..... zu prfender Ordner
//|HISTORY:
//| 050605 ...... Brause   - Funktion erstellt
//+-------------------------------------------------------------------------------------------
  function get_foldersize($folder)
  {
    $totalsize =0;
    $sourcedir = opendir($folder);
    while(false !== ($filename = readdir($sourcedir)))
    {
      if($filename != "." && $filename != "..")
      {
        if(is_dir($folder."/".$filename))// recurse subdirectory; call of function recursive
          $totalsize += get_foldersize($folder."/".$filename);
        else if(is_file($folder."/".$filename))
		  $totalsize += filesize($folder."/".$filename);
      }
    }
    closedir($sourcedir);
  return $totalsize;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: FORMAT_BYTESIZE
//| formatiert bytes in lesbare Gre
//| $size ....... zu formatierende Dateigre
//| $what ....... was zurck gegeben werden soll; 3 => 123 MB, 1 => 123, 2 => MB
//| $decimals ... anzahl der nachkommastellen
//| $switchsize . ab welcher Gre auf die nchst hhere Einheit umgerechnet wird
//|HISTORY:
//| 050605 ...... Brause   - Funktion erstellt
//+-------------------------------------------------------------------------------------------
  function format_bytesize($size,$what=3,$decimals=2,$switchsize=901) {
    // bis Zettabyte und Yottabyte, wer wei was die User fr Speicherplatz haben ;-)
	$units = array(' B', ' KB', ' MB', ' GB', ' TB', ' PB', ' EB', ' ZB', ' YB');
    for($i = 0; $size > $switchsize && $i<9; $i++)
       $size /= 1024;

	$size = format_number($size,$decimals);

  return ($what&1 ? $size : '').($what&2 ? $units[$i] : '');
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: FORMAT_NUMBER
//| formatiert zahl mit tausender Trennzeichen
//| $number ..... zu formatierende Zahl
//| $decimals ... anzahl der nachkommastellen
//|HISTORY:
//| 050615 ...... Brause   - Funktion erstellt
//| 050723 ...... Brause   - seperator kommt jetzt aus const.inc
//+-------------------------------------------------------------------------------------------
  function format_number($size,$decimals=0) {
	$sep = $GLOBALS['language_sep'][$GLOBALS['language']];
  return number_format(round($size,$decimals),$decimals,$sep[0],$sep[1]);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: ip_check
//| prft ob IP syntaktisch korrekt ist
//| $ip ......... zu prfende IP
//|HISTORY:
//| 041212 ...... LongDan  - aus dem Internet kopiert und adaptiert...
//| 050715  ..... Brause   - CHANGE: vereinfacht
//+-------------------------------------------------------------------------------------------
  function ip_check($ip){
    $ip_array = explode(".", $ip);
    if(count($ip_array) <> 4)
      return FALSE;
    for ($loop = 0; $loop < 4; $loop++)
    {
      if(!is_numeric($ip_array[$loop]))
        return FALSE;
      if($ip_array[$loop] > 254)
        return FALSE;
      if ($ip_array[$loop] < 1 && ($loop == 0 OR $loop == 3))
        return FALSE;
      if($ip_array[$loop] < 0)
        return FALSE;
    }
  return TRUE;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: thumb_caching
//| speichert Liste mit erzeugten Thumbnails
//| $pluginname . Pluginname
//|HISTORY:
//| 0411?? ...... Odu?     - Grundfunktion erstellt
//| 040828 ...... brause   - Bug mit eof entfernt
//| 050114 ...... brause   - Funktion erstellt und ausgelagert
//| 050328 ...... brause   - mkdir durch check_dirs ersetzt
//| 050608  ..... Brause   - CHANGE: umstellung auf read_file
//+-------------------------------------------------------------------------------------------
  function thumb_caching($pluginname){
    $filename=OXYL_TEMP.$pluginname.'/thumbs.dat';
    $GLOBALS['thumbs']=array();                                                       //vorschauverzeichniss anlegen
    if(file_exists($filename)) 								                          //wenn im temp pfad bereits eine thumbs.dat existiert 
       $GLOBALS['thumbs']=unserialize(read_file($filename,TRUE,filesize($filename))); //diese ffnen 
    else                                                                              //ansonsten
      check_dirs(OXYL_TEMP.$pluginname);                                              //pfad fr das pic-temp verzeichnis anlegen
  return $GLOBALS['thumbs'];
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GETTHUMBHREF
//| gets thumbs from cache or creates new for cache
//| $fn ......... imagefilename
//| $height ..... max. Hhe des geforderten Vorschaubildes
//| $width ...... max. Breite des geforderten Vorschaubildes
//| $enlarge .... ob Bild wenn zu klein auch vergrert werden soll
//| $pluginname . Name des Plugins fr welches die Vorschaubilder erzeugt werden
//| $add ........ Dateiname anfang um thumbs und previwes zu unterscheiden
//| $maxcachesize Anzahl der Vorschaubilder die im Cache gespeichert werden sollen (optional)
//|HISTORY:
//|        ...... odu? Funktion erstellt
//| 040709 ...... .fischer - funktion etwas verallgemeinert und damit beide versionen
//|                          aus oxyl_video und oxyl_pic vereinheitlicht
//| 050107 ...... brause   - $width und $height als Variablen $global_height und $global_width eingefuehrt
//|                          und direkt vor Funktion eingefuegt, Groesse auf 4:3 gesetzt das Bilder nicht so
//|                          unordentlich sind; ueber setup einstellbar
//|                        - nconvert macht aus gifs gifs, png pngs, ... (mit Hilfe get_ext Funktion)
//| 050110 ...... brause   - script ueberprueft ob vorschaudatei nicht nur thumbs sondern auch existiert
//|                        - png, bmp, tiff werden jetzt auch konvertiert
//| 050114 ...... brause   - Funktion in functions.inc abgelegt
//| 050308 ...... brause   - NEW: $maxcachesize kann jetzt angegeben werden,
//|                          default wert in const.inc $GLOBALS['maxcachesize']
//|                          -1 = default Wert, 0 = keine Begrenzung
//| 05075 ...... brause   - FIX: Cache leeren hat nicht funktioniert
//| 050706 ...... brause   - NEW: $add um mehr unterscheidungsmglichkeiten zu erhalten
//| 050710 ...... brause   - NEW: $enlarge hinzu
//+-------------------------------------------------------------------------------------------
  function getthumbhref($fn,$height,$width,$enlarge=0,$pluginname,$add='',$maxcachesize=-1){//pfad zu vorschaubild fr bild $fn laden und ev. vorschaubild erzeugen
    if($maxcachesize==-1)                                                                   //max. anzahl vorschaubilder festlegen
      $maxcachesize= $GLOBALS['maxcachesize'];                                              //wenn kein wert vorgegeben, dann defaultwert
    $back=1;                                                                                //testwert setzen zur berprfung ob vorschaubild erfolgreich erzeugt bzw. geladen werden konnte
    // neu Brause
    $img_ext = get_ext($fn);                                                                // extension von bild herausfinden
    $img_ext_check = in_array($img_ext,$GLOBALS['imageextensions_nohtml']) ? "jpg":$img_ext;//wenn z.B. bmp dann existiert nur jpg thumbnail
    if (isset($GLOBALS['thumbs'][$add.'|'.$fn]))                                            // ob variable fuer bild bereits gesetzt
	 $thumbname = OXYL_TEMP.$pluginname.'/'.$GLOBALS['thumbs'][$add.'|'.$fn].'.'.$img_ext_check;
	else
	 $thumbname = "unknown";

	if(file_exists($thumbname))                                                             //falls vorschau fr diese bild bereits existiert
      return geturl($thumbname);                                                            //den pfad zum vorschaubild in $back schreiben
    else                                                                                    //ansonsten
    {
      if (count($GLOBALS['thumbs']) >= $maxcachesize||$maxcachesize==0)                     //wenn maximale cachegrsse fr vorschaubilder noch nicht erreicht
      {
	    reset($GLOBALS['thumbs']);                                                          //springe zu erstem element in vorschauverzeichnis
        $val = current($GLOBALS['thumbs']);
        $key = key($GLOBALS['thumbs']);
		unset($GLOBALS['thumbs'][$key]);                                                    //lsche dieses element aus dem vorschauverzeichnis
        $exti = get_ext($key);
		$img_exti = in_array($exti,$GLOBALS['imageextensions_nohtml']) ? 'jpg' : $exti;
        @unlink(OXYL_TEMP.$pluginname.'/'.$val.'.'.$img_exti);                              //diese lschen
	  }

      $newfilename=md5(date('His').$fn);                                                    //erzeuge namen fr vorschaubild aus aktueller zeit und dateinamen

      // gen thumb
	  if(!($new_size = getsize_minimaxi($fn,$width,$height,$enlarge)))                      // ruft Funktion zur Grenberechnung auf
	    return OXYL_WEB.'/'.$GLOBALS['default_image'].'" width="'.$width;
      if($img_ext=="jpg"||$img_ext=="jpe"||$img_ext=="jpeg"||in_array($img_ext,$GLOBALS['imageextensions_nohtml'])){
		$img_ext2="jpeg"; 
		$img_ext3="jpg";
	  }
	  else 
	    $img_ext2=$img_ext3=$img_ext;
      $back=OXYL_TEMP.$pluginname.'/'.$newfilename.'.'.$img_ext3;                           //den pfad zum vorschaubild in $back schreiben
      // nconvert aufrufen bzw. GD Lib,$img_ext,70,$new_size[2],$new_size[3],true,$width,$height
      if(!do_imgconvert($fn,$back,$new_size[0],$new_size[1],$img_ext2))
	    return OXYL_WEB.'/'.$GLOBALS['default_image'].'" width="'.$width;

      $GLOBALS['thumbs'][$add.'|'.$fn]=$newfilename;                                        //setze daten fr neues vorschaubild in vorschauverzeichnis
    }
  return geturl($back);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GETSIZE_MINIMAXI
//| berechnet neue Gre ohne Verzerrung wenn bild zu gro
//| gibt Array zurck (neue breite, neue hhe, org breite, org hhe)
//| $fn ......... imagefilename
//| $width ...... max. Breite des geforderten Vorschaubildes
//| $height ..... max. Hhe des geforderten Vorschaubildes
//| $enlarge .... ob Bild wenn zu klein auch vergrert werden soll
//|HISTORY:
//| 050114 ...... brause   - Funktion erstellt
//| 050710 ...... brause   - CHANGE: $width mit $height getauscht wegen durchgngigkeit
//+-------------------------------------------------------------------------------------------
  function getsize_minimaxi($fn,$width,$height,$enlarge=0){  //pfad zu vorschaubild fr bild $fn laden und ev. verkleinern
    if(!($fileinfo = @GetImageSize($fn)))                // daten des originalbildes auslesen: breite und hhe
	  return FALSE;
    $thumb[0] = $fileinfo[0]>0 ? $fileinfo[0] : $width;  // thumnails erhalten ersteinmal orggroesse + Ueberpruefung auf getimmagesizefunction
    $thumb[1] = $fileinfo[1]>0 ? $fileinfo[1] : $height; // thumnails erhalten ersteinmal orggroesse + Ueberpruefung auf getimmagesizefunction
	if($enlarge)
	  $thumb = $fileinfo[0]/$fileinfo[1] > $width/$height ? 
	           array($width,round($fileinfo[1] / $fileinfo[0] * $width)) : 
			   array(round($fileinfo[0] / $fileinfo[1] * $height),$height);
    else
	{
      $thumb = $thumb[0] > $width ?                                    	   // wenn orgbreite groesser als maxbreite von thumb
	           array($width,round($width * $fileinfo[1] / $fileinfo[0])):  // dann umrechnen
			   array($thumb[0],$thumb[1]);
      $thumb = $thumb[1] > $height ?						               // wenn orghoehe groesser als maxhoehe
   	           array(round($height * $fileinfo[0] / $fileinfo[1]),$height):// dann umrechnen
               array($thumb[0],$thumb[1]);
    }
  return array ($thumb[0], $thumb[1], $fileinfo[0], $fileinfo[1]);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: DO_IMGCONVERT
//| Bilderresize mit Hilfe von nconvert
//| $orgpfad .... imagefilename_org
//| $newpfad .... neuer Filename
//| $width ...... Breite
//| $height ..... Hhe
//| $new_ext .... Zielbildformat
//| $org_ext .... Ursprungsbildformat
//| $quali ...... Komprimierungsqualitt
//| $o_width .... Original Breite
//| $o_height ... Original Hhe
//|HISTORY:
//| 050114 ...... brause   - Funktion erstellt
//| 050319 ...... brause   - FIX: leere Pfade zu nconvert konnten nicht verarbeitet werden
//|                          windows kommt nicht mit hochkommas im befehlsnamen klar, dasher umweg ber putenv,
//|                          bei linux befehl in hochkommas gepackt
//|                        - FIX: bilder mit wenig Farben konnten nicht erzeugt werden
//| 050605 ...... brause   - FIX: jpe Dateien hinzu
//+-------------------------------------------------------------------------------------------
  function do_imgconvert($orgpfad,$newpfad,$width,$height,$new_ext,$org_ext='',$quali=80,$o_width=0,$o_height=0){    
    if($org_ext!=''&&in_array($org_ext,$GLOBALS['imageextensions_nonc'])&&$GLOBALS['GDLIB_SUPPORT']){//gd_lib aufruf
      $create_img = FALSE;																// schalter ob bild erzeugt werden soll
      if($org_ext=="png"){ 																//prueft ob bild png 
  	    $simg = ImageCreateFromPNG($orgpfad);
	    $create_img = TRUE;
      }
 	  elseif($org_ext=="gif"){ 														     //prueft ob bild gif
  	    $simg = ImageCreateFromGIF($orgpfad);
	    $create_img = TRUE;
 	  }
 	  elseif($org_ext=="jpg"||$org_ext=="jpe"||$img_ext=="jpeg"){ 	    				 //prueft ob bild jpg
  	    $simg = ImageCreateFromJPEG($orgpfad);
	    $create_img = TRUE;
      }
	  if($create_img){                                                                   // wenn bild konertiert werden kann
		$img = @ImageCreateTrueColor($width-1,$height-1) 								 // erzeugt leeres bild, die -1 entfernt die schwarzen Raender
		     or $img =   ImageCreate($width-1,$height-1);								 // ersatzfunction wenn gdlib kleiner 2
	    ImageFill($img, 0, 0,ImageColorAllocate($img,255,255,255)); 					 // erstell weissen Hintergrund
		$ppp =imagecopyresampled ($img,$simg,0,0,0,0,$width,$height,$o_width,$o_height)  // scaliert bild auf thumbnailgroesse
		     or imagecopyresized ($img,$simg,0,0,0,0,$width,$height,$o_width,$o_height); // ersatzfunction wenn gdlib kleiner 2
	    ImageJPEG($img, $newpfad, $quali );	                                             // erzeugt aus bild ein jpeg und speichert es
	    ImageDestroy($img );                                                             // leert speicher
	  }
	  return $create_img;
    }
    else{
	  if($GLOBALS['system']=='windows'){                                                 // pfad zu betriebssystemspezifischem nconvert programm bestimmen
        if(!stristr( getenv("Path"),OXYL_EXEC))                                          // fgt pfad zu nconvert als Path variable zu
	      @putenv ('Path='.getenv("Path").';'.OXYL_EXEC);
	    $app='nconvert.exe';
	  }
      else
        $app='nconvert';
      if(!file_exists(OXYL_EXEC.$app))                                                   // wenn applikation nicht existiert
	    return FALSE;

      $parm_truecolor = $new_ext!="gif" ? " -truecolours" : "";                          // fix, sonnst knnen z.B. bmps mit wenigen Farben nicht erzeugt werden

      $string = ' -out '.$new_ext.$parm_truecolor.' -q '.$quali.' -resize '.$width.' '.$height.' -o "'.$newpfad.'" "'.$orgpfad.'"';

	  $command = ($GLOBALS['system']=='windows') ? $app.$string : $command = '"'.OXYL_EXEC.$app.'"'.$string; // pfad zu betriebssystemspezifischem nconvert programm bestimmen

	  @exec($command);
      return TRUE;
    }
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: DOWNLOAD_FILE
//| download a File
//| $file ....... filename
//|HISTORY:
//| 050327 ...... brause   - Funktion erstelllt
//| 050616 ...... Brause   - minimiert (Cache Control braucht der Internet Explorer
//+-------------------------------------------------------------------------------------------
  function download_file($File){
    Header("HTTP/1.1 200 OK");
    Header("Content-Length: ".filesize($File));
    Header("Content-Type: ".GetMimeType(get_ext($File)));
    Header("Last-Modified: " .gmdate("D, d M Y H:i:s"). " GMT");
    Header("Accept-Ranges: bytes");
    Header("Connection: close");
    //Header("Content-Transfer-Encoding: binary"); 
    //Header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
    Header("Cache-Control: no-cache");
    //Header("Pragma: no-cache");
    //Header("Pragma: public");*/
    Header("Cache-Control: private");
    //Header("Cache-Control: post-check=0, pre-check=0");
    Header("Content-Disposition: inline; filename=".basename($File));
    //Header("Content-Disposition: filename=".basename($File));
    @readfile($File);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: OXYL_ENCODE
//| "verschlsselt" bergabe Werte, dient um code sauberer zu bertragen
//| $wert ....... zu codierender Wert
//|HISTORY:
//| 060228 ...... Brause   - Funktion erstelllt
//+-------------------------------------------------------------------------------------------
  function oxyl_encode($wert){
  return $GLOBALS['OXYL_DEBUG'] ? $wert : base64_encode('OXYL_ENCODED'.$wert);
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: OXYL_DECODE
//| "entschlsselt" bergabe Werte, welche mit OXYL_ENCODE "verschlsselt" wurden
//| Funktion berprft ob mit OXYL_ENCODE "verschlsselt" wurde
//| $wert ....... zu decodierender Wert
//|HISTORY:
//| 060228 ...... Brause   - Funktion erstelllt
//+-------------------------------------------------------------------------------------------
  function oxyl_decode($wert){
    $decode = base64_decode($wert);
  return strpos($decode,'OXYL_ENCODED')===0 ? substr($decode,12) : $wert;
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: GetLastPos
//| Liefert den Text fr die Angabe der letzten angeschauten Position
//| $filename.... Aktuelle Datei
//|HISTORY:
//| 041217 ...... stolle   - Erstellt
//| 050608 ...... Brause   - CHANGE: umstellung auf read_file
//| 050725 ...... Brause   - FIX: leerzeichen entfernt
//+-------------------------------------------------------------------------------------------
  function GetLastPos($filename){
  return file_exists($filename.'.lastpos') ? read_file($filename.'.lastpos') : 0;
  }
//------------------ END valid Functions ----------------------------------------

//###############################################################################################
//###############################################################################################
//###############################################################################################
//
//   O L D   F U N C T I O N S  ->  Don't use Functions below, only for old Plugins
//
//###############################################################################################
//###############################################################################################
//###############################################################################################

//+-------------------------------------------------------------------------------------------
//|FUNKTION: GET_BASEDIR
//| liefert den Pfad des aktuellen Basisverzeichnisses zurck
//| $path ....... Pfad zum aktuellen Verzeichnis
//| $hist ....... History mit welchem die Anzahl der Unterverzeichnisse seit
//|               Basisverzeichnis berechnet werden kann
//|HISTORY:
//| 050718 ...... Brause   - Funktion aus getbasedir erstellt
//+-------------------------------------------------------------------------------------------
  function get_basedir($path, $hist){
    for($i=$hist;$i>0;$i--)
      $path=substr($path,0,strrpos($path, "/"));
  return $path;
  }
//+-------------------------------------------------------------------------------------------
//| FUNKTION: IS_SHOWCENTER
//|  berprft ob Client ein Pinnacle Showcenter bzw. Derivat ist oder nicht
//|  History:
//|            .............. Odu?   - erstellt
//| 20050130 ................ Brause - Funktion auf $GLOBALS['showcenter'] umgestellt -> Wartungsaufwand kleiner
//+-------------------------------------------------------------------------------------------
  function is_showcenter(){
  return $GLOBALS['showcenter'];
  }
//+-------------------------------------------------------------------------------------------
//|FUNKTION: read_plugins_cfg 
//| Liest config aller Plugins aus.
//|HISTORY:
//|        ...... Odu?     - erstellt
//| 040828 ...... brause   - readplugin Funktion neu aufgebaut, Plugins lassen sich jetzt frei sortieren
//| 050508 ...... brause   - FIX: wenn pluginorder.cfg noch nicht existent kam Fehlermeldung
//| 050718 ...... brause   - CHANGE: sortierung vereinfacht
//| 050817 ...... brause   - orginal Funktion read_plugins_cfg umbenannt in read_pluginorder
//+-------------------------------------------------------------------------------------------
  function read_plugins_cfg(){
    read_pluginorder();
  }
//---------------------------------------------E-O-F------------------------------------------------
?>
