<?php 
//####################################### Oxyl~Box 2.0 #####################################################

//+-------------------------------------------------------------------------------------------
//| oxyl_box_check.php
//| checks the oxyl box installation
//|History:
//| 041115 .............. LongDan - erstellt
//| 041201 .............. LongDan - Moved to common and $back for backjump defined
//| 041204 .............. LongDan - Errorhandling verbessert
//| 041207 .............. LongDan - Create Dir eingebaut!!
//| 050120 .............. Brause  - HMTL Code korrigiert
//|                               - temp path und playlist path testet jetzz ob ordner,file oder leer
//| 050508 .............. Brause  - CHANGE: $GLOBALS ['OXYL_ROOT'] anstatt _SERVER['DOCUMENT_ROOT']
//| 050605 .............. Brause  - FIX: Pfadcheck wurde userlevel ignoriert, nicht berechtigte pfade werden nicht mehr angezeigt
//| 050605 .............. Brause  - FIX: FileBrowser Check hinzu
//| 060122 .............. Brause  - FIX: Netzlaufwerke werden getestet
//| 060219 .............. Brause  - CHANGE: OXYL_HP constante hinzu
//+---------------------------------------------------------------------------------------------------

  include_once('design.inc');

//----------------------------------------------------------------------------------------------------
 $progcall = '<form action="oxyl_box_check.php" method="post" name="###">';

// Creates Directory if needed
//-------------------------------
if (isset($action) && $action=='mkdir')
   {
    check_dirs($dir);
   }

// Logfilekopf

$LOGFile  = "\r\n";
$LOGFile .= '+---------------------------------------------------------------------------------+' . "\r\n";
$LOGFile .= '|  oxyl~box Check  START                 ' . date("j M Y - H:i:s"). "\r\n";
$LOGFile .= '+---------------------------------------------------------------------------------+' . "\r\n";
$LOGFile .= '|  Server IP: ' . $GLOBALS['ip'] . '  Port: ' . $GLOBALS['port'] .  "\r\n";
$LOGFile .= '+---------------------------------------------------------------------------------+' . "\r\n";
$LOGFile .= '|  Operating System:   ' . PHP_OS  . "\r\n";
$LOGFile .= '|  Webserver Software: ' . $_SERVER["SERVER_SOFTWARE"]  . "\r\n";
$LOGFile .= '|  PHP Version:        ' . PHP_VERSION  . "\r\n";
$LOGFile .= '+---------------------------------------------------------------------------------+' . "\r\n";
$LOGFile .= '' . "\r\n";

// Parameter
$frwidth  = 400;
$frwidth2 = 100;
//$tabwidth = 500;
$io  = getimghref('oxyl_nav_ok.gif');
$nio = getimghref('oxyl_nav_cancel.gif');

gen_header_setup();

echo '<blockquote><h1><u>Oxyl Check ' . OXYLBOX_VERSION. '</u></h1>';
echo '<table border="1" cellpadding=5><tr><td>';

echo '<table>';

// Internet Check
//---------------------------------------------------------------------------------------
echo '<tr><td colspan=3><b>Oxylbox Versionen:</b></td></tr>';

//oxylbox version
echo '<tr><td><font size=2>Oxyl~Box Version:&nbsp;</font></td>';
echo '<td><font size=2>'.OXYLBOX_VERSION.'&nbsp;(Rel. '.OXYLBOX_RELEASE.'&nbsp;Kern&nbsp;'.OXYLBOX_KERN.')</font></td>';
echo '<td><img src="'.(defined('OXYLBOX_VERSION') ? $io : $nio).'"></td></tr>';

//apache version
$apache_check = stristr($_SERVER["SERVER_SOFTWARE"],'apache/2')!== FALSE ? 1 : 0;
echo '<tr><td><font size=2>Apache Version:&nbsp;</font></td>';
echo '<td><font size=2>'.$_SERVER["SERVER_SOFTWARE"].($apache_check ? '' : '&nbsp;&nbsp;< Apache/2.0 !').'</font></td>';
echo '<td><img src="'.($apache_check ? $io : $nio).'"></td></tr>';

//php version
$php_check = ((PHP_VERSION>='4.3.11'&&PHP_VERSION<5)||(PHP_VERSION>='5.0.4'&&PHP_VERSION>=5)) ? 1 : 0;
echo '<tr><td><font size=2>PHP Version:&nbsp;</font></td>';
echo '<td><font size=2>'.PHP_VERSION.($php_check ? '' : '&nbsp;&nbsp;< 4.3.11 or 5.0.4 !').'</font></td>';
echo '<td><img src="'.($php_check ? $io : $nio).'"></td></tr>';

//--------------------------------------------------------------------------------------

echo '<tr><td colspan=3><hr></td></tr>';


// Oxyl-Pfad Check
//---------------------------------------------------------------------------------------
echo '<tr><td colspan=3><b>Oxyl System Paths:</b></td></tr>';
$ospc='';

// Check all oxyl path

      if (! is_dir(OXYL_EXEC))
		$ospc.='-BIN path not found!<br>';

      if (! is_dir(OXYL_KERN)) //lol wenn der nicht da ist funktioniert nichts
		$ospc.='-COMMON path not found!<br>';

      if (! is_dir(OXYL_CONF))
		$ospc.='-CONFIG path not found!<br>';

      if (! is_dir(OXYL_PICS))
		$ospc.='-IMAGES path not found!<br>';

      if (! is_dir(OXYL_PLUG))
		$ospc.='-PLUGINS path not found!<br>';

      if (! is_dir(OXYL_SKIN))
		$ospc.='-SKINS path not found!<br>';

      if (! is_dir(OXYL_ROOT.'versions'))
		$ospc.='-VERSIONS path not found!<br>';

 if (strlen($ospc)>0)
 {
  $LOGFile.='# Oxyl System Paths ERROR #'. "\r\n" . '---------------------------' . "\r\n".'#!'. str_replace('<br>',"\r\n" . '#!',$ospc). "\r\n";
  echo '<tr><td colspan=2 width="' . $frwidth . '"><font size=2>' . $ospc . '</td>';
  echo '<td width="' . $frwidth2 . '"><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
 }
 else
 {
  $LOGFile.='Oxyl System Paths OK'. "\r\n";
  echo '<tr><td colspan=2 width="' . $frwidth . '"><font size=2>Checked</td>';
  echo '<td><center><img src="' . getimghref('oxyl_nav_ok.gif') . '"></td></tr>';
 }
//-----------------------------------------------------------------------------------------------

echo '<tr><td colspan=3><hr></td></tr>';


// Oxyl-Consistency Check
//---------------------------------------------------------------------------------------
echo '<tr><td colspan=3><b>Oxyl System Check:</b></td></tr>';
$ospc='';

// Check all oxyl path

      if (! is_dir(OXYL_PLUG.'oxyl_setup'))
		$ospc.='-oxyl_setup path not found!<br>';

      if (! file_exists(OXYL_PLUG.'oxyl_setup/oxyl_setup_main.php'))
		$ospc.='-oxyl_setup_main.php not found!<br>';

      if (! file_exists(OXYL_PLUG.'oxyl_setup/oxyl_plugin.cfg'))
		$ospc.='-oxyl_plugin.cfg not found!<br>';

      if (! file_exists(OXYL_PLUG.'oxyl_setup/oxyl_box_setup.php'))
		$ospc.='-oxyl_box_setup.php not found!<br>';

 if (strlen($ospc)>0)
 {
  echo '<tr><td colspan=2><font size=2>' . $ospc . '</td>';
  echo '<td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
  $LOGFile.='# System Check ERROR #'. "\r\n" . '-----------------------' . "\r\n".'#!'.  str_replace('<br>',"\r\n" . '#!',$ospc) . "\r\n";
 }
 else
 {
  $LOGFile.='Oxyl System Check OK'. "\r\n";
  echo '<tr><td colspan=2><font size=2>Checked</td>';
  echo '<td><center><img src="' . getimghref('oxyl_nav_ok.gif') . '"></td></tr>';
 }
//-----------------------------------------------------------------------------------------------

echo '<tr><td colspan=3><hr></td></tr>';


// Temp-Pfad Check
//---------------------------------------------------------------------------------------
echo '<tr><td colspan=3><b>Temp-Path:</b></td></tr>';

    if (file_exists(OXYL_CONF.'temp.cfg'))
	{
     	echo '<tr><td colspan=2><font size=2></b>' . OXYL_TEMP.'</td>';
	    if (is_dir(OXYL_TEMP)){
		  $ctp=@fopen(OXYL_TEMP.'/testfile.txt','w');
 	      @fwrite($ctp,'Hallo Welt'."\n");
		  @fclose($ctp);
		  $ctp='';
		  $ctp=@fopen(OXYL_TEMP.'/testfile.txt','r');
		  $ctpline = trim(@fgets($ctp,1024));
		  @fclose($ctp);

          if (strlen($ctpline)>0) {
		    if (strpos($ctpline, 'Welt')) {
		      echo '<td><center><img src="' . getimghref('oxyl_nav_ok.gif') . '"></td></tr>';
			  unlink ($path .'/testfile.txt');
			}
		    else{
		      echo '<td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
		      echo '<tr><td colspan=3><center><img src="' . getimghref('oxyl_nav_right.gif') . '" align="absmiddle"> Error during write access! Check Autorization and HTTP Config!</td></tr>';
			}
		  }
		  else{
		    echo '<td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
		    echo '<tr><td colspan=3><center><img src="' . getimghref('oxyl_nav_right.gif') . '" align="absmiddle"> No write access! Check Autorization and HTTP Config!</td></tr>';
          }
		}
	    else{// wenn "is_dir" false ist
		  if(file_exists($path)){// falls datei oder link...
		    echo '<td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
		    echo '<tr><td colspan=3><center><img src="' . getimghref('oxyl_nav_right.gif') . '" align="absmiddle"> Temp-Path is not a Directory!</td></tr>';
		  }
		  elseif($path==""){// falls inhalt von cfg leer
		    echo '<td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
		    echo '<tr><td colspan=3><center><img src="' . getimghref('oxyl_nav_right.gif') . '" align="absmiddle"> Temp-Path is not set! Set the Temp-Path in Oxyl Setup</td></tr>';
		  }
		  else{// wenn gar kein Verzeichnis oder file existiert
		    echo '<td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
		    echo '<tr><td colspan=3>';
		    echo str_replace('###','TEMP',$progcall);
		    echo '<img src="' . getimghref('oxyl_nav_right.gif') . '" align="absmiddle"> Directory not found!&nbsp;&nbsp;<input type="submit" name="CD" value="Create Directory">';
		    echo '<input type="hidden" name="action" value="mkdir">';
		    echo '<input type="hidden" name="back" value="' . $back . '">';
		    echo '<input type="hidden" name="dir" value="' . $path . '">';
		    echo '</form></td></tr>';
          }
	    }
	}
      else{
		 echo '<tr><td colspan=2>Temp-Path not set!</td><td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
		 echo '<tr><td colspan=3><center><img src="' . getimghref('oxyl_nav_right.gif') . '" align="absmiddle"> Set the Temp-Path in Oxyl Setup</td></tr>';
	}
$LOGFile.='Temp Path= ' . $path. "\r\n";
//-----------------------------------------------------------------------------------------------

echo '<tr><td colspan=3><hr></td></tr>';

// Playlist-Pfad Check
//---------------------------------------------------------------------------------------
echo '<tr><td colspan=3><b>Playlist-Path:</b></td></tr>';

   if (file_exists(OXYL_CONF.'plugins_oxyl_mp3_playlist.cfg'))
      {
       $fh=fopen(OXYL_CONF.'plugins_oxyl_mp3_playlist.cfg','r');
       $path=trim(fgets($fh,999));
       fclose($fh);
       echo '<tr><td colspan=2><font size=2></b>' . $path . '</td>';
	    if(is_dir($path))
		  {
		  $ctp=@fopen($path.'/testfile.txt','w');
 	      @fwrite($ctp,'Hallo Welt'."\n");
		  @fclose($ctp);
		  $ctp='';
		  $ctp=@fopen($path.'/testfile.txt','r');
		  $ctpline = trim(@fgets($ctp,1024));
		  @fclose($ctp);

		  if (strlen($ctpline)>0) {
		    if (strpos($ctpline, 'Welt')) {
		      echo '<td><center><img src="' . getimghref('oxyl_nav_ok.gif') . '"></td></tr>';
			  unlink ($path .'/testfile.txt');
			}
		    else{
		      echo '<td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
		      echo '<tr><td colspan=3><center><img src="' . getimghref('oxyl_nav_right.gif') . '" align="absmiddle"> Error during write access!&nbsp;Check Autorization and HTTP Config!</td></tr>';
			}
 		  }
		  else{
		    echo '<td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
		    echo '<tr><td colspan=3><center><img src="' . getimghref('oxyl_nav_right.gif') . '" align="absmiddle"> No write access!&nbsp;Check Autorization and HTTP Config!</td></tr>';
          }
		}
	    else{// wenn "is_dir" false ist
		  if(file_exists($path)){// falls datei oder link...
		    echo '<td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
		    echo '<tr><td colspan=3><center><img src="' . getimghref('oxyl_nav_right.gif') . '" align="absmiddle"> Playlist-Path is not a Directory!</td></tr>';
		  }
		  elseif($path==""){// falls inhalt von cfg leer
		    echo '<td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
		    echo '<tr><td colspan=3><center><img src="' . getimghref('oxyl_nav_right.gif') . '" align="absmiddle"> Playlist-Path is not set! Set the Temp-Path in Oxyl Setup</td></tr>';
		  }
		  else{// wenn gar kein Verzeichnis oder file existiert
		    echo '<td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
		    echo '<tr><td colspan=3><center>';
		    echo str_replace('###','PLPATH',$progcall);
			echo '<img src="' . getimghref('oxyl_nav_right.gif') . '" align="absmiddle"> Directory not found!&nbsp;&nbsp;<input type="submit" name="CD" value="Create Directory">';
		    echo '<input type="hidden" name="action" value="mkdir">';
		    echo '<input type="hidden" name="back" value="' . $back . '">';
		    echo '<input type="hidden" name="dir" value="' . $path . '">';
		    echo '</form></td></tr>';
		  }
	    }
      }
      else{
		echo '<tr><td colspan=2>Playlist-Path not set!</td><td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
		echo '<tr><td colspan=3><center><img src="' . getimghref('oxyl_nav_right.gif') . '" align="middle"> Set the Playlist-Path in Oxyl Setup</td></tr>';
	}

$LOGFile.='Playlist Path= ' . $path. "\r\n";
//-----------------------------------------------------------------------------------------------

echo '<tr><td colspan=3><hr></td></tr>';

// Video-Pfad Check
//---------------------------------------------------------------------------------------
$LOGFile.='Video Devices:'. "\r\n";
echo '<tr><td colspan=3><b>Video-Path:</b></td></tr>';

$devices = get_devices('plugins_oxyl_video_devices.cfg');
for ($i=0;$i<count($devices);$i++){
    echo '<tr><td><font size="-1">';
    $ret=Check_path($devices[$i]['path'],$devices[$i]['name'],$devices[$i]['level'],$GLOBALS['actuserlevel'],'OFF');
    if ($ret==0)
	  echo '</td><td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '" align="middle"></td></tr>';
    elseif($ret==1)
	  echo '</td><td><center><img src="' . getimghref('oxyl_nav_ok.gif') . '" align="middle"></td></tr>';
	else
	  echo "";
}
//--------------------------------------------------------------------------------------

echo '<tr><td colspan=3><hr></td></tr>';

// Audio-Pfad Check
//---------------------------------------------------------------------------------------
$LOGFile.='Audio Devices:'. "\r\n";
echo '<tr><td colspan=3><b>Audio-Path:</b></td></tr>';

$devices = get_devices('plugins_oxyl_mp3_devices.cfg');
for ($i=0;$i<count($devices);$i++){
    echo '<tr><td><font size="-1">';
    $ret=Check_path($devices[$i]['path'],$devices[$i]['name'],$devices[$i]['level'],0,'OFF');
    if ($ret==0)
	  echo '</td><td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '" align="middle"></td></tr>';
    else
	  echo '</td><td><center><img src="' . getimghref('oxyl_nav_ok.gif') . '" align="middle"></td></tr>';
}
//--------------------------------------------------------------------------------------

echo '<tr><td colspan=3><hr></td></tr>';

// Pictures-Pfad Check
//---------------------------------------------------------------------------------------
$LOGFile.='Pictures Devices:'. "\r\n";
echo '<tr><td colspan=3><b>Pictures-Path:</b></td></tr>';

$devices = get_devices('plugins_oxyl_pic_devices.cfg');
for ($i=0;$i<count($devices);$i++){
    echo '<tr><td><font size="-1">';
    $ret=Check_path($devices[$i]['path'],$devices[$i]['name'],$devices[$i]['level'],$GLOBALS['actuserlevel'],'OFF');
    if ($ret==0)
	  echo '</td><td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '" align="middle"></td></tr>';
    elseif($ret==1)
	  echo '</td><td><center><img src="' . getimghref('oxyl_nav_ok.gif') . '" align="middle"></td></tr>';
	else
	  echo "";
    }
//--------------------------------------------------------------------------------------

echo '<tr><td colspan=3><hr></td></tr>';

// File-Pfad Check
//---------------------------------------------------------------------------------------
$LOGFile.='File Devices:'. "\r\n";
echo '<tr><td colspan=3><b>File-Path:</b></td></tr>';

$devices = get_devices('plugins_oxyl_file_devices.cfg');
for ($i=0;$i<count($devices);$i++){
    echo '<tr><td><font size="-1">';
    $ret=Check_path($devices[$i]['path'],$devices[$i]['name'],$devices[$i]['level'],$GLOBALS['actuserlevel'],'OFF');
    if ($ret==0)
	  echo '</td><td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '" align="middle"></td></tr>';
    elseif($ret==1)
	  echo '</td><td><center><img src="' . getimghref('oxyl_nav_ok.gif') . '" align="middle"></td></tr>';
	else
	  echo "";
    }
//--------------------------------------------------------------------------------------

echo '<tr><td colspan=3><hr></td></tr>';


// Internet Check
//---------------------------------------------------------------------------------------
echo '<tr><td colspan=3><b>Internet Connection:</b></td></tr>';

echo '<tr><td colspan=2><font size=2></b>' . OXYL_HP . '</td>';

if (remote_file_exists(OXYL_HP)){
   $LOGFile.='Internet Connection OK'. "\r\n";
   echo '<td><center><img src="' . getimghref('oxyl_nav_ok.gif') . '"></td></tr>';
}
else{
   $LOGFile.='Internet Connection failed'. "\r\n";
   echo '<td><center><img src="' . getimghref('oxyl_nav_cancel.gif') . '"></td></tr>';
   echo '<tr><td colspan=3><center><img src="' . getimghref('oxyl_nav_right.gif') . '" align="absmiddle"> No Internet Connection Check Internet and Proxy Settings</td></tr>';
}

echo '</table>';

//---------------------------------------------------------------------------------------

echo '</td></tr></table></blockquote><br>';

    echo '<hr color="#000000">';
    echo '<a href="' . $back . '">&nbsp;... '.trans('','back').'</a><br><br><br>';
    gen_end();


$LOGFile .= '' . "\r\n";
$LOGFile .= '+---------------------------------------------------------------------------------+' . "\r\n";
$LOGFile .= '|  oxyl~box Check  E N D                 ' . date("j M Y - H:i:s"). "\r\n";
$LOGFile .= '+---------------------------------------------------------------------------------+';

$ctp=@fopen(OXYL_ROOT.'oxyl_CHECK_Log.txt','wb');
 @fwrite($ctp,$LOGFile);
 @fclose($ctp);


die();

//--------------------------------------------------------------------------------------------


//+------------------------------------------------------------------------------------------
//|FUNKTION: Check_Path
//| berprft ob Pfad existiert, darauf Zugegriffen werden kann
//| und der Benutzer authorisiert ist!
//|
//| History:
//|  20040817 .............. LongDan - erstellt
//|  20040828 .............. LongDan - silent mode added
//|  20050120 .............. Brause  - Kosmetik durch tabellenlayout ersetzt
//+------------------------------------------------------------------------------------------
function Check_Path($pathname,$oname,$level,$userlevel,$silent='OFF') {
Global $LOGFile;
$IS_UNC = substr($pathname,0,2)=='//' ? 1 : 0;
// Authorisation
if ((int)($level)<(int)($userlevel))
{
   //if ($silent=='OFF')
   //  echo '<b>---</b></td><td>No authorisation with current User!<br>';
   $LOGFile.="--- \tNo authorisation with current User! \r\n";
   return 2;
}
// Pfad gltig?
//----------------------
if($IS_UNC)
{
  if(!$handle=opendir ($pathname))
  {
    if ($silent=='OFF')
      echo '<b>' . $oname . '&nbsp;&nbsp;</b></td><td width="' . $frwidth2 . '"><i>Netshare - invalid: </i>&nbsp;&nbsp;' . $pathname . '<br>';
	$LOGFile.=$oname."\t".$pathname. "\tNetshare - invalid\r\n";
    return 0;
  }
  closedir($handle);
}
else // Dateiverzeichnis
{
  // Pfad gltig?
  //----------------------
  if (!is_dir($pathname))
  {
    if ($silent=='OFF')
      echo '<b>' . $oname . '&nbsp;&nbsp;</b></td><td width="' . $frwidth2 . '"><i>Path - invalid: </i>&nbsp;&nbsp;' . $pathname . '<br>';
    $LOGFile.=$oname."\t".$pathname. "\tPath - invalid\r\n";
    return 0;
  }
  // Zugriff auf Pfad?
  //----------------------
  if (@dir($pathname) =='')
  {
    if ($silent=='OFF')
      echo '<b>' . $oname . '&nbsp;&nbsp;</b></td><td><i>Unmounted: </i>&nbsp;&nbsp;' . $pathname . '<br>';
    $LOGFile.=$oname."\t".$pathname. "\tUnmounted\r\n";
    return 0;
  }
}

if ($silent=='OFF')
  echo '<b>' . $oname .'&nbsp;&nbsp;</b></td><td>' .($IS_UNC ? 'Netshare: ':''). $pathname . '<br>';
$LOGFile.=$oname."\t".$pathname. "\tOK\r\n";
return 1;

}// end function

//*****************************************************************************************************
?>
