<?php
//####################################### Oxyl~Box 2.0 #####################################################
//+-------------------------------------------------------------------------------------------
//| plugin: heise_online.php
//| author : LongDan
//+-------------------------------------------------------------------------------------------
//| Reads the webpage www.heise-online.de/newsticker
//+-------------------------------------------------------------------------------------------
//|           .............. LongDan  - Plugin erstellt
//|  20041115 .............. LongDan  - Upgrade to oxyl~box 2.0 
//|    050515 .............. Brause   - FIX: Notice fehler entfernt
//+-------------------------------------------------------------------------------------------

  include_once('../../common/design.inc');

// Default Settings
//----------------------------------------------------------------

  $pluginroot  =  OXYL_WEB.'/plugins/Heise-Online/';
  $plugin      = 'heise_online.php';

  $tmppath     = 'Heise-Online-TMP';
  $savepfad    = 'Heise-Online-SAVED';

  $myversion   = '2.0.0';
  $backtomenu  = OXYL_WEB.'/oxylstart.php';

  $maxlines    = 12;
  $weburl      = 'http://www.heise.de/newsticker/';
  $webpage     = $weburl;
  $picurl      = 'http://www.heise.de';

  $plugintext  = trans('Heise-Online','plugin_name');
  $pluginname  = $pluginroot . $plugin;

  $helpfile    = 'heise_online_help';

  if(!isset($startpage)) $startpage = '';
  if(!isset($title)) $title = '';

//------------------------------------------------------------------------------------
//  Read Config
//------------------------------------------------------------------------------------
if (file_exists(OXYL_CONF.'plugins_oxyl_heise_online.cfg'))
  {
    $heiseoptions     = file(OXYL_CONF.'plugins_oxyl_heise_online.cfg');
    $showread         = $heiseoptions[0];
    $showreadstyle    = $heiseoptions[1];
    $linelength       = $heiseoptions[2];
    if ($linelength<30 or $linelength>90)
	$linelength=60;
  }
  else
  {
    $fh = fopen(OXYL_CONF.'plugins_oxyl_heise_online.cfg','w');
    fwrite($fh,'ON' . "\r\n");
    fwrite($fh,'<font size=-1>' . "\r\n");
    fwrite($fh,'60' . "\r\n");
    fclose($fh); 
    echo '<meta http-equiv="refresh" content="0; URL=/plugins/Heise-Online/heise_online.php">';
    echo ' First use! <br><br>Initializing Config File! <br>Please Wait';
   die();
  }
//------------------------------------------------------------------------------------
//Overview Page search Strings
  $startov = 'Liste der Meldungen';
  $endov   = '-- Newstipps --';

//Detail Page search Strings
  $startdet = '-- Meldung --';
  $enddet   = '-- untere News-Navigation --';

  $cebitstart = 'HEISETEXT';
  $cebitend   = '-- Navi Anfang--';
//################################################################
//      M A I N     P R O G R A M M
//################################################################
// Reset some variables to be shure they are empty
//
  $status = 0; 
  $i=0; 
  $totallines=0;
  $totalnews=0;
  $cebit = '';
  $totallines = '';

$weekday = date("w");
$day     = date("d");
$month   = date("m");
$year    = date("Y");
$hour    = date("H");
$min     = date("i");
$sec     = date("s");
$swatch  = date("B");
//  OXYL Demo Mode
//----------------------------------------------------------------
  if (isset($demo))
  {
    $page['headline']='Heise-Online Version ' . $myversion;
    $page['mode']='full';
    $page['body']['typ']='full';
    $page['body']['content']['full'] = "Auf dem Demo-System aus Urheberrechtsgrnden gesperrt";
    gen_full_page($page);
    flush();
    die();
  }
// Create Heise Temp Directory
//-------------------------------------------------------------------------
   $directory = $GLOBALS['temppath'] . '/' . $tmppath;

// Check for Sub Dir
    if (!file_exists($directory))
    check_dirs ($directory);

// START MODE ENABLED ?
//-------------------------------------------------------------------------
if (isset($start))
   {
    echo '<html>';
    echo '<head>';

    if (isset($detail))
     echo '<meta http-equiv="refresh" content="0; URL=' . $pluginname  . '?startpage=' . $startpage . '&detail=' . $detail . '&title=' . urlencode($title) . '">';
    else
     echo '<meta http-equiv="refresh" content="0; URL=' . $pluginname  . '?startpage=' . $startpage . '">';

    echo '<meta SYABAS-FULLSCREEN>';
    echo '<meta syabas-keyoption="lowercase"><meta myibox-pip="304,80,304,240,1">';
    echo '<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">';
    echo '<meta name="generator" content="lyra-box UI">';
    echo '<title>Heise-Online ' . $myversion . '</title>';
 
      $style=getstyle();
      include($style);

    echo '</head>';
    echo '<body onLoadSet="MyFocus" background="'. getimghref('oxyl_back.png'). '" TOPMARGIN="0" LEFTMARGIN="0" MARGINHEIGHT="0" MARGINWIDTH="0">';
    $user_msg= trans('Heise-Online','start_msg01');
	if (strlen($title)>2)
       {
       $user_msg= str_replace('newsticker','newsticker<br><font size=-1>' . trim($title).'</font>',$user_msg);
       } 
    echo '<br><br><br><br><br><center><b>' . $user_msg . '<br><br>';
    echo '</body></html>';
    unset($start);
    die();
    }
//----------------------------------------------------------------
// Save DETAIL Page to Disk
//----------------------------------------------------------------
$cached_page = '<html><head><title>OXYL~BOX ' . $plugintext . ' ' . $myversion . '&nbsp;&nbsp;' . trans('Heise-Online','saved_pagetitel') . '</title>';
$cached_page .= '<body bgcolor="#F1FDFE">';

  if (isset($save))
  {
  // DocSave Path
    $savepath = $GLOBALS['temppath'] . '/' .$savepfad . '/' ;
    $htmlsave = file($GLOBALS['temppath'] . '/'. $tmppath . '/heise_detail.sav');
// Check for SAVE Sub Dir
  
    if (!file_exists($savepath))
    check_dirs ($savepath);
   
// Murks
//
    $title = str_replace('&nbsp;&nbsp;','',$title);
    $title = str_replace('CeBIT&nbsp;','CeBIT - ',$title);
    $title = str_replace('&nbsp;','',$title);
    $title = str_replace(':','-',$title);

    $savefile = $savepath . trim($title) . '.htm';

    $fhd = fopen($savefile,'w');
    reset($htmlsave);
    foreach($htmlsave as $line)
    {
// GO BACK 4 saveSHow next Pages trough plugin
    $line = str_replace('href="' . $pluginname . '?start=TRUE&detail=','href="http://www.heise.de/newsticker/',$line);
     fwrite($fhd,$line); 
    }
    fclose($fhd);
    echo '<html>';
    echo '<head>';
    echo '<table border=0 height=8 align=right><tr><td align=right><font size=-3 color=blue><p align="right">' . $plugintext ."</p></td></tr></table>";
    echo '<meta SYABAS-FULLSCREEN>';
    echo '<meta syabas-keyoption="lowercase"><meta myibox-pip="304,80,304,240,1"><meta http-equiv="content-type" content="text/html;charset=iso-8859-1">';
    echo '<meta name="generator" content="lyra-box UI">';
    echo '<meta http-equiv="refresh" content="6; URL=' . $pluginname . '?startpage=' . $startpage . '&cache=ON">';
    echo '<title>OXYL~BOX ' . $plugintext . ' ' . $myversion . '</title>';
    echo '<body onLoadSet="MyFocus" background="'. getimghref('oxyl_back.png'). '" TOPMARGIN="0" LEFTMARGIN="0" MARGINHEIGHT="0" MARGINWIDTH="0"><br><br><br><blockquote><table bgcolor=#FFFFFF border=1 align=center><tr><td align=center>';
    echo '<font size=5 color=red><br><blockquote><b>' . trans('Heise-Online','page_save') .'</b><br><br>';
    echo '<font size=2 color=blue><b>' . $title . '</b><br><br>';
    echo '<font size=1 color=black><br>' . $savepath . '&nbsp;&nbsp;<br><br></td></tr></table></body></html>';
   unset($save);
   die ();
   }
//----------------------------------------------------------------
// Show DETAIL Page of News
//----------------------------------------------------------------
  if (isset($detail))
  {
    echo '<html>';
    echo '<head>';
    echo '<table border=0 height=0 align=right><tr><td align=right><font size=-3 color=blue><p align="right">' . $plugintext ."</p></td></tr></table>";
    echo '<meta SYABAS-FULLSCREEN>';
    echo '<meta syabas-keyoption="lowercase"><meta myibox-pip="304,80,304,240,1"><meta http-equiv="content-type" content="text/html;charset=iso-8859-1">';
    echo '<meta name="generator" content="lyra-box UI">';
    echo '<title>OXYL~BOX &nbsp;' . $plugintext . ' ' . $myversion . ' &nbsp;&nbsp;&nbsp;' . $title . '</title>';
    echo '<body bgcolor="#F1FDFE">';

//  READ Detail WEBPAGE into Var
//
if (isset($pagesize))
	{
	 $sca=file($GLOBALS['temppath'] .'/' . $tmppath . '/heise_page.tmp');
	 $sc='';
	 foreach ($sca as $sct)
	   {
	    $sc.=$sct;
	   }
	}
	else
	{
	 $sc=read_web($weburl . $detail);
	 $fhp = fopen($GLOBALS['temppath'] .'/' . $tmppath . '/heise_page.tmp','w');
	 fwrite($fhp,$sc);
	 fclose($fhp);
	}
//GET rid of the news gfx and link
    $sc = str_replace('<a href="/newsticker/"><img src="/icons/ho/news_logo.gif" alt="news" width="120" height="30" border="0"></a>','',$sc);

//  Replace Picture Path + variantes
    $sc = str_replace('src="','src="' . $picurl,$sc);
    $sc = str_replace('src = "','src = "' . $picurl,$sc);

// Replace target=
    $sc = str_replace('target="_blank"','',$sc);

// SHow next Pages trough plugin
    $sc = str_replace('href="http://www.heise.de/newsticker/','href="' . $pluginname . '?start=TRUE&detail=',$sc);
    $sc = str_replace('href="/newsticker/','href="' . $pluginname . '?start=TRUE&detail=',$sc);

    $sc=explode("\n",$sc);

    $status = 0; 

// CEBIT Detail Page Murks
   if (strpos($title,'CeBIT')>0 or isset($cebt)) 
		{
 		//$startdet=$cebitstart;
		//$enddet  =$cebitend;
    		$sc = str_replace('?detail=','?cebt=Y&detail=',$sc);
		}

    foreach($sc as $line)
    {
      switch ($status)
      {
        case 0 : if (strpos($line,$startdet)>0 or strpos($line,$cebitstart)>0)
                   $status = 1;
                 break;
        case 1 : if (strpos($line,$enddet)>0 or strpos($line,$cebitend)>0)
                 {
                   $status = 2;
                 }
                 else
                   $hrefs[] = $line;
                 break;
      }

    }// End Foreach
    
    reset($hrefs);
    $leer = false;
//PAGE SIZE MODUS
    if(!isset($pagesize)) $pagesize = 0;
    switch ($pagesize)
	{
	case 1 : $ps= '<h4>';
   	         break;
	case 2 : $ps= '<h2>';
   	         break;
	case 3 : $ps= '<h1>';
   	         break;

	 	 default:
		 $ps=''; 
		 break;
	}

    echo '<blockquote>';

    foreach($hrefs as $href)
    {
	if (strstr($href,'</h2>'))
		$href=$href.$ps;
      $line = trim($href);
      if (strlen($line)<1) 
      {
        if (! $leer)
        {
//          echo '<br><br>';
        }
        $leer=true;
      }
      else
        $leer=false;
      if (strlen($line)>0)
	{
        echo $href."\n";
        $cached_page .= $href;
        }
    }
//Page bottom Menu
//----------------------------------------------------------------
    $stringp = '&startpage=' . urlencode($startpage);
    echo '<a href="' . $pluginname . "?startpage=" . $startpage .'&cache=ON" TVID="'.IR_TVID_BACKSPACE.'"><img src="' . getimghref('oxyl_nav_left.gif') . '" border="0" width="25" height="25"></a><br><hr>&nbsp;<a href="' . $pluginname . '?save=YES&title=' . urlencode($title) . '&startpage=' . $startpage . '&cache=ON" TVID = "'.IR_TVID_KEYB.'"><font size=3><b>(B)</b></a> = ' . trans('Heise-Online','page_save_text') . '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="/common/help.php?bl=/plugins/Heise-Online/heise_online.php?detail=' . $detail . urlencode('&pagesize=0') . urlencode('&startpage=') . urlencode($startpage) . urlencode('&cache=ON') . '&hf=/plugins/Heise-Online/heise_online_help" TVID="'.IR_TVID_HELP.'"><b>(?)</b></a> = ' . trans('Heise-Online','page_help_text') . '<hr>' . "\r\n";

    echo '<a href="' . $pluginname . "?startpage=" . $startpage .'&cache=ON&detail=' . urlencode($detail) . '&pagesize=1" TVID="1"> </a>' . "\r\n";
    echo '<a href="' . $pluginname . "?startpage=" . $startpage .'&cache=ON&detail=' . urlencode($detail) . '&pagesize=2" TVID="2"> </a>' . "\r\n";
    echo '<a href="' . $pluginname . "?startpage=" . $startpage .'&cache=ON&detail=' . urlencode($detail) . '&pagesize=3" TVID="3"> </a>' . "\r\n";
    echo '<a href="' . $pluginname . "?startpage=" . $startpage .'&cache=ON&detail=' . urlencode($detail) . '&pagesize=0" TVID="4"> </a>' . "\r\n";
    echo '<a href="' . $pluginname . "?startpage=" . $startpage .'&cache=ON&detail=' . urlencode($detail) . '&pagesize=0" TVID="5"> </a>' . "\r\n";
    echo '<a href="' . $pluginname . "?startpage=" . $startpage .'&cache=ON&detail=' . urlencode($detail) . '&pagesize=0" TVID="6"> </a>' . "\r\n";

//  Save Page Funktion
    echo ' </a>' . "\r\n";
// Global Keys
//------------
    echo list_gkeys() . "\r\n";
//-----------------------------
    echo '<br><br></body></html>';
    $cached_page .= '<br>' . trans('Heise-Online','page_orig_text') . ' <a href="' . $weburl . $detail . '">' . $weburl . $detail . '</a><hr><br><font size=2 color=blue>Created by Heise-Online Plugin ' . $myversion . ' @ Oxyl~Box<br>' . $day . '.' . $month . '.' . $year . ' - ' . $hour . ':' . $min . '<br></body></html>';
        
// SAVE to Temp File (if user wants to save, we have it already)
//----------------------------------------------------------------
    $savepath = $GLOBALS['temppath'] .'/'. $tmppath . '/heise_detail.sav';
    $fhd = fopen($savepath ,'w');
    fwrite($fhd,$cached_page ); 
    fclose($fhd);

// SAVE Read File 
//----------------------------------------------------------------
//echo 'showread' . $showread;
if (strstr($showread,'ON'))
    {
    $savepath = $GLOBALS['temppath'] .'/'. $tmppath . '/heise_read.sav';
    $fha = fopen($savepath ,'a');
    fwrite($fha,strip_tags($title,'') . "\r\n"); 
    fclose($fha);
    }
  }// OF DETAIL
//----------------------------------------------------------------
//  END OF DETAIL VIEW
//----------------------------------------------------------------
else
{
//----------------------------------------------------------------
// Start Processing for Overview Main Page
//----------------------------------------------------------------
// Pseudo cache
//

if (isset($cache))
  {
// Read from file
//   $hrefs = array();
   $hrefs = file($GLOBALS['temppath'] . '/' . $tmppath . '/heise_dump.tmp');

   $savevalid = $GLOBALS['temppath'] . '/' . $tmppath . '/heise_total.tmp';
   $totalnws = file($savevalid);
   $totalnews = $totalnws[0];
  }
  else
  {
// Reads the Webpage from Internet
//
    $sc=read_web($webpage);
    $fh = fopen($GLOBALS['temppath'] .'/' . $tmppath . '/heise_dump.tmp','w');
    fwrite($fh,'----------' ."\r\n");
    $sc=explode("\n",$sc);
    reset($sc);
    $status=0;
    $cebit = '';
    foreach($sc as $line)
    {
    $i++;
      switch ($status)
      {
        case 0 : if (strpos($line,$startov)>0)
                   $status = 1;
                 break;
        case 1 : if (strpos($line,$endov)>0)
                 {
                 $status = 2;
                 }
		 else
                  {
                     // Title
		     //
                     if (strpos($line,'h4>')>0)
                         {
                         $hrefs[] = trim($line);
		         fwrite($fh,trim($line) ."\r\n"); 
			 $totallines++;
                         }
                     // CEBIT Fix
		     //
                     if (strpos($line,'b class="cebit"')>0) 
                         {
		         $cebit = 'CeBIT';
                         } 
                     if (strpos($line,'a href="meldung/')>0)
                         {
			 $line=str_replace('<div> ','',$line);
			 $line=str_replace('</div>','',$line);
			 $line=str_replace('<b class="cebit">CeBIT<span class="unsichtbar">:</span></b>','',$line);
                         $hrefs[] = $cebit . '&nbsp;'.  trim($line);
		         fwrite($fh,$cebit . '&nbsp;'. trim($line)."\r\n");
			 $cebit = '';
                         $totalnews++;
			 $totallines++;
                         }
                 }
                 break;
        case 2 : $status = 3;
                 break;
      } // End Switch
    } // End Foreach 
    fclose($fh);
    // Write Total valid News 2 File
    $savevalid = $GLOBALS['temppath'] .'/'. $tmppath . '/heise_total.tmp';
    $fhd = fopen($savevalid ,'w');
    fwrite($fhd,$totalnews); 
    fclose($fhd);	        
 } // End Cache

// Now we have every good line in array $hrefs
$totallines = count($hrefs);
//----------------------------------------------------------------
// PAGE HANDLING
//----------------------------------------------------------------
if (isset($startpage))
{
  if ($startpage == '') $startpage=1;
}
else
{
  $startpage=1;
}

// Page Header
//
    $page['headline']= trans('Heise-Online','main_title');
    $page['mode']='full';
    $page['body']['typ']='lines';     

    $page['nav']['back']['image']=getimghref('oxyl_nav_top.gif','');
    $page['nav']['back']['href']=$backtomenu;

    $page['nav']['text'] = $totalnews . ' News'; 

    $page['nav']['set']['pages']=$startpage;
    $totalpages= ($totallines / $maxlines);
    
    $page['nav']['set']['countpages']= ceil($totalpages);


// Page 1 Handling
//----------------------------------------------------------------

if ($startpage==1)
{
$startline=1;
$endline=$startline + $maxlines-1;

// Show Buttons forNext Page
//
  $page['nav']['right']['image']=getimghref('oxyl_nav_right.gif');
  $page['nav']['right']['href']=$pluginname . '?startpage=2&cache=ON';  
  $page['nav']['right']['fo']='name="MyFocus" '.' TVID="'.IR_TVID_PGDN.'"';
}

// All other Pages Handling
//----------------------------------------------------------------

if ($startpage>1)
{
   $startline=($maxlines * $startpage) - $maxlines;
   $endline=$startline + $maxlines;
// Show Buttons for Prev Page
//
      if ($le=='l')                                                                           //wenn vorher gerade nach LINKS umgeblttert wurde
        $fo=' name="MyFocus"';
      else
        $fo='';
    $page['nav']['left']['image']=getimghref('oxyl_nav_left.gif');
    $page['nav']['left']['href']=$pluginname . "?startpage=" . ($startpage - 1) . '&cache=ON&le=l';
    $page['nav']['left']['fo']=$fo.' TVID="'.IR_TVID_PGUP.'"';  

  if ($endline > $totallines)
  {
    $endline=$totallines;
  }
  else
  {	
// Show Buttons forNext Page
//
      if ($le=='r')                                                                           //wenn vorher gerade nach RECHTS umgeblttert wurde
        $fo=' name="MyFocus"';
      else
        $fo='';
   $page['nav']['right']['image']=getimghref('oxyl_nav_right.gif');
   $page['nav']['right']['href']=$pluginname . "?startpage=" . ($startpage + 1) . '&cache=ON&le=r';  
   $page['nav']['right']['fo']='name="MyFocus"' .' TVID="'.IR_TVID_PGDN.'"';
  }
}
// Special Keys Handling
//
    $page['nav']['action'][1]['key'] = IR_TVID_KEYA;
    $page['nav']['action'][1]['href'] = $pluginname . "?startpage=" . ($startpage) . '&cache=ON&markall=TRUE';  
    $page['nav']['action'][1]['button'] = IR_ICON_KEYA;
    $page['nav']['action'][1]['text'] = trans('Heise-Online','main_markall');

    $page['nav']['action'][2]['key'] = IR_TVID_KEYC;
    $page['nav']['action'][2]['href'] = $pluginname . '?start=Yes';  
    $page['nav']['action'][2]['button'] = IR_ICON_KEYC;
    $page['nav']['action'][2]['text'] = trans('Heise-Online','main_reload');

    $page['help']['backhref'] = $pluginname . '?startpage=' . ($startpage) . '&cache=ON';    
    $page['help']['href']= '/plugins/Heise-Online/'.$helpfile;

// End of Page Handling
//----------------------------------------------------------------
// Set all as read
//----------------------------------------------------------------
if (isset($markall))
  {
   $savepath = $GLOBALS['temppath'] .'/'. $tmppath . '/heise_read.sav';
   $fha = fopen($savepath ,'w');
   foreach($hrefs as $markline)
	{
         if (substr($markline,0,5)=='&nbsp' or substr($markline,0,5)=='CeBIT')
           fwrite($fha,'&nbsp;' . strip_tags($markline,'') ); 
	}
    fclose($fha);
    reset($hrefs);
    unset($markall);
   }
// Create Line Entries LDMOD
//----------------------------------------------------------------
    $keyid=1;
    for ($i=$startline;$i< $endline && ($i<count($hrefs));$i++)
    {
          $href=$hrefs[$i];
          $text = strip_tags($href,'');
          $text = '&nbsp;' . trim($text);
          $spec = substr($href,0,4);

// Some Murks for the constantly changing layout of heise newsticker
//------------------------------------------------------------------
      switch ($spec)
      {
        case "<h4>" : $href='no';
                            $text = '<br>' . $text;
                            break;

        case "----" : $href='no';
                            $text = 'no';
                            break;

	default :     
			$hrefspos = strpos($href,'<a href');
			$hrefepos = strpos($href,'>',$hrefspos);
			$href=substr($href,$hrefspos,$hrefepos);

	      		$href = substr($href,strpos($href,'"')+1,strpos($href,'"',strpos($href,'"')+1)-strpos($href,'"')-1);
                        $href = $pluginname . "?detail=" . urlencode($href) . "&startpage=" . $startpage . '&title=' . urlencode(trim($text)) . '&start=YES';
      } // End switch

    if ($text !== 'no')
    {
      if ($href !== 'no')
	 {
          $page['body']['content'][$i]['href']=$href;
          $page['body']['content'][$i]['key']=$keyid;
	  $keyid++;
          }
     $shtext = dotrunc($text,$linelength,true,'r');
     if (strstr($showread,'ON'))
     {
      $bk = already_read(strip_tags($text),$tmppath);
      if ($bk=='*')
       {
       $text = dotrunc($text,$linelength+10,true,'r');
       $shtext= $showreadstyle . $text;
       }
      } 

     $page['body']['content'][$i]['text']=$shtext;

// Kosmetik 4 WWWW
//----------------------------------------------------------------
     if (strpos($text,'as war. Was wird')>0)
       {
        $page['body']['content'][$i]['image']=$pluginroot  . 'wwww.gif" width = "42" height = "15"';
	$tspos=strpos($text,'Was war');
        $page['body']['content'][$i]['text']= substr($text,$tspos);
       }
     }
   }
    gen_full_page_oxyl($page,120);
  echo '<meta myibox-pip="304,80,304,240,1">';
}

die();

//-------------------------------------------------------------------------
// FUNCTIONS
//-------------------------------------------------------------------------

// Already Read ?
//-------------------------------------------------------------------------
function already_read($rtitle,$tmppath2)
{
    $rtitle = str_replace('CeBIT&nbsp;','',$rtitle);
    $rtitle = str_replace('&nbsp;','',$rtitle);
    $readpath = $GLOBALS['temppath'] .'/'. $tmppath2 . '/heise_read.sav';
    if (file_exists($readpath))
     {
     $checker = file($readpath);
     $isread = array_search_bit($rtitle,$checker);
     return($isread);
     }
     else
     {
     return($isread);
     }
}

function array_search_bit($search, $array_in)
{
   foreach ($array_in as $key => $value)
   {
   if (strpos($value, $search) !== FALSE)
   return '*';
   }
   return FALSE;
}


// ............so long, and thanks for all the fish.......
//---------------------------------------------E-O-F------------------------------------------------
?>