<?php
//####################################### Oxyl~Box 2.5 #####################################################
//+-------------------------------------------------------------------------------------------
//|   ShoutCast V. 2.5.0 Oxyl
//| 
//|  20040810 .............. LongDan  - Created Plugin
//|  20041105 .............. LongDan  - New Comprehensive Genre List
//|  20041205 .............. LongDan  - Tuned for oxyl~box 2.0
//|                                   - Help eingebaut, thanks to merlin
//|  20050111 .............. Brause   - doppelten Stylesheet entfernt, Code entschlackt und HTML konform gestaltet
//|                                   - seite ruft jetzt design ueber kernskripte auf
//|                                   - Funktionen vereinfacht
//|                                   - eigene playlist knnen wieder hinzugefgt werden
//|                                   - aus 2.0.0 -> 2.1.1
//| 20050515 ............... Brause   - FIX: Notice fehler entfernt
//| 20050611 ............... Brause   - FIX: Bilder wurden bei externem Aufruf nicht dargestellt
//| 20050710 ............... Brause   - FIX: Playlist wird jetzt auf tote Links geprft, SC konnte damit nichts anfangen
//+---------------------------------------------------------------------------------------------------

  include_once('../../common/design.inc');


// Default Settings
//----------------------------------------------------------------

  $version   = '2.5.0';


  $pluginroot  = OXYL_WEB.'/plugins/SHOUTcast/';
  $plugin      = 'SHOUTcast.php';
  $pluginname  = 'SHOUTcast';
  $conf_file   = OXYL_CONF.'plugins_oxyl_shoutcast.cfg';

  //------------- Shoutcastparameter --------------
  $weburl1 = 'http://www.shoutcast.com/index.phtml';                    // default Startseite
  $weburl2 = 'http://www.shoutcast.com/directory/index.phtml?sgenre=';  // Seite aus der die Links gezogen werden
  $shoutcast = 'http://www.shoutcast.com';                              // Shoutcastserver
  // Variablen werden nicht im Suchstring verwendet muss -> separart angepasst werden!
  $catcher01 = '/sbin/shoutcast-playlist.pls?rn=';                      // Suchparameter wie die Links gefunden werden, Link zum Skript vor ID
  $catcher02 = '&file=filename.pls';                                    // Suchparameter wie die Links gefunden werden, Parameter nach ID
  $catcher03 = '_scurl';                                                // Suchparameter wie die Titel dazu gefunden werden

  $maxlen      = 55;                                                    // maximale Lnge der Link Titel
  $screenwidth = LAYOUT_TABLE_WIDTH;                                    // Breite der Tabelle (Liste)
  $addpicwidth = 12;                                                    // Breite vom Add Pic

//---------------------------------------------------------------------------------------
// GENRE SELECTION Quick and Comprehensive
//---------------------------------------------------------------------------------------

if(!isset($GENRE)) $GENRE = "TopTen";
if(isset($CGENRE)) if($CGENRE!=""&&$CGENRE!="TopTen") $GENRE = $CGENRE;
if(isset($QGENRE)) if($QGENRE!=""&&$QGENRE!="TopTen") $GENRE = $QGENRE;
if (! isset($fo))  $fo=' ';

//  OXYL Demo Mode
//----------------------------------------------------------------
  if (isset($demo))
  {
    $page['headline']='SHOUTcast ' . $version;
    $page['mode']='full';
    $page['body']['typ']='full';
    $page['body']['content']['full'] = "Auf dem Demo-System aus Urheberrechtsgrnden gesperrt";
    gen_full_page($page);
    flush();
    die();
  }


if (!isset($SETUP)){
//------------------------------------------------------------------------------------
//  write & delete Favoriten
//------------------------------------------------------------------------------------
//  ADD New Favorite
//------------------------------------------------------------------------------------------------------------------------
$favsaves = array();

if (isset($ADDLINE)){
    if (file_exists($conf_file))
       $favsaves = file($conf_file);
	$var = '';
    foreach($favsaves as $favsave)
	  if(strpos($favsave,$ADDLINE)===FALSE && trim($favsave)!='')
	    $var .= trim($favsave)."\r\n"; 
    $var .= $ADDLINE.'|'.$ADDTIT."\r\n";

	$var != '' ? create_file($conf_file,$var) : @unlink($conf_file);

    unset($ADDLINE);
    $START="YES";
}

//---------------------------------------------------------------------------------------
// Delete Favorite
//---------------------------------------------------------------------------------------
if (isset($DELLINE)){
    if (file_exists($conf_file))
       $favsaves = file($conf_file);
	$var = '';
    foreach($favsaves as $favsave)
	  if(strpos($favsave,$DELLINE)===FALSE && trim($favsave)!='')
	    $var .= trim($favsave)."\r\n"; 

	$var != '' ? create_file($conf_file,$var) : @unlink($conf_file);

    unset($DELLINE);
    $START="YES";
}

//------------------------------------------------------------------------------------
//  Read Shoutcast & WebRadio favorites from file or create new
//------------------------------------------------------------------------------------

 $favorites = array();

 if (file_exists($conf_file))
    $favorites = file($conf_file);

//------------------------ Favoriten -----------------
    
	$favolist  = '<table cellpadding=0 cellspacing=0 border=0 width="100%"><tr><td>'.gen_transpic(LAYOUT_BODY_HEIGHT-LAYOUT_NAVI_HEIGHT,1). '</td>';
	$favolist .= '<td valign="top"><table cellspacing=0 cellpadding=0 border=0>';
	$favolist .= '<tr><td colspan=2>&nbsp;<u>' . trans('SHOUTcast','Favoriten').'</u></td></tr>'. "\n";
	$favolist .= '<tr><td colspan=2>'.gen_transpic(4,$screenwidth). '</td></tr>'. "\n";

    $tvkey=1;
    
	foreach($favorites as $favorite)
    {
	 if(trim($favorite)!=""){
	   $favs    = explode("|",trim($favorite));
	   $sctitle = dotrunc(trim($favs[1]),$maxlen,' ...','r');
	   $favs[0] = trim($favs[0]);

       if(is_numeric($favs[0]))//ist es eine Zahl
	   {
	     $link1 = $shoutcast.$catcher01.$favs[0].$catcher02;                                                       // Link fr PC wird zusammengebastelt
         $link2 = OXYL_WEB.'/plugins/SHOUTcast/SHOUTcast_stream.php?stream='.$favs[0].'&playlist_pls=1'.$catcher02;// Link fr Showcenter wird zusammengebastelt
       }
	   else
	   {
	     $link1 = $favs[0];
	     $link2 = OXYL_WEB.'/plugins/SHOUTcast/SHOUTcast_stream.php?playlist_pls=1&url='.$favs[0];
       }
	   $link  = $GLOBALS['showcenter'] ? $link2 : $link1;

       $favolist .= '<tr><td width='.($screenwidth-$addpicwidth).'><table cellspacing=0 cellspacing=0 border=0><tr><td class="text_back" nowrap><a href="'.$link.'" TVID="'. $tvkey .'"><font size="2">('. $tvkey .')&nbsp;'.$sctitle.'</font></a></td></tr></table></td>';
       $favolist .= '<td align="right" nowrap width='.$addpicwidth.'>';
	   $favolist .= '<a href="' . $_SERVER["PHP_SELF"] . '?DELLINE='.$favs[0] . '&GENRE='. $GENRE .'">';
	   $favolist .= '<img src="'.getimghref("sc_del.gif","SHOUTcast").'" ONFOCUSSRC="'.getimghref("sc_dels.gif","SHOUTcast").'" border=0></a></td></tr>'. "\n";
       $tvkey++;
	}
}

//---------------------------------------------------------------------------------------
// MAIN SECTION
//---------------------------------------------------------------------------------------

 if(!isset($EXTERN)){
    $page['headline']='SHOUTcast ' . $version;
    $page['mode']='full';
    $page['body']['typ']='full';
    $page['nav']['back']['image']=getimghref('oxyl_nav_top.gif');                             //Pfad auf Bild fr Back-Zeichen setzen
    $page['nav']['back']['href']=OXYL_WEB.'/oxylstart.php';                                            //Verweis fr Back Gif auf Home von Oxyl setzen
    $page['nav']['back']['fo']=$fo.' TVID="'.IR_TVID_BACKSPACE.'"';                                         //BACKSPACE Knopf auf Fernbedienung mit Wechsel in nchsthhere Ebene belegen
}
//---------------------------------------------------------------------------------------
// --- Favoritenliste

$main = '<tr><td>'. "\n";
$main .= $favolist;

//---------------------------------------------------------------------------------------
// Title mit cosmetic
//---------------------------------------------------------------------------------------

$main .= '<tr><td colspan=2>'.gen_transpic(15,1). '</td></tr>'. "\n";
$main .= '<tr><td colspan=2>&nbsp;<u>SHOUTcast</u> &nbsp;<b>' . title_change($GENRE) . '</b></td></tr>'. "\n";

//flush(); funktion mit Zwischenstand herausgenommen das es eh nur auf dem PC funktionert

//---------------------------------------------------------------------------------------
// GET ShoutCast Top 20 from www.shoutcast.com
//---------------------------------------------------------------------------------------
 $toptenlist  ="";
 $weburl = !isset($GENRE) ? $weburl1 : $weburl2.urlencode($GENRE);
 $sctoptens=read_web($weburl);               // webseite wird eingelesen

 // links werden gesucht
 $pattern_link = '|(.*)/sbin/shoutcast-playlist.pls\?rn=([0-9]+)|i';         // regulrer Ausdruck um den Link zu finden
 preg_match_all($pattern_link,$sctoptens,$matches_link);
 
 // Name des Links wird gesucht
 $pattern_name = '=(.*)'.$catcher03.'([^>]*)>([^<]+)=i';         // regulrer Ausdruck um den Link titel zu finden
 preg_match_all($pattern_name,$sctoptens,$matches_name);

    for ($i=0; $i< count($matches_link[0]); $i++) {

    $link1 = $shoutcast.$catcher01.$matches_link[2][$i].$catcher02;                           // Link fr PC wird zusammengebastelt
    $link2 = OXYL_WEB.'/plugins/SHOUTcast/SHOUTcast_stream.php?stream='.$matches_link[2][$i].'&playlist_pls=1'.$catcher02;// Link fr Showcenter wird zusammengebastelt
	$name = dotrunc(Clean_Title($matches_name[3][$i]),$maxlen,' ...','r');

    $link = $GLOBALS['showcenter'] ? $link2 : $link1;

       $toptenlist .= '<tr><td>';//$link
	   $toptenlist .= '<table cellspacing=0 cellspacing=0 border=0><tr><td class="text_back" nowrap><a href="'.$link.'"><font size="2">'.$name.'</font></a></td></tr></table></td>';
       $toptenlist .= '<td align="right" nowrap>';
	   $toptenlist .= '<a href="' . $_SERVER["PHP_SELF"] . '?ADDLINE='.$matches_link[2][$i] .'&ADDTIT=' . urlencode($name) .'&GENRE='. $GENRE .'">';
	   $toptenlist .= '<img src="'.getimghref("sc_add.gif","SHOUTcast").'" ONFOCUSSRC="'.getimghref("sc_adds.gif","SHOUTcast").'" border=0></a></td></tr>'. "\n";
    }// end for


//---- TOP TEN Liste wird aufgebaut --------

$main .=  '<tr><td colspan=2>'.gen_transpic(4,$screenwidth). '</td></tr>'. "\n";
$main .=  $toptenlist;
$main .=  '</table>'. "\n";

//---- Pulldownmenues ----------------

$main .=  '<table>'. "\n"; 
$main .=  '<tr><td colspan=2>'.gen_transpic(4,$screenwidth). '</td></tr>'. "\n";
$main .=  '<tr><td nowrap valign="middle">'. "\n";
$main .=  '<form action="' . $_SERVER["PHP_SELF"] . '">'. "\n";

include(OXYL_PLUG.'SHOUTcast/SHOUTcast_genre.php');

$main .=  '&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" name="START" value="' .trans('SHOUTcast','suchen') . '" style="font-size:8pt">'. "\n";
$main .=  '</td><td>'.gen_transpic(25,1). '</td></tr>'. "\n";
$main .=  '<tr><td colspan=2>'.gen_transpic(4,$screenwidth). '</td></tr>'. "\n";
$main .=  '</table></form>'. "\n";

$main .=  '</td></tr></table></td></tr>'. "\n";

//---- Fusszeile --------

 if(!isset($EXTERN)){
//----------------------------------------------------------------------------------------
// Hilfe
//----------------------------------------------------------------------------------------

  $hlp_href='/plugins/'.$pluginname.'/'.$pluginname.'_help';
  $hlp_bref=OXYL_WEB.'/plugins/'.$pluginname.'/'.$pluginname.'.php?START=1&GENRE='.$GENRE;

  $page['nav']['action'][4]['href']   = OXYL_WEB.'/common/help.php?bl='.SpecialCharReplace($hlp_bref).'&hf='.$hlp_href;
  $page['nav']['action'][4]['key']    = IR_TVID_HELP;
  $page['nav']['action'][4]['button'] = IR_ICON_HELP;
  $page['nav']['action'][4]['text']   = trans('','help');

//----------------------------------------------------------------------------------------
// SETUP
//----------------------------------------------------------------------------------------
  $GLOBALS['NO_DIRECT_SETUP_ACCESS'] = TRUE; // damit Setup Button nicht aus design.inc kommt
  if ($GLOBALS['actuserlevel']==0&&!$GLOBALS['showcenter']&&$GLOBALS['VIEW_SETUP'])
  {
    $page['nav']['action'][6]['href']   = 'SHOUTcast.php?SETUP';
    $page['nav']['action'][6]['text']   = trans('','setup');
	$page['nav']['action'][6]['key']    = 'setup';
    $page['nav']['action'][6]['button'] = 'SHOUTcast.gif';
  }

   //ausgabe an design.inc schiocken
   $page['body']['content']['full']=$main;
   gen_full_page($page);
  }
}// ende Ausgabeseite

//           SETUP SECTION
//------------------------------------------------------------------------------------------------------------------------
if (isset($SETUPSAVE)){

  $count = 1;

  $var = '';
  for ($count = 1; $count <= $SETUPSAVE-1; $count++)
  {
    $scnrvarname = 'scnr' . $count;
    $scnrvar = ${$scnrvarname}; 
    $sctitvarname = 'sctitel' . $count;
    $sctitvar = ${$sctitvarname}; 

    if (strlen($scnrvar)>1) 
      $var .= $scnrvar . '|' . $sctitvar . "\r\n"; 
  }// END FOR

  $var != '' ? create_file($conf_file,$var) : @unlink($conf_file);

  unset($SETUPSAVE);
  $SETUP='';
  $msg= 'File saved!';
}

//------------------------------------------------------------------------------------------------------------------------
if (isset($SETUP)){
   if(!isset($msg)) $msg= '';

    gen_header_setup();
    gen_title_setup('',trans('SHOUTcast','setup_title') . ' ' . $version);
    echo '<form action="' . $_SERVER["PHP_SELF"] . '">'. "\n";
    echo '<table><tr><td colspan="2">&nbsp;</td></tr>'. "\n";
    echo '<tr><td align="center">'.trans('SHOUTcast','link').'</td><td align="center">'.trans('SHOUTcast','name').'</td></tr>'. "\n";
    $counter = 1;

    $favorites = array();
    if (file_exists($conf_file))
      $favorites = file($conf_file);

    foreach($favorites as $favorite)
    {
	  if(trim($favorite)!="")
	  {
        $inhalt = explode('|',$favorite);
        echo '<tr><td><input type="text" name="scnr' . $counter . '" value="'. $inhalt[0] .'" size="50"></td>'. "\n";
        echo '<td><input type="text" name="sctitel' . $counter .'" value="'. $inhalt[1] .'" size="50">'. "\n";
	    echo '<a href="javascript:document.forms[0].sctitel' .$counter. '.value=\'\';document.forms[0].scnr' .$counter. '.value=\'\';document.forms[0].submit();"><font size="-1">clear</a></td></tr>'. "\n";
        $counter++;
	  }
    }
    echo '<tr><td><input type="text" name="scnr' . $counter . '" value="" size="50"></td>'. "\n";
    echo '<td><input type="text" name="sctitel' . $counter .'" value="" size="50">'. "\n";
	echo '<a href="javascript:document.forms[0].sctitel' .$counter. '.value=\'\';document.forms[0].scnr' .$counter. '.value=\'\';document.forms[0].submit();"><font size="-1">clear</a></td></tr>'. "\n";
    $counter++;

    echo  '</table><br>'. "\n";
    echo  '<table><tr><td><b>' . $msg .'&nbsp;</td></tr></table>'. "\n";
    echo  '<input type="hidden" name="SETUPSAVE" value="' . $counter . '">'. "\n";
    echo  '<input type="hidden" name="SETUP" value="">'. "\n";
    echo  '<hr color="#000000">'. "\n";
    echo  '&nbsp;&nbsp;<a href="javascript:document.forms[0].submit()">Save</a>'. "\n";
    echo  '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'. "\n";
    echo  '<a href="'.OXYL_WEB.'/plugins/oxyl_setup/oxyl_setup_main.php">Zurck</a>'. "\n";
    echo  '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'. "\n";
    echo  '<a href="' . $_SERVER["PHP_SELF"] . '"><img src="'.getimghref("SHOUTcast.gif").'" width="25" height="25" border=0 align="absmiddle" >SHOUTcast</a>'. "\n";
    echo  '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'. "\n";
    echo  '<a href="http://www.shoutcast.com" target="shoutcast"><u>www.shoutcast.com</a>'. "\n";
gen_end();
}

//-----------------------------------
// FUNCTIONS
//-----------------------------------

//-------------------------------------------------------------------------
// Clean Title 
//
// 2005012 ...................  brause - Clean Title von str_replace auf preg_replace umgestellt
//-------------------------------------------------------------------------
function Clean_Title($tta){

$pattern = array('/D I G I T A L L Y - I M P O R T E D -/', 
                 '/CLUSTER/',
				 '/}/',
				 '/{/',
				 '/_=/',
				 '/=_/',
				 '/=-/',
				 '/-=/',
				 '/::/',
				 '/-=\[::/',
				 '/::\]=-/');
$ttc= trim(preg_replace($pattern,'',strip_tags($tta)));
return($ttc);
}

//---------------------------------------------------------------------------------------
// Title cosmetic
//
// 20050112 ..................... brause - titlechange erstellt aus aufwendiger if schleife
//---------------------------------------------------------------------------------------


function title_change($GENRE){

$GENRE_ARR['TopTen']     = " Top 20 Streams";
$GENRE_ARR['Dance']      = " Dance / House";
$GENRE_ARR['70s']        = " The 70s";
$GENRE_ARR['80s']        = " The 80s";
$GENRE_ARR['Film']       = " Film / Shows";
$GENRE_ARR['Hip%20Hop']  = " Hip-Hop / Rap";
$GENRE_ARR['Reggae']     = " Reggae / Island";
$GENRE_ARR['R%26B/Soul'] = " R&B / Soul";
$GENRE_ARR['Reggae']     = " Reggae / Island";

$GENRE=trim($GENRE);
 
if(isset($GENRE_ARR[$GENRE]))
  $GENRE_NEW = $GENRE_ARR[$GENRE]; 
else 
  $GENRE_NEW= $GENRE;
  
return($GENRE_NEW);
}

// ............so long, and thanks for all the fish.......
//---------------------------------------------E-O-F------------------------------------------------

?>