<?php
//+-------------------------------------------------------------------------------------------
//| plugin: oxyl_video_ofdb.php
//| author : abwasch
//| version : 0.4
//+-------------------------------------------------------------------------------------------
//| sucht auf www.ofdb.de nach Filmtiteln und zeigt Cover und Beschreibung an
//| Bitte Nutzungshinweise auf www.ofdb.de beachten!
//+-------------------------------------------------------------------------------------------
//|  051016 .... abwasch - Plugin erstellt
//|  051107 .... abwasch - speichern/lschen hinzugefgt
//|  051110 .... abwasch - Parsen vereinfacht, Detailanzeige vereinfacht
//|  051209 .... abwasch - Fehler im Playlistmodus behoben, Filmsuche erweitert (thx to Erzherzog Wuzel)
//|  060203 .... abwasch - Rating hinzugefgt
//|  060327 .... abwasch - Weiterleitung wenn nur 1 Suchergebnis, geringfgig Design gendert
//|  060409 .... abwasch - Verzeichnisname als Suche
//|  060410 .... Brause  - CHANGE: Sprachvariablen eingefhrt
//|                      - CHANGE: global no_image Variabel eingefhrt
//|                      - FIX: falsche bergabe bei gen_header_refresh
//+-------------------------------------------------------------------------------------------

  include_once('../../common/design.inc');

//--------------------------------------------------------------------------------------------
// Default Settings
//--------------------------------------------------------------------------------------------

  ini_set("max_execution_time","0");

  if (!isset($FURLING)) $FURLING = 1;

  if (isset($FURL)) {				// Filmname aus Link auslesen
	$furl_arr = explode('&',$FURL);
	foreach($furl_arr as $furli) {
		if (substr($furli,0,9) == 'startwith') $fname = substr($furli,10);
		if (substr($furli,0,3) == 'add') $fname = substr($furli,strrpos($furli,"/")+1);
	}
  }

  $fname = urldecode($fname);
  $fname = strpos($fname, '.') ? substr($fname,0,strpos($fname, '.')) : $fname;          // Dateiname ab ersten Punkt(.) krzen
  $fname = clear_name($fname);            // _ und doppelte Leerzeichen entfernen

  $savepath = OXYL_TEMP.'oxyl_'.$mode.'/ofdb/';
  check_dirs($savepath); 

  if (file_exists($savepath.$fname.'.txt')) {
	unset($msg);
	unset($start);
	unset($startdetail);
  }

  $weburl = 'http://www.ofdb.de';
  $search = '/view.php?page=';
  $backurl = 'le=r&ap='.urlencode($ap).'&st='.$st.'&his='.$his.'&view='.$view.'&mode='.$mode.'&mode_1='.$mode_1.'&sort='.$sort.'&plmod='.$plmod.'&ni=x';

  if (!$fname) {			// Wenn kein Dateiname bergeben wurde erscheint diese Meldung
	$verz = substr($ap,strrpos(change_slashes($ap),'/')+1);
	echo '<table border=0 align=center><tr><td><center><b><font size=-1><br><br><br><br>'.trans('oxyl_file','ofdb_hinweis_1').'<br><br>'
	.trans('','ofdb_hinweis_2').'</b><br><br><br>'.trans('','ofdb_hinweis_3').'<br><br></font>'
	.'<a href="oxyl_video_ofdb.php?'.$backurl.'&fname='.$verz.'&msg=&start=&verz='.$verz.'"><b>'.$verz.'</b></a><br><br>'			// Link mit Verzeichnisname
	.'<font size=-1>'.trans('','ofdb_hinweis_4').'</font></center></td></tr></table>';
	gen_header_refresh(OXYL_WEB.'/plugins/oxyl_file/oxyl_file_main.php?'.$backurl,10);
	gen_end();
	die();
  }
  
//--------------------------------------------------------------------------------------------
// Anzeige whrend gesucht wird
//--------------------------------------------------------------------------------------------

  if (isset($msg)) {
	$msg = '<table border=0 align=center>'
			  .'<tr><td><center><b><font size=-1><br><br><br><br>';
	if (isset($start)) {
		$msg .= trans('oxyl_file','ofdb_hinweis_5').'<br><br><br>'.trans('oxyl_file','ofdb_hinweis_6').'</font><br><br><b>'.$fname;
		gen_header_refresh(OXYL_WEB.'/plugins/oxyl_file/oxyl_video_ofdb.php?'.$backurl.'&fname='.urlencode($fname).'&start=&verz='.$verz.'&fid='.$fid,10);}
	else {
		$msg .=  trans('oxyl_file','ofdb_hinweis_7').'</font>';
		gen_header_refresh(OXYL_WEB.'/plugins/oxyl_file/oxyl_video_ofdb.php?'.$backurl.'&fname='.urlencode($fname).'&name='.urlencode($name).'&startdetail=&verz='.$verz.'&fid='.$fid,10);}
	echo $msg.'</b></center></td></tr></table>';
	gen_end();
	die();
  }

//--------------------------------------------------------------------------------------------
// Cover und Beschreibung Speichern/Lschen
//--------------------------------------------------------------------------------------------

  if (isset($save)) {
	foreach (glob($savepath.$fname.'.*') as $delfile) unlink($delfile);			// Dateien lschen 
	rename($savepath.$fid.'tmp.txt',$savepath.$fname.'.txt');			// Dateien nach Filmname  umbenennen
	rename($savepath.$fid.'tmp.jpg',$savepath.$fname.'.jpg');
	if (strlen($verz) >= 1) {			// info.txt und cover.jpg ins Verzeichnis kopieren wenn Verzeichnisname gewhlt wurde
		copy($savepath.'infotmp.txt',$ap.'/1_info.txt');
		copy($savepath.$fname.'.jpg',$ap.'/1_cover.jpg');
	}
	header('Location: '.OXYL_WEB.'/plugins/oxyl_file/oxyl_file_main.php?'.$backurl);
	die();
  }

//--------------------------------------------------------------------------------------------
// Filmname suchen
//--------------------------------------------------------------------------------------------

  if (isset($start)) {
	$web = read_web($weburl.$search.'suchergebnis&Neu=1&Kat=titel&SText='.urlencode($fname));			// Suche: Dateiname wie geschrieben

	if (!strpos($web, '<b>Titel:</b><br><br>1.')) {				// Suche: alle (grammatikalische) Artikel aus Dateiname entfernen, Umlaute wandeln
		$fname1 = preg_replace(array('@ae|Ae@', '@oe|Oe@', '@ue|Ue@'),array('', '', ''),$fname);          
		$fteile=explode(' ',$fname1);
		foreach ($fteile as $fteil) {
			$fteil = preg_replace('@der|die|das|des|ein|eine|the|-@si','',$fteil);
			$fname2=$fname2." ".$fteil;
		}
		$web = read_web($weburl.$search.'suchergebnis&Neu=1&Kat=titel&SText='.urlencode($fname2));
	}

	if (!strpos($web, '<b>Titel:</b><br><br>1.')) {				// Suche: alle Wrter kleiner 4 Buchstaben aus Dateiname entfernen
		$fteile=explode(' ',$fname1);
		foreach ($fteile as $fteil) {
			if (strlen($fteil)>=4) $fname3=$fname3." ".$fteil;
		}
		$web = read_web($weburl.$search.'suchergebnis&Neu=1&Kat=titel&SText='.urlencode($fname3));
	}

	if (!strpos($web, '<b>Titel:</b><br><br>1.')) {				// Suche: nach lngstem Begriff im Dateinamen

        // Die funktion gibt es eigentlich in functions.inc bzw. strcoll
        // Ja. Aber ich hatte da unter Linux Probleme mit Umlauten. Und da noch eine Unterscheidung einzubauen war mir zu Aufregend ;) 
		function sortieren($a, $b) {
			if (strlen($a) == strlen($b)) return 0;
			return (strlen($a) > strlen($b)) ? -1 : 1;
		}
		// ende

		$fname4 = explode(" ",$fname1);
		usort($fname4, 'sortieren');
		$web = read_web($weburl.$search.'suchergebnis&Neu=1&Kat=titel&SText='.urlencode($fname4[0]));
	}

	preg_match_all("'fid=([0-9]*)\'>(.*?)<.*?\((.*?)\)'si", $web, $treffer, PREG_SET_ORDER);			// Ergebnisse in Array

	$main =  '<table cellpadding=0 cellspacing=0 border=0 width=100%>'			// Seitenaufbau Filmsuche
				.'<tr><td>'.gen_transpic(LAYOUT_BODY_HEIGHT-LAYOUT_NAVI_HEIGHT,1).'</td>'
				.'<td valign=top><br>'.trans('oxyl_file','ofdb_hinweis_8').'<br><br>';

	for($i=0;$treffer[$i][0];$i++)
		$main .= '<a href=oxyl_video_ofdb.php?'.$backurl.'&fname='.urlencode($fname).'&startdetail=&msg=&verz='.$verz
					.'&fid='.$treffer[$i][1].'&name='.urlencode($treffer[$i][2]).'>'.$treffer[$i][2].' / '.$treffer[$i][3].'</a><br>';

	if ($i == 1) {			// wenn nur ein(1) Ergebnis dann sofort nachladen in startdetail
		$startdetail = '';
		$fid = $treffer[0][1];
		$name = $treffer[0][2];
	}

	$treffer[0][0] ? '' : $main .= '<i>- '.trans('oxyl_file','ofdb_hinweis_9').' -</i>';
	$main .= '</td></tr></table>';

	$page['headline'] = $fname;
	$page['nav']['action'][2]['href'] = 'oxyl_file_main.php?'.$backurl;			// C-Button zurck auf file_main
  }

//--------------------------------------------------------------------------------------------
// Details zum Film auslesen
//--------------------------------------------------------------------------------------------

  foreach (glob($savepath.'*tmp.*') as $tmpfile) unlink($tmpfile);			// alte TMP-Dateien lschen

  if (isset($startdetail)) {
	$web = read_web($weburl.$search.'film&fid='.$fid);			// Detaiseite auslesen

	$detail = preg_replace('@<br><a[^>]*?>@si', ', <a>', $web);
	$detail = strip_tags($detail);
	$detail = preg_replace(array('@&#149;@', '@([\r\n])[\s]+@', '@&nbsp;@', '@((Inhalt.*)|(Bewertung.*))@'),'',$detail).',';
	
	preg_match("'Genre\(s\): *(.*?)Originaltitel: *(.*?)Herstellungsland: *(.*?)"			// Filmdetails in Array  // geht's noch??
		."Erscheinungsjahr: *(.*?)Regie: *(.*?)Darsteller: *(.{0,70}),'si", $detail, $detail);			// Darsteller auf 70 Zeichen begrenzen

	preg_match("'&sid=([0-9]*)'si", $web, $sid);			// ID fr Beschreibung
	$inhalt = read_web($weburl.$search.'inhalt&fid='.$fid.'&sid='.$sid[1]);			// Beschreibung zum Film auslesen
	$inhalt = preg_replace('@([\r\n])[\s]+@', '', $inhalt);
	preg_match("'</a></b><br><br> *(.*?)</font>'si" , $inhalt, $inhalt);

	preg_match("'Note:.([0-9.]*).*?Stimmen:.([0-9]*).*?Platz:.([0-9]*)'si" , $web, $rating);			// Rating auslesen

	$detail = array($name, $detail[1], $detail[2], $detail[3], $detail[4], $detail[5], $detail[6], $inhalt[1], trim($rating[1]), trim($rating[2]), trim($rating[3]));
	create_file($savepath.$fid.'tmp.txt',implode("\r\n", $detail));			// Beschreibung zwischenspeichern
	
	if (strlen($verz) >= 1) {
		$info = array($detail[3].' '.$detail[4].' - Regie: '.$detail[5], 'Darsteller: '.$detail[6], '', 'Beschreibung:', $inhalt[1]);
		create_file($savepath.'infotmp.txt',implode("\r\n", $info));			// info.txt bei Verzeichnisauswahl
	}

	if (!strstr($web,'images/film/na.gif'))			// Bild zwischenspeichern
		copy($weburl.'/images/film/'.substr($fid, 0, -3).($fid <= '999' ? '0' : '').'/'.$fid.'.jpg',$savepath.$fid.'tmp.jpg');
  }

//--------------------------------------------------------------------------------------------
// Detailseite erstellen
//--------------------------------------------------------------------------------------------

  if ($detail = file($savepath.$fname.'.txt')) {			// Beschreibung zum Film schon vorhanden?
	$img = $savepath.$fname.'.jpg';

	$page['headline'] = $fname;
	$page['nav']['action'][0]['href'] = 'oxyl_video_ofdb.php?'.$backurl.'&fname='.urlencode($fname).'&save=&verz='.$verz.'&fid=';			// A-Button zum lschen // evtl. wieder einkommentieren
	$page['nav']['action'][0]['key'] = IR_TVID_KEYA;
	$page['nav']['action'][0]['button'] = IR_ICON_KEYA;
	$page['nav']['action'][0]['text'] = trans('oxyl_file','setup_del');
	// ? was soll die Zeile $page['nav']['action'][2]['href'] = 'oxyl_file_main.php?'.$backurl;			// C-Button zurck auf file_main
	// um bei mehreren Suchergebnissen wieder zur Suche zu kommen und nicht nach file_main, siehe 6 Zeilen weiter unten.. is aber auch egal, du bist der Chef ;)
  }

  elseif ($detail = file($savepath.$fid.'tmp.txt')) {			// TMP-File (von $startdetail) vorhanden?
	$img = $savepath.$fid.'tmp.jpg';

//	$page['nav']['action'][2]['href'] = 'oxyl_video_ofdb.php?'.$backurl.'&fname='.urlencode($fname).'&start=&verz='.$verz.'&msg=';			// C-Button zurck auf Filmsuche

	$page['headline'] = $name;
	$page['nav']['action'][1]['href'] = 'oxyl_video_ofdb.php?'.$backurl.'&fname='.urlencode($fname).'&save=&verz='.$verz.'&fid='.$fid;			// B-Button zum speichern
	$page['nav']['action'][1]['key'] = IR_TVID_KEYB;
	$page['nav']['action'][1]['button'] = IR_ICON_KEYB;
	$page['nav']['action'][1]['text'] = trans('oxyl_file','save');
  }

  if ($detail[0]) {			// wenn was da ist: Seitenaufbau Detailseite sonst Filmsuche($start)

	if ($detail[9]) {			// Rating wird in der Titelleiste angezeigt wenn vorhanden

		$page['headline'] = '<table border=0 cellspacing=0 cellpadding=0 width=100%><tr>'
								 .'<td width=100% valign=top align=left rowspan=2><span class="log_in">'.$page['headline'].'</span></td>'
								 .'<td align=left valign=middle nowrap><font size=1>'.trans('oxyl_file','ofdb_rating').': '.$detail[8].'&nbsp;</font></td>'
								 .'<td align=right valign=middle nowrap><img src="/images/blueh_leftend.gif" height=13 width=3>'
								 .'<img src="/images/blueh.gif" height=13 width='.(round(($detail[8]*9))-3).'>'
								 .'<img src="/images/blueh2.gif" height=13 width='.(87-round(($detail[8]*9))).'>'
								 .'<img src="/images/blueh2_rightend.gif" height=13 width=3></td></tr>'
								 .'<tr><td valign=top align=left nowrap><font size=1>'.trans('oxyl_file','ofdb_place').': '.$detail[10].'</font></td>'
								 .'<td valign=top align=right nowrap><font size=1>'.$detail[9].' '.trans('oxyl_file','ofdb_stimmen').'</font></td></tr></table>';
	}

	$main =  '<table border=0 cellspacing=0 cellpadding=0 width=100%>'
				.'<tr><td valign=top rowspan=3>'.gen_transpic(LAYOUT_BODY_HEIGHT-LAYOUT_NAVI_HEIGHT,4).'</td><td><tr>'
				.'<td width=130 valign=top><img src="'.geturl(file_exists($img) ? $img : OXYL_ROOT.$GLOBALS['default_image']).'" width=120 border=0></td>'
				.'<td valign=top><table>'
				.'<tr><td width=120 valign=top>'.$detail[3].'</td><td valign=top>'.$detail[4].'</td></tr>'
				.'<tr><td valign=top>'.trans('oxyl_file','ofdb_orgtitel').':</td><td valign=top>'.$detail[2].'</td></tr>'
				.'<tr><td valign=top>'.trans('oxyl_file','ofdb_genre').':</td><td valign=top>'.$detail[1].'</td></tr>'
				.'<tr><td valign=top>'.trans('oxyl_file','ofdb_regie').':</td><td valign=top>'.$detail[5].'</td></tr>'
				.'<tr><td valign=top>'.trans('oxyl_file','ofdb_artist').':</td><td valign=top>'.$detail[6].'&nbsp;</td></tr>'
				.'</table></td></tr>'
				.'<tr><td valign=top colspan=2>'.$detail[7].'</td></tr>'
				.'</td></tr></table>';
  }

//--------------------------------------------------------------------------------------------
// Seite erzeugen
//--------------------------------------------------------------------------------------------

  $page['body']['typ'] = 'full';
  $page['nav']['back']['image'] = getimghref('oxyl_nav_top.gif');
  $page['nav']['back']['href'] = 'oxyl_file_main.php?'.$backurl;
  $page['nav']['action'][2]['href'] = 'oxyl_file_main.php?'.$backurl;
  $page['nav']['action'][2]['key'] = IR_TVID_KEYC;
  $page['nav']['action'][2]['button'] = IR_ICON_KEYC;
  $page['nav']['action'][2]['text'] = htmlspecialchars(trans('oxyl_file','back'));
  $page['body']['content']['full'] = $main;

gen_full_page($page);

//-------------------------------------------EOF----------------------------------------------
?>