<?php 
//####################################### Oxyl~Box 2.5 #####################################################
//+-------------------------------------------------------------------------------------------
//| include: oxyl_box_update_do.php
//| author : odu
//+-------------------------------------------------------------------------------------------
//| collection of systemparameters
//+-------------------------------------------------------------------------------------------
//| ?      .............. odu      - erstellt
//| 050328 .............. brause   - check_dirs in functions.inc ausgelagert
//|                                  NEW: inkrementales Update
//| 050508 .............. brause   - NEW: Plugins knnen jetzt auch gelscht werden
//| 050614 .............. brause   - NEW: Quick Update und Rollback
//| 050615 .............. brause   - NEW: Unterscheidung Linux und WindowsKern
//| 050826 .............. brause   - CHANGE: Stoweb wird vor dem Updaten beendet
//| 051026 .............. brause   - FIX: Stoweb wurde immer beendet/gestartet auch wenn nicht zu Update anstand
//| 060219 .............. Brause   - CHANGE: oxyl_update_doup constante hinzu
//+-------------------------------------------------------------------------------------------

include_once('../../common/design.inc');

if (! isset($demo))
   ini_set("max_execution_time","0");

gen_header_setup();

gen_title_setup('',trans('oxyl_setup','title_updatedo'));

echo'<table cellpadding="5"><tr><td>';

echo trans('oxyl_setup','updatedo_module').': '.$name.' !!!<br>';  
echo '<br>';  
echo trans('oxyl_setup','updatedo_text1').'<br>';  
echo '<br>';  
echo trans('oxyl_setup','updatedo_text2').'<br>';  
echo '<br>';  
echo'</td></tr></table>';

if (! isset($demo))
{
  $fl = @fopen($GLOBALS['oxyl_update_doup'].'?na='.$name.'&ver='.$ver.'&mod='.$mod.'&ty='.$ty,'r');
  @fclose($fl);

  if($ty=='K')// wenn Kern wegen Unterscheidung Linux/Windows
    $whatis= 'Kern ('.ucfirst($GLOBALS['system']).')';
  else
    $whatis = $name;

  echo '&nbsp;&nbsp;&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_getinfos').' <b>'.$whatis.'</b> ... &nbsp;&nbsp;';

  if($modus=="rollback")
    $GLOBALS['update_remote_adress']=OXYL_TEMP.'rollback';

  if(!$updatefile=@file($GLOBALS['update_remote_adress'].'/versions/'.$name.'.ver'))
  {
     echo '<br><br><font size="+1">'.trans('oxyl_setup','update_text9').'</font><br>';  
     $masterversion = array();
  }
  else// beginnt nur Update wenn updatefile existiert
  {
    echo '<b>'.trans('oxyl_setup','ok').'</b><br>';

    $plug_dat = array(); 
    while(list($key,$var)=each($updatefile))
    {
      $var=trim($var);
	  if ($var!='')
	  {
	    if(substr($var,1,1)=='=')
	    {
          $plug_ver['l'.substr($var,0,1)] = '';
          $plug_ver['r'.substr($var,0,1)] = substr(trim($var),2);
	    }
	    else
	    {
          $rpart = array();
          $rpart = explode('|',trim($var).'|'); 	
          $plug_dat[$rpart[0]]['lversion'] = 0;
		  if(trim($rpart[1])=='')$rpart[1]=$plug_ver['rV'];
            $plug_dat[$rpart[0]]['rversion'] = trim($rpart[1]);
        }
	  }
    }

    if($ty=='K')// wenn Kern wegen Unterscheidung Linux/Windows
      $name='kern';

    if(file_exists(OXYL_ROOT.'versions/'.$name.'.ver')){
      $boxfile = file(OXYL_ROOT.'versions/'.$name.'.ver');
      while(list($key,$var)=each($boxfile))
      {
        $var=trim($var);
	    if ($var!='')
	    {
	      if(substr($var,1,1)=='=')
	        $plug_ver['l'.substr($var,0,1)] = substr(trim($var),2);
	      else
	      {
            $rpart = array();
            $rpart = explode('|',trim($var).'|');
            if(trim($rpart[1])=='')$rpart[1]=$plug_ver['lV'];
              $plug_dat[$rpart[0]]['lversion'] = trim($rpart[1]);
     	    if(!isset($plug_dat[$rpart[0]]['rversion']))
              $plug_dat[$rpart[0]]['rversion'] = '-';
          }
	    }
	  }
    }

    $verfile  = 'V='.$plug_ver['rV'].''."\r\n";
    $verfile .= 'D='.$plug_ver['rD'].''."\r\n";
    $verfile .= 'T='.$plug_ver['rT'].''."\r\n";

    echo '<hr color="#000000">';
    echo '&nbsp;&nbsp;&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_startupdate').' <b>'.$name.'</b> ... <br><br>';
    reset($updatefile);
    $new_ver_dat = array();
    $new_version=$dircheck=0;

    foreach($plug_dat as $key => $value)  
    {
      $key2 = $key;
      if (get_ext($key2)=='ppp')
        $key2=del_ext($key2).'.php';
      //falls stoweb upgedatet wird 
	  if(basename($key)==$GLOBALS['stoWeb_exe'] && $GLOBALS['system']=='windows' &&
	    (( $value['lversion'] <> $value['rversion']&& $GLOBALS['update_write_newer_files'])
		||($value['lversion'] <  $value['rversion']&&!$GLOBALS['update_write_newer_files'])))
	  {
	    echo '&nbsp;&nbsp;&nbsp;&nbsp;Stop '.del_ext($GLOBALS['stoWeb_exe']).'...<br>';
		flush();
		$stowebexec = 'net stop '.del_ext($GLOBALS['stoWeb_exe']);
        $stopstoweb = `$stowebexec`;
		$fp = @fsockopen ('localhost',GetStreamPort($GLOBALS['port']), $errno, $errstr, 15);
		@fputs($fp, "TERMINATE\n\n");
		@fclose($fp);
	  }
      if($GLOBALS['update_rollback']&&$modus!="rollback"&&$plug_ver['lV']!='')
	  {
	    check_dirs(OXYL_TEMP.'rollback'.dirname($key)); //da check_dirs verwendet wir reicht dirname, sonst dir_name besser
        @copy(CHANGE_SLASHES(OXYL_ROOT.$key2),OXYL_TEMP.'rollback'.$key);
        $verfile2.= $key.'|'.$value['lversion'].''."\r\n";
	  }
      if($value['rversion']=='-')
	  {
	    if($GLOBALS['update_delete_old_files']&&$ty!='K')
	    {
	      echo '&nbsp;&nbsp;&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_getfile').' <b>'.basename($key2).'</b>&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_localver').': <b>v'.$value['lversion'].'</b>&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_noexist').' --> <b>'.trans('oxyl_setup','del_do').' '.trans('oxyl_setup','updatedo_localver').' '.basename($key2).'</b><br>';
	      @unlink (CHANGE_SLASHES(OXYL_ROOT.$key2));
	    }
	  }
      elseif($modus=="quickupdate"&& 
	      (( $value['lversion']==$value['rversion']&& $GLOBALS['update_write_newer_files'])
		  ||($value['lversion']>=$value['rversion']&&!$GLOBALS['update_write_newer_files'])))
	    echo '&nbsp;&nbsp;&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_getfile').' <b>'.basename($key2).'</b>&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_localver').': <b>v'.$value['lversion'].'</b>&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_newver').': <b>v'.$value['rversion'].'</b> --> <b>'.trans('oxyl_setup','updatedo_uptodate').'</b><br>';
      else
      {
	    if($modus=="quickupdate")
	      echo '&nbsp;&nbsp;&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_getfile').' <b>'.basename($key2).'</b>&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_localver').': <b>v'.$value['lversion'].'</b>&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_newver').': <b>v'.$value['rversion'].'</b> --> <b>'.trans('oxyl_setup','update').'</b>';
        else
	      echo '&nbsp;&nbsp;&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_getfile').' <b>'.basename($key2).'</b> ... ';
        if($fh=@fopen($GLOBALS['update_remote_adress'].$key,'rb'))
	    {
           $newfile = '';
           $fin=false;
	       while (! $fin)
           {      
             $buffer = fread($fh,1024);
             echo ' .';      
             flush();
             if (strlen($buffer)>0)
               $newfile .= $buffer;
             else
               $fin=true;
           }
           fclose($fh);
           echo ' '.trans('oxyl_setup','updatedo_savelocal').' ... ';
		   check_dirs(dirname(OXYL_TEMP.'update'.$key2));
           if(!create_file(CHANGE_SLASHES(OXYL_TEMP.'update'.$key2),$newfile))
		   {
		     echo '<b>'.trans('oxyl_setup','updatedo_notcreate').'</b><br>';
		     $download_niO = 1;
		   }
		   else
             echo '<b>'.trans('oxyl_setup','ok').'</b><br>';
	    }
	    else
		{
	      echo '&nbsp;<b>'.trans('oxyl_setup','updatedo_notfound').'</b><br>';
		  $value['rversion']=0;
		  $download_niO = 1;
		}
	  }
	  if($value['rversion']!='-')
	    $verfile .= $key.'|'.$value['rversion'].''."\r\n";
    }

    echo '<hr color="#000000">';

    if($GLOBALS['update_rollback']&&$modus!="rollback"&&$plug_ver['lV']!='')
    {
      check_dirs(OXYL_TEMP.'rollback/versions');
      $verfile1  = 'V='.$plug_ver['lV'].''."\r\n";
      $verfile1 .= 'D='.$plug_ver['lD'].''."\r\n";
      $verfile1 .= 'T='.$plug_ver['lT'].''."\r\n";
      create_file(OXYL_TEMP.'rollback/versions/'.$name.'.ver',$verfile1.$verfile2);
    }

    if(!isset($download_niO))// wenn kein einziger Fehler beim Update aufgetaucht ist
	{
      echo '&nbsp;&nbsp;&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_updateversion').' <b>'.$name.'</b> ... ';

      echo trans('oxyl_setup','updatedo_saveversionname').' ... ';

	  foreach($plug_dat as $key => $value){
        if (get_ext($key)=='ppp')
          $key=del_ext($key).'.php';
	    check_dirs(dirname(OXYL_ROOT.$key));
        @copy(OXYL_TEMP.'update'.$key,OXYL_ROOT.$key);
	    if(!stristr($key,del_ext($GLOBALS['stoWeb_exe'])))
		  @unlink(OXYL_TEMP.'update'.$key);
	    if(basename($key)==$GLOBALS['stoWeb_exe'] && $GLOBALS['system']=='windows' &&
	    (( $value['lversion'] <> $value['rversion']&& $GLOBALS['update_write_newer_files'])
		||($value['lversion'] <  $value['rversion']&&!$GLOBALS['update_write_newer_files'])))
	    {
          echo '&nbsp;&nbsp;&nbsp;&nbsp;Start '.del_ext($GLOBALS['stoWeb_exe']).'...&nbsp;&nbsp;';
		  flush();
		  $stowebexec = 'net start '.del_ext($GLOBALS['stoWeb_exe']);
          if(!`$stowebexec`)
		    $page['body']['javascript'] = '<script>alert("'.trans('oxyl_setup','update_stowebstart').'");</script>';
	    }
	  }
	  check_dirs(OXYL_ROOT.'versions');
      create_file(OXYL_ROOT.'versions/'.$name.'.ver',$verfile);

      echo '<b>'.trans('oxyl_setup','ok').'</b><br>';

      echo '&nbsp;&nbsp;&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_updatedb').' ... ';

      $var = '';
      foreach(getfiles(OXYL_ROOT.'versions/','ver',true) as $ver)
      {
        $info = array();
        $name = del_ext($ver);
        $info = readversion($name,3);
        $var .= $info['typ'].'|'.$name.'|'.$info['version'].'|'.$info['datum'].''."\r\n";
      }
      create_file(OXYL_ROOT.'versions/oxyl_versions.dat',$var);

      echo '<b>'.trans('oxyl_setup','ok').'</b><br>';
	}
	else
	  echo '&nbsp;&nbsp;&nbsp;&nbsp;'.trans('oxyl_setup','updatedo_noupdated').' ... ';
  }// ENDE Update nur beginnen wenn RemoteFile existiert
}
else
  echo trans('oxyl_setup','updatedo_nodemo');
echo '<hr color="#000000">';
echo '<a href="oxyl_box_update.php">&nbsp;... '.trans('oxyl_setup','back').'</a><br>';

gen_end($page);
?>

